/*
OuDiaSecond Copyright (C) 2017 diagram_mania

̃vÓAtake-okm쐬OuDia\tgEFAłB
̃vOpɂẮAtake-okmLڂ̉Lɏ܂B
*/
/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CdPrintPageProp.cpp
// ****************************************************************
*/
#include "stdafx.h"

#include "CdPrintPageProp.h"
#include "str/CdConnectedString2.h"
#include "str/strToInt.h"
using namespace OuLib ;
using namespace std ;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

namespace Print{
	using namespace OuLib::Str;
// ****************************************************************
//	CdPrintPageProp
// ****************************************************************
	// ********************************
	//@name CdPrintPageProp-
	// ********************************
const TCHAR nameLeft[] = _T("MarginLeftMm") ;
const TCHAR nameTop[] = _T("MarginTopMm") ;
const TCHAR nameRight[] = _T("MarginRightMm") ;
const TCHAR nameBottom[] = _T("MarginBottomMm") ;
const TCHAR nameHeader[] = _T("PrintHeader");
const TCHAR nameFooter[] = _T("PrintFooter");

tstring CdPrintPageProp::encode() 
{
	CdConnectedString2	aConnectedString ;
	//Left
	{
		aConnectedString.setItem( nameLeft , stringOf( m_dMarginLeftMm ) ) ;
	}	
	//Top
	{
		aConnectedString.setItem( nameTop , stringOf( m_dMarginTopMm ) ) ;
	}	
	//Right
	{
		aConnectedString.setItem( nameRight , stringOf( m_dMarginRightMm ) ) ;
	}	
	//Bottom
	{
		aConnectedString.setItem( nameBottom , stringOf( m_dMarginBottomMm ) ) ;
	}
	//Header
	{
		aConnectedString.setItem(nameHeader, stringOf(m_iPrintHeader));
	}
	//Footer
	{
		aConnectedString.setItem(nameFooter, stringOf(m_iPrintFooter));
	}
	return ( aConnectedString ) ;
}

int CdPrintPageProp::decode( const tstring& value ) 
{
	int iRv = 0 ;
	
	CdConnectedString2	aConnectedString( value ) ;
	clear() ;

	//Left
	{
		m_dMarginLeftMm = doubleOf( aConnectedString.getValue( nameLeft ) ) ;
	}	
	//Top
	{
		m_dMarginTopMm = doubleOf( aConnectedString.getValue( nameTop ) ) ;
	}	
	//Right
	{
		m_dMarginRightMm = doubleOf( aConnectedString.getValue( nameRight ) ) ;
	}	
	//Bottom
	{
		m_dMarginBottomMm = doubleOf( aConnectedString.getValue( nameBottom ) ) ;
	}
	//Header
	{
		if (aConnectedString.getValue(nameHeader) == _T("0"))
		{
			m_iPrintHeader = 0;
		}
		else
		{
			m_iPrintHeader = 1;
		}
	}
	//Footer
	{
		if (aConnectedString.getValue(nameFooter) == _T("0"))
		{
			m_iPrintFooter = 0;
		}
		else
		{
			m_iPrintFooter = 1;
		}
		//m_iPrintFooter = intOf(aConnectedString.getValue(nameFooter));
	}
	
	return ( iRv ) ;
}

} //namespace Print
