/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
// CDlgDiagramViewProp.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "str/strToInt.h"
#include "str/CStrCharSizeMb.h"
#include "Str\strToWstr.h"

#include "..\diagramedit.h"
#include "..\entDed\entDed.h"
#include "DcdCd/Pos/CLineFunc.h"
#include "CDlgDiagramViewProp.h"

using namespace std ;


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

namespace ViewDiagram{

/** ̏ێ܂B */
const CdDedJikoku::CConv	g_CdDedJikokuConv(
	false ,		//	NoColon 
	CdDedJikoku::CConv::EHour_Zero ,	//  00  09 ̏ꍇA10̈ʂ "0" Ƃ܂
	CdDedJikoku::CConv::ESecond_NoSecond 	// bɏo͂܂B 
	) ;

/** Ԃ̏ێ܂B */
const CdDedJikan::CConv	g_CdDedJikanConv(
	true ,		//	NoSecond
	false ,		//	PlusDisplay 
	false ) ;	//	PlusToSpace 

/////////////////////////////////////////////////////////////////////////////
// CDlgDiagramViewProp _CAO


CDlgDiagramViewProp::CDlgDiagramViewProp(
		const CdDcdZoneXy&	zonexyCentDedDiaZone_Dgr ,
		BOOL bEnableYokojiku ,
		BOOL bEnableTatejiku ,
		const CdDcdZoneXy&	zonexyCWndDiagramZone_Dgr ,
		int idxVlineMode ,
		CWnd* pParent )
	: CDialog(CDlgDiagramViewProp::IDD, pParent)
	, m_zonexyCentDedDiaZone_Dgr( zonexyCentDedDiaZone_Dgr )
	, m_bEnableYokojiku(bEnableYokojiku)
	, m_bEnableTatejiku(bEnableTatejiku)
	, m_zonexyCWndDiagramZone_Dgr( zonexyCWndDiagramZone_Dgr )
	, m_idxVlineMode( idxVlineMode ) 
{
	//{{AFX_DATA_INIT(CDlgDiagramViewProp)
	m_strEDIT_YokojikuPos = _T("");
	m_strEDIT_YokojikuSize = _T("");
	m_iCOMBO_Jikanmemori = -1;
	m_iEDIT_TatejikuPos = 0;
	m_iEDIT_TatejikuSize = 0;
	//}}AFX_DATA_INIT

	if ( m_bEnableYokojiku )
	{
		m_strEDIT_YokojikuPos = g_CdDedJikokuConv.encode( CdDedJikoku( m_zonexyCWndDiagramZone_Dgr.getX().getPos() ) ).c_str() ;
		m_strEDIT_YokojikuSize = g_CdDedJikanConv.encode( CdDedJikan( m_zonexyCWndDiagramZone_Dgr.getX().getSize() ) ).c_str() ;
	}
	if ( m_bEnableTatejiku )
	{
		m_iEDIT_TatejikuPos = ( m_zonexyCWndDiagramZone_Dgr.getY().getPos() - 
			m_zonexyCentDedDiaZone_Dgr.getY().getPos() ) * 
			100 / m_zonexyCentDedDiaZone_Dgr.getY().getSize() ;
		m_iEDIT_TatejikuSize = ( m_zonexyCWndDiagramZone_Dgr.getY().getSize() * 
			100 / m_zonexyCentDedDiaZone_Dgr.getY().getSize() );
	}
	m_iCOMBO_Jikanmemori = m_idxVlineMode ;


}


void CDlgDiagramViewProp::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgDiagramViewProp)
	DDX_Text(pDX, IDC_EDIT_YokojikuPos, m_strEDIT_YokojikuPos);
	DDX_Text(pDX, IDC_EDIT_YokojikuSize, m_strEDIT_YokojikuSize);
	DDX_CBIndex(pDX, IDC_COMBO_Jikanmemori, m_iCOMBO_Jikanmemori);
	DDX_Text(pDX, IDC_EDIT_TatejikuPos, m_iEDIT_TatejikuPos);
	DDX_Text(pDX, IDC_EDIT_TatejikuSize, m_iEDIT_TatejikuSize);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgDiagramViewProp, CDialog)
	//{{AFX_MSG_MAP(CDlgDiagramViewProp)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgDiagramViewProp bZ[W nh

void CDlgDiagramViewProp::OnOK() 
{
	int iRv = 0 ;
	
	if ( !UpdateData() )
	{
		return ;
	}
	
	if ( m_bEnableYokojiku )	//̃GfBbg{bNXL
	{
		CdDedJikoku	jikokuYokojikuPos ;
		CdDedJikan	jikanYokojikuSize ;


		if ( iRv >= 0 )
		{
			if ( jikokuYokojikuPos.decode( 
				tstringOf(CStrCharSizeMb::strToSingleByte( stringOf((LPCTSTR)m_strEDIT_YokojikuPos) ) )
				) < 0 )
			{
				iRv = -1 ;	//	\͈͂̋N_AƂĉ߂ł܂B
			}
		}
		if ( iRv >= 0 )
		{
			if ( jikanYokojikuSize.decode( 
				tstringOf(CStrCharSizeMb::strToSingleByte(stringOf((LPCTSTR)m_strEDIT_YokojikuSize)) )
				) < 0 )
			{
				iRv = -2 ;	//	\͈͂AԂƂĉ߂ł܂B
			}
			else if ( jikanYokojikuSize.getTotalSeconds() > 24*60*60 )
			{
				iRv = -3 ;	//	\͈͂傫܂B24Ԉȉ̒lݒ肵ĂB
			}
			else if ( jikanYokojikuSize.getTotalSeconds() <= 0 )
			{
				iRv = -6 ;	//	\͈͂܂B1ȏ̒lݒ肵ĂB
			}
		}
		if ( iRv >= 0 )
		{
			CdDcdZone	zoneX( 
				jikokuYokojikuPos.getTotalSeconds() ,
				jikanYokojikuSize.getTotalSeconds() ) ;
			if ( zoneX.getPos() < m_zonexyCentDedDiaZone_Dgr.getX().getPos() )
			{
				//	\͈͂̋N_A
				//	w_COGeBeBWnx̋N_菬ȂA
				//	24ԂZ
				zoneX.setPos( zoneX.getPos() + 24*60*60 ) ;
			}
			if ( m_zonexyCentDedDiaZone_Dgr.getX().getEndPos() < zoneX.getEndPos() )
			{
				iRv = -4 ;	//	\͈͂A_CŐN_zĂ܂B
							//	%s zȂ悤ɐݒ肵ĂB
			}
			else
			{
				m_zonexyCWndDiagramZone_Dgr.setX( zoneX ) ;
			}
			
		}	
		
	}
	if ( m_bEnableTatejiku )	//	c̃GfBbg{bNXL
	{
		if ( iRv >= 0 )
		{
			if ( !( 0 <= m_iEDIT_TatejikuPos && m_iEDIT_TatejikuPos <= 100 ) )
			{
				iRv = -8 ;	//	c\͈͂̏[͈͓ɂ܂\n
							//	0%ȏ100%ȉ̒lw肵ĂB
			}
			else if ( !( 1 <= m_iEDIT_TatejikuSize && m_iEDIT_TatejikuSize <= 1000 ) )
			{
				iRv = -9 ;	//	c\͈͈͓͂̕ɂ܂\n
							//	1%ȏ1000%ȉ̒lw肵ĂB
			}
		}
		if ( iRv >= 0 )
		{
			CdDcdZone	zoneY( m_iEDIT_TatejikuPos * m_zonexyCentDedDiaZone_Dgr.getY().getSize() / 100 +
				m_zonexyCentDedDiaZone_Dgr.getY().getPos() ,
				m_iEDIT_TatejikuSize * m_zonexyCentDedDiaZone_Dgr.getY().getSize() / 100 ) ;
			
			m_zonexyCWndDiagramZone_Dgr.setY( zoneY ) ;
		}
	}
	if ( iRv >= 0 )
	{
		m_idxVlineMode = m_iCOMBO_Jikanmemori ;
		if ( m_idxVlineMode < 0 ){
			m_idxVlineMode = 0 ;
		}
	}
		//iRv = 
		//		-1 ;	//	\͈͂̋N_AƂĉ߂ł܂B
		//		-2 ;	//	\͈͂AԂƂĉ߂ł܂B
		//		-3 ;	//	\͈͂傫܂B24Ԉȉ̒lݒ肵ĂB
		//		-4 ;	//	\͈͂A_CŐN_zĂ܂B
		//				//	%s zȂ悤ɐݒ肵ĂB
		//		-6 ;	//	\͈͂܂B1ȏ̒lݒ肵ĂB
		//		-8 ;	//	c\͈͂̏[͈͓ɂ܂
		//				//	0%ȏ100%ȉ̒lw肵ĂB
		//		-9 ;	//	c\͈͈͓͂̕ɂ܂
		//				//	1%ȏ1000%ȉ̒lw肵ĂB
	if ( iRv >= 0 )
	{
		CDialog::OnOK();
	}
	else
	{
		CString	strError ;
		switch( iRv ){
		 case -1 :	
			{
				GetDlgItem(IDC_ERR_1)->GetWindowText( strError ) ;
			}
			break ;
		 case -2 :	
			{
				GetDlgItem(IDC_ERR_2)->GetWindowText( strError ) ;
			}
			break ;
		 case -3 :	
			{
				GetDlgItem(IDC_ERR_3)->GetWindowText( strError ) ;
			}
			break ;
		 case -4 :	
			{
				tstring	strJikoku = g_CdDedJikokuConv.encode( CdDedJikoku( m_zonexyCentDedDiaZone_Dgr.getX().getPos() ) ) ;
				CString	strFmt ;
				GetDlgItem(IDC_ERR_4)->GetWindowText( strFmt ) ;
				strError.Format( strFmt , strJikoku.c_str() ) ;
			}
			break ;
		 case -6 :	
			{
				GetDlgItem(IDC_ERR_6)->GetWindowText( strError ) ;
			}
			break ;
		 case -8 :	
			{
				GetDlgItem(IDC_ERR_8)->GetWindowText( strError ) ;
			}
			break ;
		 case -9 :	
			{
				GetDlgItem(IDC_ERR_9)->GetWindowText( strError ) ;
			}
			break ;
		 default :	
			{
				CString	strFmt ;
				GetDlgItem(IDC_ERR_X)->GetWindowText( strFmt ) ;
				strError.Format( strFmt , iRv ) ;
			}
			break ;
		}
		MessageBox( strError , NULL , MB_ICONEXCLAMATION | MB_OK ) ;
	}

}

BOOL CDlgDiagramViewProp::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	if( !m_bEnableYokojiku )
	{
		GetDlgItem(IDC_EDIT_YokojikuPos)->EnableWindow(FALSE) ;
		GetDlgItem(IDC_EDIT_YokojikuSize)->EnableWindow(FALSE) ;
	}
	if( !m_bEnableTatejiku )
	{
		GetDlgItem(IDC_EDIT_TatejikuPos)->EnableWindow(FALSE) ;
		GetDlgItem(IDC_EDIT_TatejikuSize)->EnableWindow(FALSE) ;
	}
	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}
} //namespace ViewDiagram
