/*
OuDiaSecond Copyright (C) 2017 diagram_mania

̃vÓAtake-okm쐬OuDia\tgEFAłB
̃vOpɂẮAtake-okmLڂ̉Lɏ܂B
*/
/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CWndDcdGridEkiTrack2.cpp
//	$Id: CWndDcdGridEkiTrack2.cpp  $
// ****************************************************************
*/
/** @file */
#include "stdafx.h"

#include "logmsg\LogMsg.h"
#include "NsOu\OuNew.h"
#include "NsOu\dynamic_castOu.h"
#include "str\strtoint.h"
#include "DcDraw\CDcdTargetGetDC.h"
#include "DcDraw\CConverter_WinGdi.h"

#include "..\resource.h"
#include "..\entDed\CentDedRosen.h"
#include "..\DiagramEdit.h"
#include "..\CRfEditCmdHolder.h"
#include "..\DedRosenFileData\EditCmd\EditCmd.h"
#include "CDlgEkiTrack2Prop.h"
#include "CWndDcdGridEkiTrack2.h"

// ****************************************************************
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
// ****************************************************************

namespace ViewEkiTrack2 {
using namespace std ;

// --------------------------------
///@name	Xԍ
// --------------------------------
///@{
/**
XԍFԐԍ
*/
const int XCOLUMNNNO_EKITRACK2NO = 0 ;
/**
XԍFԐ
*/
const int XCOLUMNNNO_EKITRACK2 = 1 ;
/**
XԍFԐ
*/
const int XCOLUMNNNO_ETRYAKUSYOU = 2 ;
/**
XԍF{
*/
const int XCOLUMNNNO_MAINTRACK = 3 ;
/**
XԍFX
*/
const int XCOLUMNNCOUNT = 4 ;
///@}


// --------------------------------
///@name	Yԍ
// --------------------------------
///@{
/**
YԍFwb_
*/
const int YCOLUMNNNO_HEADER = 0 ;
/**
YԍFԐ0Ԗ
*/
const int YCOLUMNNNO_EKITRACK2_0 = 1 ;
/**
YԍFԐ̗̌
*/
const int YCOLUMNNCOUNT_BLANK = 1 ;
///@}

/**
@return
	Ԏʃr[̃tHg̑Ԃ܂B
*/
static CdFontProp createFontProp()
{
	return ( CConverter_WinGdi().CdFontPropOf( DEFAULT_GUI_FONT ) ) ;
}

	// --------------------------------
	//@name	֐
	// --------------------------------
CdEkiTrack2XColSpecCont
CWndDcdGridEkiTrack2::createXColSpecCont()
{
	const CentDedEkiCont* pCentDedEkiCont = getCDiagramEditDoc()->getCDedRosenFileData()
		->getCentDedRosen()->getCentDedEkiCont();
	int iEkiIndex = pCentDedEkiCont->EkiIndexOfEkiID(GetDocument()->getEkiID());
	//int iEkiIndex = GetDocument()->getEkiIndex();
	CdEkiTrack2XColSpecCont aSpecCont(
		pCentDedEkiCont->getMuPtr()->get(iEkiIndex)->getEkiTrack2Cont());
	//CdEkiTrack2XColSpecCont aSpecCont(
	//	getCDiagramEditDoc()->getCDedRosenFileData()->getCentDedRosen()
	//		->getCentDedEkiCont()->getMuPtr()->get(iEkiIndex)->getEkiTrack2Cont()); 
	return aSpecCont ;
}

CdEkiTrack2YColSpecCont
CWndDcdGridEkiTrack2::createYColSpecCont()
{
	const CentDedEkiCont* pCentDedEkiCont = getCDiagramEditDoc()->getCDedRosenFileData()
		->getCentDedRosen()->getCentDedEkiCont();
	int iEkiIndex = pCentDedEkiCont->EkiIndexOfEkiID(GetDocument()->getEkiID());
	//int iEkiIndex = GetDocument()->getEkiIndex();
	CdEkiTrack2YColSpecCont aSpecCont(
		pCentDedEkiCont->getMuPtr()->get(iEkiIndex)->getEkiTrack2Cont());
	return aSpecCont ;
}

CdEkiTrack2XColSpec
CWndDcdGridEkiTrack2::getXColSpecOfFocus()
{
	const CentDedEkiCont* pCentDedEkiCont = getCDiagramEditDoc()->getCDedRosenFileData()
		->getCentDedRosen()->getCentDedEkiCont();
	int iEkiIndex = pCentDedEkiCont->EkiIndexOfEkiID(GetDocument()->getEkiID());
	//int iEkiIndex = GetDocument()->getEkiIndex();
	CdEkiTrack2XColSpec aSpec ;
	CdDcdPosXy aPos = getCFocus()->getFocusCellColumnNumber() ;
	if ( aPos != getCFocus()->ColumnNumberPosXy_NULL() )
	{
		CdEkiTrack2XColSpecCont aSpecCont(
			pCentDedEkiCont->getMuPtr()->get(iEkiIndex)->getEkiTrack2Cont());
		aSpec = aSpecCont.ColumnNumberToSpec( aPos.getX() ) ;
	}
	return aSpec ;
}

CdEkiTrack2YColSpec
CWndDcdGridEkiTrack2::getYColSpecOfFocus()
{
	const CentDedEkiCont* pCentDedEkiCont = getCDiagramEditDoc()->getCDedRosenFileData()
		->getCentDedRosen()->getCentDedEkiCont();
	int iEkiIndex = pCentDedEkiCont->EkiIndexOfEkiID(GetDocument()->getEkiID());
	//int iEkiIndex = GetDocument()->getEkiIndex();
	CdEkiTrack2YColSpec aSpec ;
	CdDcdPosXy aPos = getCFocus()->getFocusCellColumnNumber() ;
	if ( aPos != getCFocus()->ColumnNumberPosXy_NULL() )
	{
		CdEkiTrack2YColSpecCont aSpecCont(
			pCentDedEkiCont->getMuPtr()->get(iEkiIndex)->getEkiTrack2Cont());
		aSpec = aSpecCont.ColumnNumberToSpec( aPos.getY() ) ;
	}
	return aSpec ;
}
	
bool CWndDcdGridEkiTrack2::createCmd(
	ECreateCmd eCreateCmd , 
	Ou<DedRosenFileData::EditCmd::CRfEditCmd_EkiTrack2>* ppCmd )
{
	bool bRv = false ;
	Ou<DedRosenFileData::EditCmd::CRfEditCmd_EkiTrack2> pCmd ;

	CdEkiTrack2YColSpecCont aCdYColSpecCont = createYColSpecCont() ;
	CdEkiTrack2YColSpec  aCdYColSpecOfFocus = getYColSpecOfFocus() ;

	const CentDedEkiCont* pCentDedEkiCont = getCDiagramEditDoc()->getCDedRosenFileData()
		->getCentDedRosen()->getCentDedEkiCont();
	int iEkiIndex = pCentDedEkiCont->EkiIndexOfEkiID(GetDocument()->getEkiID());
	// ********************************
	//	ECreateCmd_NewItem 
	//@r[̃tH[JXʒuɐVKACe}邽߂̃R}h𐶐܂B
	// ********************************
	if ( eCreateCmd == ECreateCmd_NewItem )
	{
		//r[ŕIOFF
		if ( getCSelect()->getSelectedCellCount() == 0 )
		{


			//	VKACéAIuWFNg
			CentDedEkiTrack2 aNewEkiTrack2;

			//r[ŕIOFFEtH[JXZACeɂꍇ: 
			//- m_iDiaIndex = tH[JXZ̃ACeIndexAm_iIndexSize = 0
			//- m_CentDedEkiCont = VK쐬̃ACe̊l
			//- CaMuiSelect = YACeIB
			if ( aCdYColSpecOfFocus.getColumnType()
				== CdEkiTrack2YColSpec::ColumnType_EkiTrack2)
			{
				bRv = true ;
				if ( ppCmd != NULL )
				{
					pCmd = OuNew<CRfEditCmd_EkiTrack2>(
						new CRfEditCmd_EkiTrack2(
							*getCDiagramEditDoc()->getCDedRosenFileData() , 
							//GetDocument()->getEkiIndex(),
							iEkiIndex,
							aCdYColSpecOfFocus.getEkiTrack2Index() ,
							0 ) ) ;
					pCmd->getCaMuiSelect()->insert( aNewEkiTrack2, INT_MAX ) ;
					pCmd->getCaMuiSelect()->setSelectAll( true ) ;
				}
			}

			 //@r[ŕIOFFEtH[JXZVKACeʒuɂꍇ:
			 //- m_iDiaIndex = ACeIndex+1Am_iIndexSize = 0
			 //- m_CentDedEkiCont = VK쐬̃ACe̊l
			 //- CaMuiSelect = YACeIB
			if ( aCdYColSpecOfFocus.getColumnType() 
				== CdEkiTrack2YColSpec::ColumnType_NewEkiTrack2)
			{
				bRv = true ;
				if ( ppCmd != NULL )
				{
					pCmd = OuNew<CRfEditCmd_EkiTrack2>(
						new CRfEditCmd_EkiTrack2(
							*getCDiagramEditDoc()->getCDedRosenFileData() ,
							//GetDocument()->getEkiIndex(),
							iEkiIndex,
							aCdYColSpecOfFocus.getEkiTrack2Index() ,
							0 ) ) ;
					pCmd->getCaMuiSelect()->insert( aNewEkiTrack2, INT_MAX ) ;
					pCmd->getCaMuiSelect()->setSelectAll( true ) ;
				}
			}
		}
		 //@r[ŕION:
		 //- IOFF̏ꍇƓ
	}
	// ********************************
	//	ECreateCmd_Focus
	//@tH[JXZ̃ACe1ΏۂƂR}h𐶐܂B
	// ********************************
	if ( eCreateCmd == ECreateCmd_Focus )
	{
		//r[ŕIOFF
		if ( getCSelect()->getSelectedCellCount() == 0 )
		{

			//	r[ŕIOFFEtH[JXZACeɂꍇ: 
			//
			//- m_iDiaIndex = tH[JXZ̃ACeIndexAm_iIndexSize = 1
			//- m_CentDedRessyaCont = tH[JXZ̃ACe1̃Rs[
			//- m_CaMuiSelect = tH[JXZ̃ACeIB
			if ( aCdYColSpecOfFocus.getColumnType() 
				== CdEkiTrack2YColSpec::ColumnType_EkiTrack2)
			{
				bRv = true ;
				if ( ppCmd != NULL )
				{
					pCmd = OuNew<CRfEditCmd_EkiTrack2>(
						new CRfEditCmd_EkiTrack2(
							*getCDiagramEditDoc()->getCDedRosenFileData() ,
							//GetDocument()->getEkiIndex(),
							iEkiIndex,
							aCdYColSpecOfFocus.getEkiTrack2Index() ,
							1 ) ) ;
					pCmd->getCaMuiSelect()->setSelectAll( true ) ;
				}
			}

			//	r[ŕIOFFEtH[JXZVKACeʒuɂꍇ: 
			//- NULLԂ܂B
		}
		//	r[ŕION
		//- IOFF̏ꍇƓ

	}
	// ********************************
	//	ECreateCmd_Select
	//@̒P܂͕IĂACeΏۂƂ
	//	R}h𐶐܂B
	// ********************************
	if ( eCreateCmd == ECreateCmd_Select )
	{
		//	r[ŕIOFFEtH[JXZACeɂꍇ: 
		//- m_iDiaIndex = tH[JXZ̃ACeIndexAm_iIndexSize = 1
		//- m_CentDedRessyaCont = tH[JXẐACe1̃Rs[
		//- CaMuiSelect = YԂIB
		if ( getCSelect()->getSelectedCellCount() == 0 
			&& aCdYColSpecOfFocus.getColumnType() 
				== CdEkiTrack2YColSpec::ColumnType_EkiTrack2)
		{
			bRv = true ;
			if ( ppCmd != NULL )
			{
				pCmd = OuNew<CRfEditCmd_EkiTrack2>(
					new CRfEditCmd_EkiTrack2(
						*getCDiagramEditDoc()->getCDedRosenFileData() ,
						//GetDocument()->getEkiIndex(),
						iEkiIndex,
						aCdYColSpecOfFocus.getEkiTrack2Index() ,
						1 ) ) ;
				pCmd->getCaMuiSelect()->setSelectAll( true ) ;
			}
		}

		//	r[ŕIOFFEtH[JXZVKACeʒuɂꍇ: 
		//- NULLԂ܂B

		//	r[ŕION
		//
		//- m_iDiaIndex = IĂACe̐擪index
		//- m_iIndexSize = IĂACe̖index-擪index+1
		//- m_CentDedRessyaCont = IĂACe̐擪index
		//	index܂ł̃ACẽRs[
		//- CaMuiSelect ́AZIɍ킹ăACeIB
		//
		//(A)̈ʒuŏ܂B
	}




	// ********************************
	//		ECreateCmd_All ,
	//@SԂΏۂƂR}h𐶐܂B
	// ********************************
	if ( eCreateCmd == ECreateCmd_All )
	{
		// r[ŕIOFFEtH[JXZACeɂꍇ: 
		//- m_iDiaIndex = 0Am_iIndexSize = ACe̐
		//- m_CentDedRessyaCont = SACẽRs[
		//- m_CaMuiSelect ́ASACeIB
		//
		// r[ŕIOFFEtH[JXZVKACeʒuɂꍇ: 
		//- m_iDiaIndex = 0Am_iIndexSize = ACe̐
		//- m_CentDedRessyaCont = SACẽRs[
		//- CaMuiSelect ́ASACeIB
		if ( getCSelect()->getSelectedCellCount() == 0 
			&& ( aCdYColSpecOfFocus.getColumnType() == CdEkiTrack2YColSpec::ColumnType_EkiTrack2
			|| aCdYColSpecOfFocus.getColumnType() == CdEkiTrack2YColSpec::ColumnType_NewEkiTrack2) )
		{
			bRv = true ;
			if ( ppCmd != NULL )
			{
				pCmd = OuNew<DedRosenFileData::EditCmd::CRfEditCmd_EkiTrack2>(
					new CRfEditCmd_EkiTrack2(
						*getCDiagramEditDoc()->getCDedRosenFileData() ,
						//GetDocument()->getEkiIndex(),
						iEkiIndex,
						0 , 
						aCdYColSpecCont.getEkiTrack2Count() ) ) ;
				pCmd->getCaMuiSelect()->setSelectAll( true ) ;
			}
		}

		// r[ŕION
		//
		//- m_iDiaIndex = IĂACe̐擪index
		//- m_iIndexSize = IĂACe̖index-擪index+1
		//- m_CentDedRessyaCont = IĂACe̐擪index
		//index܂ł̃ACẽRs[
		//- m_CaMuiSelect ́AZ̑Iɍ킹ăACeIB
		//
		//(A)̈ʒuŏ܂B
	}

	// ********************************
	//	(A)ECreateCmd_SelectEECreateCmd_All 
	//@IĂԂΏۂƂ
	//	R}h𐶐܂B
	// ********************************
	if ( eCreateCmd == ECreateCmd_Select 
		|| eCreateCmd == ECreateCmd_All )
	{
		if ( getCSelect()->getSelectedCellCount() > 0 )
		{
			//	IĂACeIndex擾
			deque<int> contiSelectedItemIndex ;
			for ( int iColumnNumber = 0 ; iColumnNumber < getCXDcdGrid()->getYColumnCount() ;iColumnNumber ++ )
			{
				if ( getCSelect()->getYColumnNumberSelected( iColumnNumber ) )
				{
					CdEkiTrack2YColSpec aCdYColSpec = aCdYColSpecCont.ColumnNumberToSpec( iColumnNumber ) ;
					if ( aCdYColSpec.getColumnType() == CdEkiTrack2YColSpec::ColumnType_EkiTrack2)
					{
						contiSelectedItemIndex.push_back( aCdYColSpec.getEkiTrack2Index() ) ;
					}
				}
			}
			//contiSelectedItemIndex = ̕I{Ăꍇ́A
			//	IĂԎIndexi[܂B
			//	łȂꍇ́AłB

			if ( contiSelectedItemIndex.size() > 1 )
			{
				bRv = true ;
				if ( ppCmd != NULL )
				{
					//	R}hIuWFNgɁAIĂw̐擪疖܂ł
					//	wi[܂(擪EȊOɂ́AIĂȂw
					//	܂܂Ăꍇ܂)
					pCmd = OuNew<DedRosenFileData::EditCmd::CRfEditCmd_EkiTrack2>(
						new CRfEditCmd_EkiTrack2(
							*getCDiagramEditDoc()->getCDedRosenFileData() ,
							//GetDocument()->getEkiIndex(),
							iEkiIndex,
							contiSelectedItemIndex.front() , 
							contiSelectedItemIndex.back() - contiSelectedItemIndex.front() + 1 ) ) ;

					//	R}hIuWFNg
					//	m_CentDedRessyaContSrc  ̗ԂI܂B
					pCmd->getCaMuiSelect()->setSelectAll( false ) ;
					for ( int i = 0 ; i < (int)contiSelectedItemIndex.size() ; i ++ )
					{
						pCmd->getCaMuiSelect()->setSelect( 
							contiSelectedItemIndex[i] - contiSelectedItemIndex.front()  , 
							true ) ;
					}
				}
			}
		}
	}
	// ================================
	if ( ppCmd != NULL && pCmd != NULL )
	{
		*ppCmd = pCmd ;
	}
	return bRv ;
}


	// --------------------------------
	//@name OnUpdate ̉֐
	// --------------------------------
void CWndDcdGridEkiTrack2::OnUpdate_setCentDedEkiTrack2_To_Column(
	int iYColumnNumber , 
	const CentDedEkiTrack2& aCentDedEkiTrack2,
	const int iDownMain,
	const int iUpMain)
{
	bool bIsNull = aCentDedEkiTrack2.isNull() ;

	CdFontProp fontpropDefault = createFontProp() ;

	// --------------------------------
	//	sYTCYݒ
	// --------------------------------
	{
		CDcdTargetGetDC	aCDcdTarget( NULL ) ;

		CdDcdSizeXy	sizeEkiTrack2mei ;
		CDcdTextbox	aCDcdTextbox(_T("sss") ,
			fontpropDefault , 
			_T("") , 1 , 2 , 2 ) ;
		aCDcdTextbox.getItemSize( &aCDcdTarget , &sizeEkiTrack2mei) ;

		getCXDcdGrid()->getYColumn( iYColumnNumber )->setColumnSize( sizeEkiTrack2mei.getY() ) ;
	}


	// --------------------------------
	//	ݒ
	// --------------------------------
	{
		//	Ԑ
		Ou<CDcdTextbox> pCDcdTextbox = 
			getCXDcdGrid()->getCell(XCOLUMNNNO_EKITRACK2, iYColumnNumber )->getIfDcDraw() ;
		pCDcdTextbox->
			setText(aCentDedEkiTrack2.getTrackName() )  ;

		//	tHg
		CdDrawTextProp	aCdDrawTextProp = 
				pCDcdTextbox->getCdDrawTextProp() ;
		aCdDrawTextProp.setCdFontProp( fontpropDefault ) ;
		pCDcdTextbox->setCdDrawTextProp( aCdDrawTextProp )  ;	
		
		//	Z𖳌
		InvalidateCell(XCOLUMNNNO_EKITRACK2, iYColumnNumber ) ;
	}
	{
		//	
		Ou<CDcdTextbox> pCDcdTextbox = 
			getCXDcdGrid()->getCell(XCOLUMNNNO_ETRYAKUSYOU, iYColumnNumber )->getIfDcDraw() ;
		
		//̂̃eLXg
		pCDcdTextbox->setText( 
			aCentDedEkiTrack2.getTrackRyakusyou() )  ;
		
		//̂̃tHg
		CdDrawTextProp	aCdDrawTextProp = 
				pCDcdTextbox->getCdDrawTextProp() ;
		aCdDrawTextProp.setCdFontProp(fontpropDefault);
		/*{
			aCdDrawTextProp.setTextColor( 
				aCentDedRessyasyubetsu.getJikokuhyouMojiColor() ) ;

			int idxFont = aCentDedRessyasyubetsu.getJikokuhyouFontIndex() ;
			aCdDrawTextProp.setCdFontProp( 
				getCDiagramEditDoc()->getCDedRosenFileData()
					->getCdDedDispProp().getJikokuhyouFont( idxFont ) ) ;
		}*/
		pCDcdTextbox->setCdDrawTextProp( aCdDrawTextProp )  ;	

		//	Z𖳌
		InvalidateCell(XCOLUMNNNO_ETRYAKUSYOU, iYColumnNumber ) ;
	}
	{
		//	{
		Ou<CDcdTextbox> pCDcdTextbox =
			getCXDcdGrid()->getCell(XCOLUMNNNO_MAINTRACK, iYColumnNumber)->getIfDcDraw();

		if (aCentDedEkiTrack2.getTrackName().empty())
		{
			pCDcdTextbox->setText(_T(""));
		}
		else if (iYColumnNumber == iDownMain && iYColumnNumber == iUpMain)
		{
			pCDcdTextbox->setText(_T("㉺{"));
		}
		else if (iYColumnNumber == iDownMain && iYColumnNumber != iUpMain)
		{
			pCDcdTextbox->setText(_T("{"));
		}
		else if (iYColumnNumber != iDownMain && iYColumnNumber == iUpMain)
		{
			pCDcdTextbox->setText(_T("{"));
		}
		else if (iYColumnNumber != iDownMain && iYColumnNumber != iUpMain)
		{
			pCDcdTextbox->setText(_T("{/"));
		}

		//pCDcdTextbox->
		//	setText(aCentDedEkiTrack2.getTrackName());

		//	tHg
		CdDrawTextProp	aCdDrawTextProp =
			pCDcdTextbox->getCdDrawTextProp();
		aCdDrawTextProp.setCdFontProp(fontpropDefault);
		pCDcdTextbox->setCdDrawTextProp(aCdDrawTextProp);

		//	Z𖳌
		InvalidateCell(XCOLUMNNNO_MAINTRACK, iYColumnNumber);
	}
	//{
	//	//	X^C
	//	CdDcdFreeLineProp	aCdLineProp( 0 ) ;
	//	if ( !bIsNull ){
	//		CconvCentDed aCconvCentDed ;
	//		aCconvCentDed.CentDedRessyasyubetsu_to_CDcdFreeLineProp( 
	//			aCentDedRessyasyubetsu.getCdDiagramLineStyle() ,
	//			&aCdLineProp ) ;
	//	}
	//	Ou<CDcdFreeLine_StyleSample>	pCDcdFreeLine_StyleSample = 
	//		getCXDcdGrid()->getCell( XCOLUMNNNO_LINESTYLE , iYColumnNumber )->getIfDcDraw() ;
	//	pCDcdFreeLine_StyleSample->setCdLineProp( aCdLineProp ) ;

	//	//	Z𖳌
	//	InvalidateCell( XCOLUMNNNO_LINESTYLE , iYColumnNumber ) ;
	//}
}


void CWndDcdGridEkiTrack2::OnUpdate_setEkiTrack2NoXColumn()
{
	//const CentDedRosen*	pCentDedRosen = getCDiagramEditDoc()->getCDedRosenFileData()->getCentDedRosen() ;
	//ꉞύX
		//int iEkiIndex = GetDocument()->getEkiIndex();
		//const Mu< const CentDedEki* >* pCentDedEkiCont = getCDiagramEditDoc()->getCDedRosenFileData()
		//	->getCentDedRosen()->getCentDedEkiCont()->getMuPtr();
		//const Mu<const CentDedEkiTrack2*>* pMuCentDedEkiTrack2 =
		//	pCentDedEkiCont->get(iEkiIndex)->getEkiTrack2Cont()->getMuPtr();

	//iEkiIndex->iIDւ̎dlύXɔύX
	const CentDedEkiCont* pCentDedEkiCont = getCDiagramEditDoc()
		->getCDedRosenFileData()->getCentDedRosen()->getCentDedEkiCont();
	int iEkiIndex = pCentDedEkiCont->EkiIndexOfEkiID(GetDocument()->getEkiID());
	const Mu<const CentDedEkiTrack2*>* pMuCentDedEkiTrack2 =
		pCentDedEkiCont->getMuPtr()->get(iEkiIndex)->getEkiTrack2Cont()->getMuPtr();

	for ( int iYColumnNumber = 0 ; iYColumnNumber < getCXDcdGrid()->getYColumnCount() ; iYColumnNumber ++ )
	{
		Ou<CDcdTextbox> pCDcdTextbox = 
			getCXDcdGrid()->getCell(XCOLUMNNNO_EKITRACK2NO, iYColumnNumber )->getIfDcDraw() ;

		tstring aStr ;
		if ( YCOLUMNNNO_EKITRACK2_0 <= iYColumnNumber &&
			iYColumnNumber < YCOLUMNNNO_EKITRACK2_0 + 9 &&
			iYColumnNumber < YCOLUMNNNO_EKITRACK2_0 + pMuCentDedEkiTrack2->size() )
		{
			aStr = stringOf( iYColumnNumber - YCOLUMNNNO_EKITRACK2_0 + 1) ;
		}
		pCDcdTextbox->setText( aStr )  ;	
		
		//	ZXV
		InvalidateCell(XCOLUMNNNO_EKITRACK2NO, iYColumnNumber ) ;
	}
}



void  CWndDcdGridEkiTrack2::OnUpdate_All()
{
	CWaitCursor	aCWaitCursor ;	

	//CDiagramEditDoc* pCDiagramEditDoc = getCDiagramEditDoc() ;
	//const CentDedRosen*	pCentDedRosen = 
	//	pCDiagramEditDoc->getCDedRosenFileData()->getCentDedRosen() ;
	////ꉞύX
	//int iEkiIndex = GetDocument()->getEkiIndex();
	//const Mu< const CentDedEki* >* pCentDedEkiCont = getCDiagramEditDoc()->getCDedRosenFileData()
	//	->getCentDedRosen()->getCentDedEkiCont()->getMuPtr();
	//const Mu<const CentDedEkiTrack2*>* pCentDedEkiTrack2ContGet =
	//	pCentDedEkiCont->get(iEkiIndex)->getEkiTrack2Cont()->getMuPtr();


	//iEkiIndex->iIDւ̎dlύXɔύX
	const CentDedEkiCont* pCentDedEkiCont = getCDiagramEditDoc()
		->getCDedRosenFileData()->getCentDedRosen()->getCentDedEkiCont();
	int iEkiIndex = pCentDedEkiCont->EkiIndexOfEkiID(GetDocument()->getEkiID());
	const Mu<const CentDedEkiTrack2*>* pCentDedEkiTrack2ContGet =
		pCentDedEkiCont->getMuPtr()->get(iEkiIndex)->getEkiTrack2Cont()->getMuPtr();
	int iDownMain = pCentDedEkiCont->get(iEkiIndex).getDownMain();
	int iUpMain = pCentDedEkiCont->get(iEkiIndex).getUpMain();
	{
		//	R}hIuWFNgsɂZړŃZIɂȂȂ悤ɁA
		//	ZIAZI@\ꎞIɒ~܂B
		clearSelect() ;
		CPropStack aPropStack( this ) ;
		aPropStack
			.CBoxSelect_setIsEnable( false )
			.CRandomSelect_setIsEnable( false )  ;

		// --------------------------------		
		//	SvfXV
		// --------------------------------
		//	Y񐔂𑝌
		getCXDcdGrid()->setYColumnCount( 
			pCentDedEkiTrack2ContGet->size() + YCOLUMNNNO_EKITRACK2_0 + YCOLUMNNCOUNT_BLANK ) ;

		//	eZɁAf[^ݒ
		int idxEkiTrack2;
		for ( idxEkiTrack2 = 0 ;
				idxEkiTrack2 <
					pCentDedEkiTrack2ContGet->size() ;
				idxEkiTrack2++ )
		{
			const CentDedEkiTrack2*	pCentDedEkiTrack2 =
				pCentDedEkiTrack2ContGet->get( idxEkiTrack2) ;

			OnUpdate_setCentDedEkiTrack2_To_Column(
				idxEkiTrack2 + YCOLUMNNNO_EKITRACK2_0, *pCentDedEkiTrack2,
				iDownMain, iUpMain) ;
		} 
		OnUpdate_setCentDedEkiTrack2_To_Column(
			idxEkiTrack2 + YCOLUMNNNO_EKITRACK2_0, CentDedEkiTrack2() ,
			iDownMain, iUpMain) ;

		// --------------------------------
		//	ԎʔԍXV
		// --------------------------------
		OnUpdate_setEkiTrack2NoXColumn() ;
	}
	m_bUpdate_All_Requested = false ;
}

	// --------------------------------
	//@name j[R}h̉֐
	// --------------------------------
	//	[ҏW]-[؂]
int CWndDcdGridEkiTrack2::OnEditCut_Process( BOOL bQueryEnable )
{
	int iRv = 0 ;
	CString	strErrorMessage ;

	//iEkiIndex->iIDւ̎dlύXɔύX
	const CentDedRosen*	pCentDedRosen = 
		getCDiagramEditDoc()->getCDedRosenFileData()->getCentDedRosen() ;
	const CentDedEkiCont* pCentDedEkiCont = pCentDedRosen->getCentDedEkiCont();
	int iEkiIndex = pCentDedEkiCont->EkiIndexOfEkiID(GetDocument()->getEkiID());
	const Mu<const CentDedEkiTrack2*>* pMuCentDedEkiTrack2 =
		pCentDedEkiCont->getMuPtr()->get(iEkiIndex)->getEkiTrack2Cont()->getMuPtr();

	CdEkiTrack2YColSpecCont aCdYColSpecCont = createYColSpecCont();

	Ou<CRfEditCmd_EkiTrack2> pCmd ;
	Ou<CRfEditCmd_EkiTrack2>* ppCmd = NULL ;
	if ( !bQueryEnable ){	ppCmd = &pCmd ;}


	// ****************************************************************
	//	R}h̗LE
	// ****************************************************************
	if ( iRv >= 0 )
	{
		if (!createCmd(ECreateCmd_Focus, ppCmd))
		//if ( !createCmd( ECreateCmd_Select , ppCmd ) )
		{
			iRv = -1 ;	//	Z̈ʒu܂B
		}
	}
	if ( iRv >= 0 )
	{
		//	݁AԐ1ł΁Ãj[R}h͖Ƃ܂B
		if ( pMuCentDedEkiTrack2->size() <= 1 )
		{
			iRv = -2;	//	Ԑ1ł΁Ãj[R}h͖
		}
	}
	if (iRv >= 0)
	{
		//	Ԑ{ɐݒ肳ĂꍇAG[Ƃ܂B
		if (getCSelect()->getSelectedCellCount() == 0)
		{
			int DownMain = pCentDedEkiCont->get(iEkiIndex).getDownMain();
			int UpMain = pCentDedEkiCont->get(iEkiIndex).getUpMain();
			CdEkiTrack2YColSpec aCdEkiTrack2YColSpec = getYColSpecOfFocus();
			int iEkiTrack2Index = aCdEkiTrack2YColSpec.getEkiTrack2Index();

			//Index0n܂ADown/UpMain0n܂Ȃ̂ŁA+1Ĕr
			if (iEkiTrack2Index + 1 == DownMain)
			{
				iRv = -4;
			}
			else if (iEkiTrack2Index + 1 == UpMain)
			{
				iRv = -5;
			}
		}
		else if (getCSelect()->getSelectedCellCount() > 0)
		{
			int DownMain = pCentDedEkiCont->get(iEkiIndex).getDownMain();
			int UpMain = pCentDedEkiCont->get(iEkiIndex).getUpMain();
			for (int iColumnNumber = 0; iColumnNumber < getCXDcdGrid()->getYColumnCount() && iRv >= 0; iColumnNumber++)
			{
				if (getCSelect()->getYColumnNumberSelected(iColumnNumber))
				{
					CdEkiTrack2YColSpec aCdEkiTrack2YColSpec = aCdYColSpecCont.ColumnNumberToSpec(iColumnNumber);
					int iEkiTrack2Index = aCdEkiTrack2YColSpec.getEkiTrack2Index();
					//Index0n܂ADown/UpMain0n܂Ȃ̂ŁA+1Ĕr
					if (iEkiTrack2Index + 1 == DownMain)
					{
						iRv = -4;
					}
					else if (iEkiTrack2Index + 1 == UpMain)
					{
						iRv = -5;
					}
				}
			}
		}
	}
	// ****************************************************************
	if ( !bQueryEnable && iRv >= 0 )
	{
		// ****************************************************************
		//	R}h̎s
		// ****************************************************************
		
		//	폜悤ƂĂԐ̗Ԃ
		//	݂ȂG[Ƃ܂B
		int iEkiTrack2Index = -1 ;
		int iDiaIndex = -1 ;//߂lp
		ERessyahoukou	eRessyahoukou = Ressyahoukou_Kudari ;//߂lp
		if ( iRv >= 0 )
		{
			int idx ;
			for ( idx = 0 ; iRv >= 0 && idx < pCmd->getCaMuiSelect()->size() ;
				idx ++ )
			{
				iEkiTrack2Index = pCmd->getIndexDst() + idx ;
				std::deque<int> iEkiIndexBrunchLoop;
				int iSize = pCentDedRosen->getCentDedEkiCont()
					->getEkiIndexBrunchLoop(iEkiIndex, iEkiIndexBrunchLoop);
				for (int idxbl = 0; idxbl < iSize; idxbl++)
				{

					if (pCentDedRosen->getCentDedDiaCont()
						->isExistRessyaOfEkiTrack2(
							iEkiIndexBrunchLoop[idxbl], iEkiTrack2Index,
							&iDiaIndex, &eRessyahoukou, NULL)
						!= 0)
					{
						iRv = -3;	//폜悤ƂĂԐ̗Ԃ݂܂
						break;
					}
				}
			}
		}
		//iEkiIndex = 
		//	iRv=-3̏ꍇ́A폜悤ƂĂԐwindex
		//iEkiTrack2Index = 
		//	iRv=-3̏ꍇ́A폜悤ƂĂԐindex
		//iDiaIndex = 
		//	iRv=-3̏ꍇ́A폜悤ƂĂԐ݂_Cindex
		//eRessyahoukou = 
		//	iRv=-3̏ꍇ́A폜悤ƂĂԐ݂_Cindex
		
		if ( iRv >= 0 )
		{
			// -------------------------------- 
			//	Nbv{[hɓ]
			// --------------------------------
			getCDiagramEditDoc()->CentDedEkiTrack2_To_Cliboard(
				pCmd->getCaMuiSelect() ) ;
			// --------------------------------
			//	R}hIuWFNg̗ԂҏW
			// --------------------------------
			{
				pCmd->getCaMuiSelect()->erase( 0 , INT_MAX ) ;
			}
			// --------------------------------
			//	R}hIuWFNgs
			// --------------------------------
			{
				getCDiagramEditDoc()->executeEditCmd( pCmd ) ;
			}
		}
		// ****************************************************************
		//	G[bZ[W
		// ****************************************************************
		if ( iRv < 0 )
		{
			//	G[bZ[W\

			if ( iRv == -3 )
			{
				CString	strEkiName = pCentDedEkiCont->get(iEkiIndex).getEkimei().c_str();
				CString	strEkiTrack2Name =
					pMuCentDedEkiTrack2->get( iEkiTrack2Index )
					->getTrackName().c_str()  ;
				CString	strDiaName = 
					pCentDedRosen->getCentDedDiaCont()->getMuPtr()->
					get( iDiaIndex )->getName().c_str() ;
				CString	strRessyahoukou ;
				//if ( eRessyahoukou == Ressyahoukou_Kudari )
				//{
				//	strRessyahoukou.LoadString( IDS_WORD_Kudari ) ;
				//}
				//else
				//{
				//	strRessyahoukou.LoadString( IDS_WORD_Nobori ) ;
				//}
				if (eRessyahoukou == Ressyahoukou_Kudari)
				{
					if (pCentDedRosen->getKudariDiaAlias().empty())
					{
						strRessyahoukou.LoadString(IDS_WORD_Kudari);
					}
					else
					{
						strRessyahoukou = pCentDedRosen->getKudariDiaAlias().c_str();
					}
				}
				else
				{
					if (pCentDedRosen->getNoboriDiaAlias().empty())
					{
						strRessyahoukou.LoadString(IDS_WORD_Nobori);
					}
					else
					{
						strRessyahoukou = pCentDedRosen->getNoboriDiaAlias().c_str();
					}
				}
				CString	strMsg ;
				strMsg.Format( IDS_ERR_ExistRessyaOfEkiTrack,
					strEkiName,strEkiTrack2Name, strDiaName , strRessyahoukou ) ;
				strErrorMessage = strMsg ;
			}

			if ( iRv == -4)
			{
				CString	strMsg ;
				strMsg = _T("{Ɏw肳Ă̂ō폜ł܂");
				strErrorMessage = strMsg ;
			}
			if (iRv == -5)
			{
				CString	strMsg;
				strMsg = _T("{Ɏw肳Ă̂ō폜ł܂");
				strErrorMessage = strMsg;
			}

			if ( strErrorMessage.IsEmpty() )
			{
				strErrorMessage.Format( _T( "Error(%d)" ) , iRv ) ; 
			}
			MessageBox( strErrorMessage , NULL , MB_ICONSTOP | MB_OK ) ; 
		}
		// ****************************************************************
	}
	return iRv ;	

}
	//	[ҏW]-[Rs[]	
int CWndDcdGridEkiTrack2::OnEditCopy_Process( BOOL bQueryEnable )
{
	int iRv = 0 ;
	Ou<CRfEditCmd_EkiTrack2> pCmd ;
	Ou<CRfEditCmd_EkiTrack2>* ppCmd = NULL ;
	if ( !bQueryEnable ){	ppCmd = &pCmd ;}

	// ****************************************************************
	//	R}h̗LE
	// ****************************************************************
	if ( iRv >= 0 )
	{
		if ( !createCmd( ECreateCmd_Select , ppCmd ) )
		{
			iRv = -1 ;	//	Z̈ʒu܂B
		}
	}
	// ****************************************************************
	if ( !bQueryEnable && iRv >= 0 )
	{
		// ****************************************************************
		//	R}h̎s
		// ****************************************************************
		// -------------------------------- 
		//	Nbv{[hɓ]
		// --------------------------------
		getCDiagramEditDoc()->CentDedEkiTrack2_To_Cliboard(
			pCmd->getCaMuiSelect() ) ;

		// -------------------------------- 
		//	tH[JXZAIvfōő̔ԐIndex̎ʂɈړ
		// --------------------------------
		{
			//	ZINAA
			//	tH[JXZ̈ړɂZI𖳌܂B
			clearSelect() ;
			CPropStack	aPropStack( this ) ;
			aPropStack
				.CBoxSelect_setIsEnable( false )
				.CRandomSelect_setIsEnable( false )  ;
		
			//	Ivfōő̔ԐIndex ߂
			int iEkiTrack2IndexMax = -1 ;
			{
				CaMuiSelect<CentDedEkiTrack2>* pCaMuiSelect = pCmd->getCaMuiSelect() ;
				for ( int iIndex = pCaMuiSelect->getAdapteeMu()->size() - 1  ; 
					iEkiTrack2IndexMax == -1 && iIndex >= 0 ; iIndex -- )
				{
					if ( pCaMuiSelect->getSelect( iIndex ) )
					{
						iEkiTrack2IndexMax = iIndex + pCmd->getIndexDst() ;
					}
				}
			}
			//iEkiTrack2IndexMax = IĂԐ̂AőIndex

			//	ړ̃tH[JXZʒu
			int iYColumnNmber = -1 ;
			{
				CdEkiTrack2YColSpecCont aCdYColSpecCont = createYColSpecCont() ;
				iYColumnNmber = aCdYColSpecCont.ColumnNumberFromSpec( 
					CdEkiTrack2YColSpec( CdEkiTrack2YColSpec::ColumnType_EkiTrack2, iEkiTrack2IndexMax ) ) + 1 ;
			}
			//	tH[JXړ
			{
				CdDcdPosXy posxyFocusCellColumnNumber 
					= getCFocus()->getFocusCellColumnNumber() ;
				if ( iYColumnNmber >= 0 
					&& posxyFocusCellColumnNumber != getCFocus()->ColumnNumberPosXy_NULL() )
				{
					posxyFocusCellColumnNumber.setY( iYColumnNmber ) ;
					getCFocus()->setFocusCellColumnNumber( posxyFocusCellColumnNumber ) ;
				}
			}
		}
		// ****************************************************************
		//	G[bZ[W
		// ****************************************************************

		// ****************************************************************
	}
	return iRv ;


}
	//	[ҏW]-[\t]	
int CWndDcdGridEkiTrack2::OnEditPaste_Process( BOOL bQueryEnable )
{
	int iRv = 0 ;
	Ou<CRfEditCmd_EkiTrack2> pCmd ;
	Ou<CRfEditCmd_EkiTrack2>* ppCmd = NULL ;
	if ( !bQueryEnable ){	ppCmd = &pCmd ;}

	// ****************************************************************
	//	R}h̗LE
	// ****************************************************************
	if ( iRv >= 0 )
	{
		if ( !createCmd( ECreateCmd_NewItem , ppCmd ) )
		{
			iRv = -1 ;	//	Z̈ʒu܂B
		}
	}
	if ( iRv >= 0 )
	{
		if ( !getCDiagramEditDoc()->CentDedEkiTrack2_IsClipboardFormatAvailable() )
		{
			iRv = -2 ;	//	Nbv{[hɔԐ̃f[^܂
		}
	}
	// ****************************************************************
	if ( !bQueryEnable && iRv >= 0 )
	{
		// ****************************************************************
		//	R}h̎s
		// ****************************************************************
		// -------------------------------- 
		//	Nbv{[hf[^擾
		// --------------------------------
		CentDedEkiTrack2Cont	aEkiTrack2Cont ;
		getCDiagramEditDoc()->CentDedEkiTrack2_From_Cliboard( &aEkiTrack2Cont ) ;
		// --------------------------------
		//	R}hIuWFNg̔ԐҏW
		// --------------------------------
		{
			//	CWndDcdGridEkiTrack2::ECreateCmd_NewItem ɂĐꂽ
			//	VKACe͍폜܂B
			pCmd->getCaMuiSelect()->erase( 0 , INT_MAX ) ;

			//	R}hɃNbv{[h̃ACeǉ܂B
			CaMui<CentDedEkiTrack2> aCaMui( pCmd->getCaMuiSelect() ) ;
			aCaMui.insert( &aEkiTrack2Cont , 0 , INT_MAX , 0 ) ;
		}
		// --------------------------------
		//	R}hIuWFNgs
		// --------------------------------
		{
			getCDiagramEditDoc()->executeEditCmd( pCmd ) ;
		}
		// ****************************************************************
		//	G[bZ[W
		// ****************************************************************
		if ( iRv < 0 )
		{
			CString strErrorMessage ;
			strErrorMessage.Format( _T( "Error=%d" ) , iRv ) ;

			MessageBox( strErrorMessage , NULL , MB_ICONSTOP | MB_OK ) ; 
		}
	}
	return iRv ;

}
	//	[ҏW]-[]	
int CWndDcdGridEkiTrack2::OnEditClear_Process( BOOL bQueryEnable )
{
	int iRv = 0 ;
	CString	strErrorMessage ;

	//iEkiIndex->iIDւ̎dlύXɔύX
	const CentDedRosen*	pCentDedRosen = 
		getCDiagramEditDoc()->getCDedRosenFileData()->getCentDedRosen() ;
	const CentDedEkiCont* pCentDedEkiCont = pCentDedRosen->getCentDedEkiCont();
	int iEkiIndex = pCentDedEkiCont->EkiIndexOfEkiID(GetDocument()->getEkiID());
	const Mu<const CentDedEkiTrack2*>* pMuCentDedEkiTrack2 =
		pCentDedEkiCont->getMuPtr()->get(iEkiIndex)->getEkiTrack2Cont()->getMuPtr();

	CdEkiTrack2YColSpecCont aCdYColSpecCont = createYColSpecCont();

	Ou<CRfEditCmd_EkiTrack2> pCmd ;
	Ou<CRfEditCmd_EkiTrack2>* ppCmd = NULL ;
	if ( !bQueryEnable ){	ppCmd = &pCmd ;}


	// ****************************************************************
	//	R}h̗LE
	// ****************************************************************
	if ( iRv >= 0 )
	{
		if ( !createCmd(ECreateCmd_Focus, ppCmd ) )
			//if (!createCmd(ECreateCmd_Select, ppCmd))
		{
			iRv = -1 ;	//	Z̈ʒu܂B
		}
	}
	if ( iRv >= 0 )
	{
		//	݁AԎʂ1ł΁Ãj[R}h͖Ƃ܂B
		if ( pMuCentDedEkiTrack2->size() <= 1 )
		{
			iRv = -2;	//	Ԏʂ1ł΁Ãj[R}h͖
		}
	}
	if (iRv >= 0)
	{
		//	Ԑ{ɐݒ肳ĂꍇAG[Ƃ܂B
		if (getCSelect()->getSelectedCellCount() == 0)
		{
			int DownMain = pCentDedEkiCont->get(iEkiIndex).getDownMain();
			int UpMain = pCentDedEkiCont->get(iEkiIndex).getUpMain();
			CdEkiTrack2YColSpec aCdEkiTrack2YColSpec = getYColSpecOfFocus();
			int iEkiTrack2Index = aCdEkiTrack2YColSpec.getEkiTrack2Index();

			//Index0n܂ADown/UpMain0n܂Ȃ̂ŁA+1Ĕr
			if (iEkiTrack2Index + 1 == DownMain)
			{
				iRv = -4;
			}
			else if (iEkiTrack2Index + 1 == UpMain)
			{
				iRv = -5;
			}
		}
		else if (getCSelect()->getSelectedCellCount() > 0)
		{
			int DownMain = pCentDedEkiCont->get(iEkiIndex).getDownMain();
			int UpMain = pCentDedEkiCont->get(iEkiIndex).getUpMain();
			for (int iColumnNumber = 0; iColumnNumber < getCXDcdGrid()->getYColumnCount() && iRv >= 0; iColumnNumber++)
			{
				if (getCSelect()->getYColumnNumberSelected(iColumnNumber))
				{
					CdEkiTrack2YColSpec aCdEkiTrack2YColSpec = aCdYColSpecCont.ColumnNumberToSpec(iColumnNumber);
					int iEkiTrack2Index = aCdEkiTrack2YColSpec.getEkiTrack2Index();
					//Index0n܂ADown/UpMain0n܂Ȃ̂ŁA+1Ĕr
					if (iEkiTrack2Index + 1 == DownMain)
					{
						iRv = -4;
					}
					else if (iEkiTrack2Index + 1 == UpMain)
					{
						iRv = -5;
					}
				}
			}
		}
	}
	// ****************************************************************
	if ( !bQueryEnable && iRv >= 0 )
	{
		// ****************************************************************
		//	R}h̎s
		// ****************************************************************

		//	폜悤ƂĂԐ̗Ԃ
		//	݂ȂG[Ƃ܂B
		int iEkiTrack2Index = -1 ;
		int iDiaIndex = -1 ;
		ERessyahoukou	eRessyahoukou = Ressyahoukou_Kudari ;
		if ( iRv >= 0 )
		{
			int idx ;
			for ( idx = 0 ; iRv >= 0 && idx < pCmd->getCaMuiSelect()->size() ;
				idx ++ )
			{
				iEkiTrack2Index = pCmd->getIndexDst() + idx ;
				std::deque<int> iEkiIndexBrunchLoop;
				int iSize = pCentDedRosen->getCentDedEkiCont()
					->getEkiIndexBrunchLoop(iEkiIndex, iEkiIndexBrunchLoop);
				for (int idxbl = 0; idxbl < iSize; idxbl++)
				{
					if (pCentDedRosen->getCentDedDiaCont()
						->isExistRessyaOfEkiTrack2(
							iEkiIndexBrunchLoop[idxbl], iEkiTrack2Index,
							&iDiaIndex, &eRessyahoukou, NULL)
						!= 0)
					{
						iRv = -3;	//폜悤ƂĂԐ̗Ԃ݂܂
						break;
					}

				}
			}
		}
		//iEkiIndex = 
		//	iRv=-3̏ꍇ́A폜悤ƂĂԐwindex
		//iEkiTrack2Index = 
		//	iRv=-3̏ꍇ́A폜悤ƂĂԐindex
		//iDiaIndex = 
		//	iRv=-3̏ꍇ́A폜悤ƂĂԐ݂_Cindex
		//eRessyahoukou = 
		//	iRv=-3̏ꍇ́A폜悤ƂĂԐ݂_Cindex
		
		if ( iRv >= 0 )
		{
			// -------------------------------- 
			//	Nbv{[hɓ]
			// --------------------------------
			getCDiagramEditDoc()->CentDedEkiTrack2_To_Cliboard(
				pCmd->getCaMuiSelect() ) ;
			// --------------------------------
			//	R}hIuWFNg̗ԂҏW
			// --------------------------------
			{
				pCmd->getCaMuiSelect()->erase( 0 , INT_MAX ) ;
			}
			// --------------------------------
			//	R}hIuWFNgs
			// --------------------------------
			{
				getCDiagramEditDoc()->executeEditCmd( pCmd ) ;
			}
		}
		// ****************************************************************
		//	G[bZ[W
		// ****************************************************************
		if ( iRv < 0 )
		{
			//	G[bZ[W\
			if ( iRv == -3 )
			{
				CString	strEkiName = pCentDedEkiCont->get(iEkiIndex).getEkimei().c_str();
				CString	strEkiTrack2Name =
					pMuCentDedEkiTrack2->get( iEkiTrack2Index )
					->getTrackName().c_str()  ;
				CString	strDiaName = 
					pCentDedRosen->getCentDedDiaCont()->getMuPtr()->
					get( iDiaIndex )->getName().c_str() ;
				CString	strRessyahoukou ;
				//if ( eRessyahoukou == Ressyahoukou_Kudari )
				//{
				//	strRessyahoukou.LoadString( IDS_WORD_Kudari ) ;
				//}
				//else
				//{
				//	strRessyahoukou.LoadString( IDS_WORD_Nobori ) ;
				//}
				if (eRessyahoukou == Ressyahoukou_Kudari)
				{
					if (pCentDedRosen->getKudariDiaAlias().empty())
					{
						strRessyahoukou.LoadString(IDS_WORD_Kudari);
					}
					else
					{
						strRessyahoukou = pCentDedRosen->getKudariDiaAlias().c_str();
					}
				}
				else
				{
					if (pCentDedRosen->getNoboriDiaAlias().empty())
					{
						strRessyahoukou.LoadString(IDS_WORD_Nobori);
					}
					else
					{
						strRessyahoukou = pCentDedRosen->getNoboriDiaAlias().c_str();
					}
				}
				CString	strMsg ;
				strMsg.Format( IDS_ERR_ExistRessyaOfEkiTrack,
					strEkiName,strEkiTrack2Name , strDiaName , strRessyahoukou ) ;
				strErrorMessage = strMsg ;
			}
			if ( iRv == -4)
			{
				CString	strMsg ;
				strMsg = _T("{Ɏw肳Ă̂ō폜ł܂");
				strErrorMessage = strMsg ;
			}
			if (iRv == -5)
			{
				CString	strMsg;
				strMsg = _T("{Ɏw肳Ă̂ō폜ł܂");
				strErrorMessage = strMsg;
			}

			if ( strErrorMessage.IsEmpty() )
			{
				strErrorMessage.Format( _T( "Error(%d)" ) , iRv ) ; 
			}
			MessageBox( strErrorMessage , NULL , MB_ICONSTOP | MB_OK ) ; 
		}
		// ****************************************************************
	}
	return iRv ;	

}
	//	[ҏW]-[Ԏʂ}]	
int CWndDcdGridEkiTrack2::
OnEDITEkiTrack2Insert_Process( BOOL bQueryEnable )
{
	int iRv = 0 ;

	// ****************************************************************
	//	R}h̗LE
	// ****************************************************************
	if ( execEkiTrack2PropDlg( true , TRUE ) < 0 )
	{
		iRv = -1 ;	//	tH[JẌʒusłB
	}
	// ****************************************************************
	if ( !bQueryEnable && iRv >= 0 )
	{
		// ****************************************************************
		//	R}h̎s
		// ****************************************************************
		execEkiTrack2PropDlg( true , FALSE ) ;

		// ****************************************************************
		//	G[bZ[W
		// ****************************************************************
		if ( iRv < 0 )
		{
			CString strErrorMessage ;
			switch( iRv )
			{
			case -1 :	//	݂͎sł܂B
				break ;
			default:
				strErrorMessage.Format( _T( "Error=%d" ) , iRv ) ;
				break ;
			}
			if ( strErrorMessage.GetLength() > 0 )
			{
				MessageBox( strErrorMessage , NULL , MB_ICONSTOP | MB_OK ) ; 
			}
		}
		// ****************************************************************
	}
	return iRv ;

}
	//	[ҏW]-[]	*/
int CWndDcdGridEkiTrack2::OnEkiTrack2Up_Process( BOOL bQueryEnable )
{
	int iRv = 0 ;
	// ****************************************************************
	//	R}h̗LE
	// ****************************************************************
	int iEkiTrack2Index = -1 ;
	if ( iRv >= 0 )
	{
		if ( !createCmd( ECreateCmd_Focus , NULL ) )
		{
			iRv = -1 ;	//	Z̈ʒu܂B
		}
	}
	if ( iRv >= 0 )
	{
		CdEkiTrack2YColSpecCont aYColSpecCont = createYColSpecCont() ;
		CdEkiTrack2YColSpec aYColSpec = getYColSpecOfFocus() ;
		if ( aYColSpec.getColumnType() != aYColSpec.ColumnType_EkiTrack2)
		{
			iRv = -1 ;
		}
		else
		{
			iEkiTrack2Index = aYColSpec.getEkiTrack2Index() ;
			if ( !( 1 <= iEkiTrack2Index
				&& iEkiTrack2Index< aYColSpecCont.getEkiTrack2Count() ) )
			{
				iRv = -1 ;	//	tH[JẌʒusłB(ԏ̗Ԏʂɂ͎g܂)
			}
		}
	}
	//iRessyasyubetsuIndex = tH[JXẐʒu̗ԎIndex

	// ****************************************************************
	if ( !bQueryEnable && iRv >= 0 )
	{
		// ****************************************************************
		//	R}h̎s
		// ****************************************************************
		// --------------------------------
		//	tH[JXړ
		// --------------------------------
		{
			CDcdGridCell*	pCDcdGridCell = getCFocus()->getFocusCell() ;
			if ( pCDcdGridCell != NULL ){
				CDcdGridCell*	pCDcdGridCellNew = getCXDcdGrid()->calcMovedCell( 
					pCDcdGridCell , 0 , -1 ) ;
				if ( pCDcdGridCellNew != NULL ){
					getCFocus()->setFocusCell( pCDcdGridCellNew ) ;	
				}
			}
		}
		// --------------------------------
		//	R}h𐶐Es
		// --------------------------------
		{
			//iEkiIndex->iIDւ̎dlύXɔύX
			const CentDedEkiCont* pCentDedEkiCont = getCDiagramEditDoc()
				->getCDedRosenFileData()->getCentDedRosen()->getCentDedEkiCont();
			int iEkiIndex = pCentDedEkiCont->EkiIndexOfEkiID(GetDocument()->getEkiID());

			OuNew<CRfEditCmd> pCmd( 
				new CRfEditCmd_EkiTrack2Swap(
					iEkiIndex,
					iEkiTrack2Index ,
					iEkiTrack2Index - 1 )
			) ;
			getCDiagramEditDoc()->executeEditCmd( pCmd ) ;
		}
		// ****************************************************************
		//	G[bZ[W
		// ****************************************************************

		// ****************************************************************
	}
	return ( iRv ) ;

}
	//	[ҏW]-[]	*/
int CWndDcdGridEkiTrack2::
OnEkiTrack2Down_Process( BOOL bQueryEnable )
{
	int iRv = 0 ;
	// ****************************************************************
	//	R}h̗LE
	// ****************************************************************
	int iEkiTrack2Index = -1 ;
	if ( iRv >= 0 )
	{
		if ( !createCmd( ECreateCmd_Focus , NULL ) )
		{
			iRv = -1 ;	//	Z̈ʒu܂B
		}
	}
	if ( iRv >= 0 )
	{
		CdEkiTrack2YColSpecCont aYColSpecCont = createYColSpecCont() ;
		CdEkiTrack2YColSpec aYColSpec = getYColSpecOfFocus() ;
		if ( aYColSpec.getColumnType() != aYColSpec.ColumnType_EkiTrack2)
		{
			iRv = -1 ;
		}
		else
		{
			iEkiTrack2Index = aYColSpec.getEkiTrack2Index() ;
			if ( !( 0 <= iEkiTrack2Index
				&& iEkiTrack2Index< aYColSpecCont.getEkiTrack2Count() - 1 ) )
			{
				iRv = -1 ;	//	tH[JẌʒusłB(ԉ̗Ԏʂɂ͎g܂)
			}
		}
	}
	//iRessyasyubetsuIndex = tH[JXẐʒu̗ԎIndex

	// ****************************************************************
	if ( !bQueryEnable && iRv >= 0 )
	{
		// ****************************************************************
		//	R}h̎s
		// ****************************************************************
		// --------------------------------
		//	tH[JXړ
		// --------------------------------
		{
			CDcdGridCell*	pCDcdGridCell = getCFocus()->getFocusCell() ;
			if ( pCDcdGridCell != NULL ){
				CDcdGridCell*	pCDcdGridCellNew = getCXDcdGrid()->calcMovedCell( 
					pCDcdGridCell , 0 , 1 ) ;
				if ( pCDcdGridCellNew != NULL ){
					getCFocus()->setFocusCell( pCDcdGridCellNew ) ;	
				}
			}
		}
		// --------------------------------
		//	R}h𐶐Es
		// --------------------------------
		{
			//iEkiIndex->iIDւ̎dlύXɔύX
			const CentDedEkiCont* pCentDedEkiCont = getCDiagramEditDoc()
				->getCDedRosenFileData()->getCentDedRosen()->getCentDedEkiCont();
			int iEkiIndex = pCentDedEkiCont->EkiIndexOfEkiID(GetDocument()->getEkiID());

			OuNew<CRfEditCmd> pCmd( 
				new CRfEditCmd_EkiTrack2Swap(
					iEkiIndex,
					iEkiTrack2Index,
					iEkiTrack2Index + 1 )
			) ;
			getCDiagramEditDoc()->executeEditCmd( pCmd ) ;
		}
		// ****************************************************************
		//	G[bZ[W
		// ****************************************************************

		// ****************************************************************
	}
	return ( iRv ) ;


}
	//	[ҏW]-[Ԑ̃vpeB]	*/
int CWndDcdGridEkiTrack2::
OnEDITEkiTrack2Prop_Process( BOOL bQueryEnable )
{
	int iRv = 0 ;
	// ****************************************************************
	//	R}h̗LE
	// ****************************************************************

	//	tH[JXZVKACeʒuɂƂ́A
	//	uVKACẽvpeB͂sA𖖔ɑ}vƂ
	//	ɂȂ܂B
	bool bInsert = false ;
	CdEkiTrack2YColSpec aYColSpec = getYColSpecOfFocus() ;
	if ( aYColSpec.getColumnType() == CdEkiTrack2YColSpec::ColumnType_NewEkiTrack2 )
	{
		bInsert = true ;
	}
	if ( execEkiTrack2PropDlg( bInsert , TRUE ) < 0 )
	{
		iRv = -1 ;	//	tH[JXZ̈ʒusłB
	}
	// ****************************************************************
	if ( !bQueryEnable && iRv >= 0 )
	{
		// ****************************************************************
		//	R}h̎s
		// ****************************************************************
		iRv = execEkiTrack2PropDlg( bInsert , FALSE ) ;

		// ****************************************************************
		//	G[bZ[W
		// ****************************************************************

		// ****************************************************************
	}
	return iRv ;

}



// ****************************************************************
//	CWndDcdGridEkiTrack2
// ****************************************************************


// ********************************
//	RXgN^
// ********************************
CWndDcdGridEkiTrack2::CWndDcdGridEkiTrack2()
	: m_bUpdate_All_Requested( false ) 
{
	getCSelect()->setSelectMode( CSelect::SelectMode_YColumn ) ;
}
CWndDcdGridEkiTrack2::~CWndDcdGridEkiTrack2()
{
}

// ********************************
//@name	CDcdGrid
// ********************************

// ********************************
//@name	CWndDcdGrid
// ********************************

	// ********************************
	//@name CWndDcdGridRessyasyubetsu-
	// ********************************

int CWndDcdGridEkiTrack2::
execEkiTrack2PropDlg( bool bInsert , BOOL bQueryEnable )
{
	int iRv = 0 ;
	Ou<CRfEditCmd_EkiTrack2>	pCmd ;
	Ou<CRfEditCmd_EkiTrack2>*	ppCmd = NULL ;
	if ( !bQueryEnable ){	ppCmd = &pCmd ;};

	// ****************************************************************
	//	R}h̎sۂ̔
	// ****************************************************************
	if ( iRv >= 0 )
	{
		if ( bInsert )
		{
			if ( !createCmd( ECreateCmd_NewItem , ppCmd ) )
			{
				iRv = -1 ;	//	Z̈ʒusłB
			}
		}
		else
		{
			if ( !createCmd( ECreateCmd_Select , ppCmd ) ) 
			{
				iRv = -1 ;
			}
		}
	}
	// ****************************************************************
	if ( !bQueryEnable && iRv >= 0 )
	{
		// ****************************************************************
		//	R}h̎s
		// ****************************************************************
		CdEkiTrack2XColSpec	aXColSpec = getXColSpecOfFocus() ;
		int iFocusItem = -1 ;
		switch( aXColSpec.getColumnType() )
		{
		case aXColSpec.ColumnType_TrackName:	iFocusItem = 0 ;	break ;
		case aXColSpec.ColumnType_TrackRyakusyou:	iFocusItem = 1 ;	break ;
		case aXColSpec.ColumnType_MainTrack:	iFocusItem = 2 ;	break ;
		}
		CDlgEkiTrack2Prop	aDlg(
			bInsert,
			pCmd->getCaMuiSelect()->getMuPtr(),
			iFocusItem , 
			&m_CKeyinputSenderToModalDlg , this ) ;
		if ( aDlg.DoModal() == IDOK )
		{
			iRv = 1 ;
		}			
		// --------------------------------
		//	_CAOOK̏
		// --------------------------------
		if ( iRv == 1 )
		{
			// --------------------------------
			//	ҏWR}hs
			// --------------------------------
			getCDiagramEditDoc()->executeEditCmd( pCmd ) ;
		}
		// ****************************************************************
		//	G[bZ[W
		// ****************************************************************
	}
	return iRv ;
		

}

CEkiTrack2Doc * CWndDcdGridEkiTrack2::GetDocument()
{
	CView* pCView = (CView*)GetParent();
	return (CEkiTrack2Doc*)pCView->GetDocument();
}


// ----------------------------------------------------------------
//	MFC
// ----------------------------------------------------------------
BEGIN_MESSAGE_MAP(CWndDcdGridEkiTrack2,CWndDcdGridEkiTrack2::super)
	//{{AFX_MSG_MAP(CWndDcdGridEkiTrack2)
	ON_WM_CREATE()
	ON_WM_KEYUP()
	ON_WM_LBUTTONDBLCLK()
	ON_WM_KEYDOWN()
	ON_COMMAND(ID_EkiTrack2_Prop, OnEDITEkiTrack2Prop)
	ON_UPDATE_COMMAND_UI(ID_EkiTrack2_Prop, &CWndDcdGridEkiTrack2::OnUpdateEkiTrack2Prop)
	ON_COMMAND(ID_EkiTrack2_Insert, OnEDITEkiTrack2Insert)
	ON_UPDATE_COMMAND_UI(ID_EkiTrack2_Insert, &CWndDcdGridEkiTrack2::OnUpdateEkiTrack2Insert)
	ON_COMMAND(ID_EDIT_CLEAR, OnEditClear)
	ON_UPDATE_COMMAND_UI(ID_EDIT_CLEAR, OnUpdateEditClear)
	ON_COMMAND(ID_EDIT_CUT, OnEditCut)
	ON_UPDATE_COMMAND_UI(ID_EDIT_CUT, OnUpdateEditCut)
	ON_COMMAND(ID_EDIT_COPY, OnEditCopy)
	ON_UPDATE_COMMAND_UI(ID_EDIT_COPY, OnUpdateEditCopy)
	ON_COMMAND(ID_EDIT_PASTE, OnEditPaste)
	ON_UPDATE_COMMAND_UI(ID_EDIT_PASTE, OnUpdateEditPaste)
	ON_COMMAND(ID_EkiTrack2_Up, OnEkiTrack2Up)
	ON_UPDATE_COMMAND_UI(ID_EkiTrack2_Up, OnUpdateEkiTrack2Up)
	ON_COMMAND(ID_EkiTrack2_Down, OnEkiTrack2Down)
	ON_UPDATE_COMMAND_UI(ID_EkiTrack2_Down, OnUpdateEkiTrack2Down)
	ON_WM_CONTEXTMENU()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

int CWndDcdGridEkiTrack2::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (super::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// --------------------------------
	//	Ԏʃr[ɎgptHg
	// --------------------------------
	CdFontProp fontpropDefault = createFontProp() ;

	// --------------------------------
	//	̐w
	// --------------------------------
	getCXDcdGrid()->setXColumnCount( XCOLUMNNCOUNT ) ;
	getCXDcdGrid()->setYColumnCount(YCOLUMNNNO_EKITRACK2_0 + YCOLUMNNCOUNT_BLANK ) ;
	getCXDcdGrid()->setYFixColumnCount(YCOLUMNNNO_EKITRACK2_0) ;

	// --------------------------------
	//	̃TCYݒ
	// --------------------------------
	{
		CDcdTargetGetDC	aCDcdTarget( NULL ) ;
		// --------------------------------
		//	X
		// --------------------------------
		{
			//	Ԑԍ
			CdDcdSizeXy	sizeEkiTrack2;
			CDcdTextbox	aCDcdTextbox( 
				_T("0") ,
				fontpropDefault ,
				_T("") , 1 , 2 , 2 ) ;
			aCDcdTextbox.getItemSize( &aCDcdTarget , &sizeEkiTrack2) ;
			getCXDcdGrid()->getXColumn(XCOLUMNNNO_EKITRACK2NO)->setColumnSize(sizeEkiTrack2.getX() ) ;
		}
		{
			//	Ԑ
			CdDcdSizeXy	sizeEkiTrack2;
			CDcdTextbox	aCDcdTextbox( 
				_T("ssssss") ,
				fontpropDefault ,
				_T("") , 1 , 2 , 2 ) ;
			aCDcdTextbox.getItemSize( &aCDcdTarget , &sizeEkiTrack2) ;
			getCXDcdGrid()->getXColumn(XCOLUMNNNO_EKITRACK2)->setColumnSize(sizeEkiTrack2.getX() ) ;
		}
		{
			//	Ԑ
			CdDcdSizeXy	sizeEkiTrack2;

			CDcdTextbox	aCDcdTextbox( 
				_T("ss") ,
				fontpropDefault ,
				_T("") , XCOLUMNNNO_ETRYAKUSYOU, 2 , 2 ) ;
			aCDcdTextbox.getItemSize( &aCDcdTarget , &sizeEkiTrack2) ;

			getCXDcdGrid()->getXColumn(XCOLUMNNNO_ETRYAKUSYOU)->setColumnSize(sizeEkiTrack2.getX() ) ;
		}
		{
			//	{ݒ
			CdDcdSizeXy	sizeEkiTrack2;

			CDcdTextbox	aCDcdTextbox(
				_T("sss"),
				fontpropDefault,
				_T(""), XCOLUMNNNO_MAINTRACK, 2, 2);
			aCDcdTextbox.getItemSize(&aCDcdTarget, &sizeEkiTrack2);

			getCXDcdGrid()->getXColumn(XCOLUMNNNO_MAINTRACK)->setColumnSize(sizeEkiTrack2.getX());
		}
		// --------------------------------
		//	Y
		// --------------------------------
		{
			CdDcdSizeXy	sizeEkiTrack2;
			CDcdTextbox	aCDcdTextbox( 
				_T("ssssss") ,
				fontpropDefault ,
				_T("") , 1 , 2 , 2 ) ;
			aCDcdTextbox.getItemSize( &aCDcdTarget , &sizeEkiTrack2) ;

			getCXDcdGrid()->getYColumn( YCOLUMNNNO_HEADER )->setColumnSize(sizeEkiTrack2.getY() ) ;
			getCXDcdGrid()->getYColumn(YCOLUMNNNO_EKITRACK2_0)->setColumnSize(sizeEkiTrack2.getY() ) ;
		}
	}
	// --------------------------------
	//	ŏɑƃeLXgݒ
	// --------------------------------
	{
		// ʔԍ
		Ou<CDcdTextbox>	pCDcdTextbox = 
			getCXDcdGrid()->getCell(XCOLUMNNNO_EKITRACK2NO, YCOLUMNNNO_HEADER )->getIfDcDraw() ;
		
		CConverter_WinGdi aCConverter_WinGdi ;
		
		CdDrawTextProp	aCdDrawTextProp( 
			fontpropDefault ,
			aCConverter_WinGdi.CdColorPropOfSysColor( COLOR_MENUTEXT ) ) ;
		CdBrushProp	aCdBrushProp( 
			aCConverter_WinGdi.CdColorPropOfSysColor( COLOR_MENU ) ) ;

		pCDcdTextbox->setCdDrawTextProp( aCdDrawTextProp ) ;
		pCDcdTextbox->setCdBrushProp( aCdBrushProp )  ;
	}
	{
		// ʖ
		CString	aString ;
		aString.LoadString(IDS_WORD_EkiTrackName) ;//ŗvݒ

		Ou<CDcdTextbox>	pCDcdTextbox = 
			getCXDcdGrid()->getCell(XCOLUMNNNO_EKITRACK2, YCOLUMNNNO_HEADER )->getIfDcDraw() ;
		
		CConverter_WinGdi aCConverter_WinGdi ;
		
		CdDrawTextProp	aCdDrawTextProp( 
			fontpropDefault ,
			aCConverter_WinGdi.CdColorPropOfSysColor( COLOR_MENUTEXT ) ) ;
		CdBrushProp	aCdBrushProp( 
			aCConverter_WinGdi.CdColorPropOfSysColor( COLOR_MENU ) ) ;

		pCDcdTextbox->setCdDrawTextProp( aCdDrawTextProp ) ;
		pCDcdTextbox->setCdBrushProp( aCdBrushProp )  ;
		pCDcdTextbox->setText( (LPCTSTR)aString ) ;
	}
	{
		// 
		CString	aString ;
		aString.LoadString(IDS_WORD_TrackRyakusyou) ;//ŗvݒ?

		Ou<CDcdTextbox>	pCDcdTextbox = 
			getCXDcdGrid()->getCell(XCOLUMNNNO_ETRYAKUSYOU, YCOLUMNNNO_HEADER )->getIfDcDraw() ;
		
		CConverter_WinGdi aCConverter_WinGdi ;


		CdDrawTextProp	aCdDrawTextProp( 
			fontpropDefault ,
			aCConverter_WinGdi.CdColorPropOfSysColor( COLOR_MENUTEXT ) ) ;
		CdBrushProp	aCdBrushProp( 
			aCConverter_WinGdi.CdColorPropOfSysColor( COLOR_MENU ) ) ;

		pCDcdTextbox->setCdDrawTextProp( aCdDrawTextProp ) ;
		pCDcdTextbox->setCdBrushProp( aCdBrushProp )  ;
		pCDcdTextbox->setText( (LPCTSTR)aString ) ;
	}
	{
		// {
		CString	aString;
		aString.LoadString(IDS_WORD_MainTrack);//ŗvݒ

		Ou<CDcdTextbox>	pCDcdTextbox =
			getCXDcdGrid()->getCell(XCOLUMNNNO_MAINTRACK, YCOLUMNNNO_HEADER)->getIfDcDraw();

		CConverter_WinGdi aCConverter_WinGdi;


		CdDrawTextProp	aCdDrawTextProp(
			fontpropDefault,
			aCConverter_WinGdi.CdColorPropOfSysColor(COLOR_MENUTEXT));
		CdBrushProp	aCdBrushProp(
			aCConverter_WinGdi.CdColorPropOfSysColor(COLOR_MENU));

		pCDcdTextbox->setCdDrawTextProp(aCdDrawTextProp);
		pCDcdTextbox->setCdBrushProp(aCdBrushProp);
		pCDcdTextbox->setText((LPCTSTR)aString);
	}
	// --------------------------------
	//	tH[JXZ̏ʒuݒ
	// --------------------------------
	getCFocus()->setFocusCell( getCXDcdGrid()->getCell( 0 , YCOLUMNNNO_EKITRACK2_0) ) ;
	// --------------------------------
	//	\XV
	// --------------------------------
	InvalidateGrid() ;

	
	return 0;
}

void CWndDcdGridEkiTrack2::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags)
{
	// ****************************************************************
	//	R}h̗LE
	// ****************************************************************

	//	tH[JXZVKACeʒuɂƂ́A
	//	uVKACẽvpeB͂sA𖖔ɑ}vƂ
	//	ɂȂ܂B
	bool bInsert = false ;
	CdEkiTrack2YColSpec aYColSpec = getYColSpecOfFocus() ;
	if ( aYColSpec.getColumnType() == CdEkiTrack2YColSpec::ColumnType_NewEkiTrack2)
	{
		bInsert = true ;
	}

	// ****************************************************************
	//	R}h̎s
	// ****************************************************************
	//	L[ĂāA_CAO{bNXJĂȂꍇ
	//	_CAO{bNXJ܂B
	if ( CKeyinputSenderToModalDlg::AnyLetterOrDigitKeyIsDown() && 
			m_CKeyinputSenderToModalDlg.startSend() >= 0 )
	{
		m_CKeyinputSenderToModalDlg.OnKeyDown( nChar , nRepCnt , nFlags ) ;
		execEkiTrack2PropDlg( bInsert , FALSE ) ;
		m_CKeyinputSenderToModalDlg.endSend() ;
	}
	//	łɃ_CAON_CAO{bNXɃbZ[W]
	else	
	{
		if ( !m_CKeyinputSenderToModalDlg.OnKeyDown( nChar , nRepCnt , nFlags ) )
		{
			CWndDcdGridEkiTrack2::super::OnKeyDown(nChar, nRepCnt, nFlags);
		}
	}
			

}

void CWndDcdGridEkiTrack2::OnLButtonDblClk(UINT nFlags, CPoint point)
{
	int iRv = 0 ;
	// ****************************************************************
	//	R}h̗LE
	// ****************************************************************

	//	tH[JXZVKACeʒuɂƂ́A
	//	uVKACẽvpeB͂sA𖖔ɑ}vƂ
	//	ɂȂ܂B
	bool bInsert = false ;
	CdEkiTrack2YColSpec aYColSpec = getYColSpecOfFocus() ;
	if ( aYColSpec.getColumnType() == CdEkiTrack2YColSpec::ColumnType_NewEkiTrack2)
	{
		bInsert = true ;
	}
	// ****************************************************************
	//	R}h̎s
	// ****************************************************************
	iRv = execEkiTrack2PropDlg( bInsert , FALSE ) ;
}

void CWndDcdGridEkiTrack2::OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags)
{
	if ( !m_CKeyinputSenderToModalDlg.OnKeyUp( nChar , nRepCnt , nFlags ) )
	{
		CWndDcdGridEkiTrack2::super::OnKeyUp(nChar, nRepCnt, nFlags);
	}
}


void CWndDcdGridEkiTrack2::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint)
{
	if (lHint == LHINT_SUBVIEW_TO_ROOTDOC)
	{
		return;
	}
	// --------------------------------


	//iEkiIndex->iIDւ̎dlύXɔύX
	const CentDedEkiCont* pCentDedEkiCont = getCDiagramEditDoc()
		->getCDedRosenFileData()->getCentDedRosen()->getCentDedEkiCont();
	int iEkiIndex = pCentDedEkiCont->EkiIndexOfEkiID(GetDocument()->getEkiID());
	const Mu<const CentDedEkiTrack2*>* pCentDedEkiTrack2ContGet =
		pCentDedEkiCont->getMuPtr()->get(iEkiIndex)->getEkiTrack2Cont()->getMuPtr();

	//CDiagramEditDoc* pCDiagramEditDoc = getCDiagramEditDoc();
	//const CentDedRosen*	pCentDedRosen =
	//	pCDiagramEditDoc->getCDedRosenFileData()->getCentDedRosen();
	//ꉞύX
	//int iEkiIndex = GetDocument()->getEkiIndex();
	//const Mu< const CentDedEki* >* pCentDedEkiCont = getCDiagramEditDoc()->getCDedRosenFileData()
	//	->getCentDedRosen()->getCentDedEkiCont()->getMuPtr();
	//const Mu<const CentDedEkiTrack2*>* pCentDedEkiTrack2ContGet =
	//	pCentDedEkiCont->get(iEkiIndex)->getEkiTrack2Cont()->getMuPtr();
	int iDownMain = pCentDedEkiCont->get(iEkiIndex).getDownMain();
	int iUpMain = pCentDedEkiCont->get(iEkiIndex).getUpMain();
	//int iID= pCentDedEkiCont->get(iEkiIndex)->getID();

	//pHint= 
	//	pHint CRfEditCmdHolder IuWFNgȂA
	//	ΉҏWR}h CRfEditCmd ێĂ܂B
	//	̏ꍇAthis  CRfEditCmd ̓eɍœK
	//	XVs܂B
	//	NULLȂASXVvĂ܂B
	if (m_bUpdate_All_Requested)
	{
		//	SXVۗĂꍇ́A
		//	̌̓R}hɂœKꂽP̂̂ȂXVvɑ΂ĂASXVs܂B
		pHint = NULL;
	}


	Ou<CRfEditCmd> pCmd;
	if (pHint != NULL && pHint->IsKindOf(RUNTIME_CLASS(CRfEditCmdHolder)))
	{

		CRfEditCmdHolder* pHolder =
			(CRfEditCmdHolder*)pHint;
		pCmd = pHolder->getCmd();
	}

	if ( pCmd != NULL )
	{
		if ( dynamic_castOu<CRfEditCmd_Comment>( pCmd ) || 
			dynamic_castOu<CRfEditCmd_Dia>( pCmd ) || 
			dynamic_castOu<CRfEditCmd_DiaProp>( pCmd ) || 
			dynamic_castOu<CRfEditCmd_Ressya>( pCmd ) ||
			dynamic_castOu<CRfEditCmd_Ressyasyubetsu>( pCmd ) ||
			dynamic_castOu<CRfEditCmd_Operation>(pCmd)
		)
		{
			//	̃r[́A
			//		Rg̕ύX
			//		_C̕ύX
			//		_C̑̕ύX
			//		Ԃ̕ύX
			//		Ԏʂ̕ύX
			//	̏ꍇ́AXVs܂B
		}
		//	Ԑ̕ύX
		else if ( dynamic_castOu<CRfEditCmd_EkiTrack2>( pCmd ) )
		{
			Ou<CRfEditCmd_EkiTrack2>	pCommand =
				dynamic_castOu<CRfEditCmd_EkiTrack2>( pCmd );
			if (!(pCommand->getEkiIndex() == iEkiIndex)) {
				//ҏWwȊȌꍇ́ẢwƌqĂwTA
				//̒ɕҏWw݂XVB
				std::deque<int> iEkiIndexBrunchLoop;
				int iSize = pCentDedEkiCont->getEkiIndexBrunchLoop(iEkiIndex, iEkiIndexBrunchLoop);
				bool bSearch=false;
				for (int idx = 0; idx < iSize; idx++)
				{
					if (iEkiIndexBrunchLoop[idx] == pCommand->getEkiIndex())
					{
						bSearch = true;
						break;
					}
				}
				if(!bSearch)
				{
					return;
				}
				//ҏWwȊȌꍇ́AҏWwiBrunchCoreEkiIndexQlɁAXVΏۂ߂B
				//int iBrunchCoreEkiIndex = pCentDedEkiCont->get(pCommand->getEkiIndex()).getBrunchCoreEkiIndex();
				//if (iBrunchCoreEkiIndex < 0)
				//{
				//	//ҏWwiBrunchCoreEkiIndex-1̎́ẢwiBrunchCoreEkiIndex
				//	//ҏWwiEkiindexƈvꍇɍXVB
				//	if (pCentDedEkiCont->get(iEkiIndex).getBrunchCoreEkiIndex() !=
				//		pCommand->getEkiIndex())
				//	{
				//		return;
				//	}
				//}
				//else
				//	//ҏWwiBrunchCoreEkiIndex0ȏ̎́A
				//	//̉wiEkiIndexiBrunchCoreEkiIndexvƂ
				//	//̉wiBrunchCoreEkiIndexiBrunchCoreEkiIndexvƂɍXV܂
				//{
				//	if (iEkiIndex != iBrunchCoreEkiIndex &&
				//		pCentDedEkiCont->get(iEkiIndex).getBrunchCoreEkiIndex() != iBrunchCoreEkiIndex)
				//	{
				//		return;
				//	}
				//}
			}
			//	R}hIuWFNgsɂZړŃZIɂȂȂ悤ɁA
			//	ZIAZI@\ꎞIɒ~܂B
			clearSelect() ;
			CPropStack aPropStack( this ) ;
			aPropStack
				.CBoxSelect_setIsEnable( false )
				.CRandomSelect_setIsEnable( false )  ;

			// --------------------------------
			//	̗vf̍폜
			// --------------------------------
			const CentDedEkiTrack2Cont*	pCentDedEkiTrack2ContSrc = pCommand->getCentDedEkiTrack2ContSrc() ;
			int iGensyouSize = pCommand->getSizeDst() - pCentDedEkiTrack2ContSrc->size() ;
			if ( iGensyouSize > 0 ){
				for ( int cnt = 0 ; cnt < iGensyouSize ; cnt ++ ){
					getCXDcdGrid()->eraseYColumn( 
						pCommand->getIndexDst() + 
						pCommand->getSizeDst() - iGensyouSize 
						+ 1 ) ;
				}
			}
			// --------------------------------
			//	̗vf̒ǉ
			// --------------------------------
			int iOkikaeSize = 0 ;
			iOkikaeSize = min( pCommand->getSizeDst() , pCentDedEkiTrack2ContSrc->size() ) ;
			int iZoukaSize = pCentDedEkiTrack2ContSrc->size() - pCommand->getSizeDst() ;
			if ( iZoukaSize > 0 ){
				for ( int cnt = 0 ; cnt < iZoukaSize ; cnt ++ ){
					getCXDcdGrid()->insertYColumn( 
						pCommand->getIndexDst() + iOkikaeSize + cnt + 1 , 
						true ) ; 
				}
			}
			// --------------------------------
			//	vf̍XV
			// --------------------------------
			{					
				for ( int cnt = 0 ; cnt < pCentDedEkiTrack2ContSrc->size() ; cnt ++ ){
					int iEkiTrack2Index = pCommand->getIndexDst() + cnt ;
					const CentDedEkiTrack2*	pCentDedEkiTrack2 = pCentDedEkiTrack2ContGet->get( iEkiTrack2Index ) ;
					OnUpdate_setCentDedEkiTrack2_To_Column(
						iEkiTrack2Index + 1 , *pCentDedEkiTrack2,
						iDownMain,iUpMain) ;
				}
			}
			// --------------------------------
			//	ԐԍXV
			// --------------------------------
			OnUpdate_setEkiTrack2NoXColumn() ;
		}
		//	wԐ̓
		else if ( dynamic_castOu<CRfEditCmd_EkiTrack2Swap>( pCmd ) )
		{
			Ou<CRfEditCmd_EkiTrack2Swap>	pCommand =
				dynamic_castOu<CRfEditCmd_EkiTrack2Swap>( pCmd );
			if (!(pCommand->getEkiIndex() == iEkiIndex)) {
				//ҏWwȊȌꍇ́ẢwƌqĂwTA
				//̒ɕҏWw݂XVB
				std::deque<int> iEkiIndexBrunchLoop;
				int iSize = pCentDedEkiCont->getEkiIndexBrunchLoop(iEkiIndex, iEkiIndexBrunchLoop);
				bool bSearch = false;
				for (int idx = 0; idx < iSize; idx++)
				{
					if (iEkiIndexBrunchLoop[idx] == pCommand->getEkiIndex())
					{
						bSearch = true;
						break;
					}
				}
				if (!bSearch)
				{
					return;
				}
			}
			// --------------------------------
			//	vf̍XV
			// --------------------------------
			{					
				{
					int iEkiTrack2Index = pCommand->getEkiTrack2IndexA() ;
					const CentDedEkiTrack2*	pCentDedEkiTrack2 =
						pCentDedEkiTrack2ContGet->get( iEkiTrack2Index ) ;
					OnUpdate_setCentDedEkiTrack2_To_Column(
						iEkiTrack2Index + 1 , *pCentDedEkiTrack2,
						iDownMain,iUpMain) ;
				}
				{
					int iEkiTrack2Index = pCommand->getEkiTrack2IndexB() ;
					const CentDedEkiTrack2*	pCentDedEkiTrack2 =
						pCentDedEkiTrack2ContGet->get( iEkiTrack2Index ) ;
					OnUpdate_setCentDedEkiTrack2_To_Column(
						iEkiTrack2Index + 1 , *pCentDedEkiTrack2,
						iDownMain,iUpMain) ;
				}
			}
			// --------------------------------
			//	ԐԍXV
			// --------------------------------
			OnUpdate_setEkiTrack2NoXColumn() ;
		}
		//else if (dynamic_castOu<CRfEditCmd_Eki>(pCmd))
		//{
			//Ou<CRfEditCmd_Eki>	pCommand =
			//	dynamic_castOu<CRfEditCmd_Eki>(pCmd);
			//if (!(pCommand->getEkiIndex() == iEkiIndex)) {
			//	//ҏWwȊȌꍇ́ẢwƌqĂwTA
			//	//̒ɕҏWw݂XVB
			//	std::deque<int> iEkiIndexBrunchLoop;
			//	int iSize = pCentDedEkiCont->getEkiIndexBrunchLoop(iEkiIndex, iEkiIndexBrunchLoop);
			//	bool bSearch = false;
			//	for (int idx = 0; idx < iSize; idx++)
			//	{
			//		if (iEkiIndexBrunchLoop[idx] == pCommand->getEkiIndex())
			//		{
			//			bSearch = true;
			//			break;
			//		}
			//	}
			//	if (!bSearch)
			//	{
			//		return;
			//	}
			//}
		//	pHint = NULL;
		//}
		else
		{
			//CRfEditCmd_DedRosenFileDataProp
			//	  Ht@C̃vpeB̕ύX́A
			//	tHg̕ω𔺂߁ASXVKvłB
			//CRfEditCmd_Rosen
			//CRfEditCmd_RosenFileData
			//	Ԏʂ܂IuWFNgłBꂪXVꂽꍇ́A
			//	SXVKvłB
			pHint = NULL ;
		}
	}
	if ( pHint == NULL )
	{
		// --------------------------------		
		//	SvfXV
		// --------------------------------
		CView *pView = getCDiagramEditApp()->getCMainFrame()->
			getMDIChildActiveView() ;
		if ( GetParent() == pView )
		{
			OnUpdate_All() ;
		}
		else
		{
			LogMsg(_T("CWndDcdGridEkiTrack2::OnUpdate()")
				_T("m_bUpdate_All_Requested=true") ) ;
			m_bUpdate_All_Requested = true ;
		}
	}
	
	// --------------------------------
	//	I͈͂ݒ
	// --------------------------------
	{
		//CDiagramEditDoc* pCDiagramEditDoc = getCDiagramEditDoc() ;
		//const CentDedRosen*	pCentDedRosen = 
		//	pCDiagramEditDoc->getCDedRosenFileData()->getCentDedRosen() ;
		////ꉞύX
		//int iEkiIndex = GetDocument()->getEkiIndex();
		//const Mu< const CentDedEki* >* pCentDedEkiCont = getCDiagramEditDoc()->getCDedRosenFileData()
		//	->getCentDedRosen()->getCentDedEkiCont()->getMuPtr();
		const Mu<const CentDedEkiTrack2*>* pMuCentDedEkiTrack2 =
			pCentDedEkiCont->getMuPtr()->get(iEkiIndex)->getEkiTrack2Cont()->getMuPtr();

		int iYColumnBegin = createYColSpecCont().ColumnNumberFromSpec( 
			CdEkiTrack2YColSpec( CdEkiTrack2YColSpec::ColumnType_EkiTrack2, 0 ) ) ;

		getCSelect()->setColumnNumberSelectLimit(
			CdDcdZoneXy( 
				CdDcdZone( 0 , INT_MAX ) , 
				CdDcdZone( iYColumnBegin , pMuCentDedEkiTrack2->size()   )
			) );
	}

}

void CWndDcdGridEkiTrack2::OnEDITEkiTrack2Prop()
{
	OnEDITEkiTrack2Prop_Process( FALSE ) ;
}


void CWndDcdGridEkiTrack2::OnEDITEkiTrack2Insert()
{
	OnEDITEkiTrack2Insert_Process( FALSE );
}

void CWndDcdGridEkiTrack2::OnEditClear()
{
	OnEditClear_Process( FALSE ) ;
	
}

void CWndDcdGridEkiTrack2::OnUpdateEditClear(CCmdUI* pCmdUI)
{
	pCmdUI->Enable( OnEditClear_Process( TRUE ) >= 0 ) ;
}

void CWndDcdGridEkiTrack2::OnEditCut()
{
	OnEditCut_Process( FALSE );
}

void CWndDcdGridEkiTrack2::OnUpdateEditCut(CCmdUI* pCmdUI)
{
	pCmdUI->Enable( OnEditCut_Process( TRUE ) >= 0 ) ;
}

void CWndDcdGridEkiTrack2::OnEditCopy()
{
	OnEditCopy_Process( FALSE );
}

void CWndDcdGridEkiTrack2::OnUpdateEditCopy(CCmdUI* pCmdUI)
{
	pCmdUI->Enable( OnEditCopy_Process( TRUE ) >= 0 ) ;
}

void CWndDcdGridEkiTrack2::OnEditPaste()
{
	OnEditPaste_Process( FALSE );
}

void CWndDcdGridEkiTrack2::OnUpdateEditPaste(CCmdUI* pCmdUI)
{
	pCmdUI->Enable( OnEditPaste_Process( TRUE ) >= 0 ) ;
}

void CWndDcdGridEkiTrack2::OnEkiTrack2Up()
{
	OnEkiTrack2Up_Process( FALSE );

}

void CWndDcdGridEkiTrack2::OnUpdateEkiTrack2Up(CCmdUI* pCmdUI)
{
	pCmdUI->Enable( OnEkiTrack2Up_Process( TRUE ) >= 0 ) ;

}

void CWndDcdGridEkiTrack2::OnEkiTrack2Down()
{
	OnEkiTrack2Down_Process( FALSE ) ;
}

void CWndDcdGridEkiTrack2::OnUpdateEkiTrack2Down(CCmdUI* pCmdUI)
{
	pCmdUI->Enable( OnEkiTrack2Down_Process( TRUE ) >= 0 ) ;
}
void CWndDcdGridEkiTrack2::OnActivateView(BOOL bActivate, CView* pActivateView, CView* pDeactiveView)
{
	LogMsg(_T("CWndDcdGridEkiTrack2::OnActivateView(%d,,)") , bActivate ) ;
	
	if ( bActivate && m_bUpdate_All_Requested )
	{
		OnUpdate_All() ;
	}
}

void CWndDcdGridEkiTrack2::OnUpdateEkiTrack2Insert(CCmdUI *pCmdUI)
{
	pCmdUI->Enable( OnEDITEkiTrack2Insert_Process( TRUE ) >= 0 ) ;
}

void CWndDcdGridEkiTrack2::OnUpdateEkiTrack2Prop(CCmdUI *pCmdUI)
{
	pCmdUI->Enable( OnEDITEkiTrack2Prop_Process( TRUE ) >= 0 ) ;
}

void CWndDcdGridEkiTrack2::OnContextMenu(CWnd* pWnd, CPoint point)
{
	CMenu	aMenu ;
	aMenu.LoadMenu( IDR_MENU_EKITRACK2VIEW_CONTEXT ) ;//vݒ
	CMenu* pContextMenu = aMenu.GetSubMenu( 0 ) ;

	//	ReLXgj[}EXȊOŌĂяoꂽꍇ́A
	//	ReLXgj[̕\ʒúAtH[JXZ̒̈ʒuƂ܂B
	if ( point.x ==-1 || point.y == -1 )
	{
		//	ReLXgj[}EXȊOŌĂяo܂
		CdDcdPosXy posxyFocusCellColumnNumber = getCFocus()->getFocusCellColumnNumber() ;
		if ( posxyFocusCellColumnNumber !=  
				CFocus::ColumnNumberPosXy_NULL() )
		{
			CdDcdZoneXy	zonexyFocusCell = getCellZone( 
				posxyFocusCellColumnNumber.getX() , 
				posxyFocusCellColumnNumber.getY() ) ;
			point.x = zonexyFocusCell.getX().getPos() + zonexyFocusCell.getX().getSize() / 2 ;
			point.y = zonexyFocusCell.getY().getPos() + zonexyFocusCell.getY().getSize() / 2 ;
			ClientToScreen( &point ) ;
		}
	}
	//point = ReLXgj[̕\ʒuB
	//	-1̏ꍇ́AReLXgj[͕\ł܂B

	if ( point.x >= 0 &&  point.y >= 0 )
	{
		pContextMenu->TrackPopupMenu( 
			TPM_LEFTALIGN | TPM_RIGHTBUTTON ,
			point.x , point.y , 
			AfxGetMainWnd() ) ;	//	this w肷ƁAAppDocView 
								//R}h`F[삵܂B
	}
	else
	{
		super::OnContextMenu(pWnd, point);
	}
}
} //namespace ViewEkiTrack2
