/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
// cdlgmodifyekijikokuoperation2.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "..\diagramedit.h"
#include "cdlgmodifyekijikokuoperation2.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

namespace ViewJikokuhyou{

/////////////////////////////////////////////////////////////////////////////
// CDlgModifyEkijikokuOperation2 _CAO
// --------------------------------
//@name ֐
// --------------------------------
bool CDlgModifyEkijikokuOperation2::updateControl() 
{
	bool bRv = false ;
	{
		CWnd* pCWnd = GetDlgItem( IDC_RADIO_Ekiatsukai ) ;
		BOOL bCurrentState = pCWnd->IsWindowEnabled() ;
		CButton* pCChekcbox = (CButton*)GetDlgItem(IDC_CHECK_EkiatsukaiModify) ;
		BOOL bState = ( pCChekcbox->GetCheck() == 1 );

		if ( ( bState && !bCurrentState ) ||
			( !bState && bCurrentState ) )
		{
			GetDlgItem( IDC_RADIO_Ekiatsukai )->EnableWindow( bState ) ;
			GetDlgItem( IDC_RADIO_Ekiatsukai1 )->EnableWindow( bState ) ;
			GetDlgItem( IDC_RADIO_Ekiatsukai2 )->EnableWindow( bState ) ;
			GetDlgItem( IDC_RADIO_Ekiatsukai3 )->EnableWindow( bState ) ;
			bRv = true ;
		}
	}
	{
		CButton* pCWnd = (CButton*)GetDlgItem( IDC_RADIO_EkijikokuOperation1 ) ;
		BOOL bCurrentState = GetDlgItem( IDC_EDIT_Seconds1 )->IsWindowEnabled() ;
		BOOL bState = ( ( pCWnd->GetCheck() & 3 ) == 1 ) ;
		if ( ( bState && !bCurrentState ) ||
			( !bState && bCurrentState ) ){
			GetDlgItem( IDC_EDIT_Seconds1 )->EnableWindow( bState ) ;
			bRv = true ;
		}
	}
	{
		CButton* pCWnd = (CButton*)GetDlgItem( IDC_RADIO_EkijikokuOperation2 ) ;
		BOOL bState = ( ( pCWnd->GetCheck() & 3 ) == 1 ) ;

		{
			BOOL bCurrentState = GetDlgItem( IDC_COMBO_JikokuOrderCopySrc )->IsWindowEnabled() ;

			if ( ( bState && !bCurrentState ) ||
				( !bState && bCurrentState ) ){
				GetDlgItem( IDC_COMBO_JikokuOrderCopySrc )->EnableWindow( bState ) ;
				bRv = true ;
			}
		}
		{
			BOOL bCurrentState = GetDlgItem( IDC_EDIT_Seconds2 )->IsWindowEnabled() ;
			if ( ( bState && !bCurrentState ) ||
				( !bState && bCurrentState ) ){
				GetDlgItem( IDC_EDIT_Seconds2 )->EnableWindow( bState ) ;
				bRv = true ;
			}
		}
	}
	return bRv ;
}

int CDlgModifyEkijikokuOperation2::COMBO_JikokuOuderCopySrcFromJikokuOrder( 
		const CdDedJikokuOrder& aJikokuOrder ) 
{
	int iRv = -1 ;
	if ( !aJikokuOrder.getIsNull() )
	{
		iRv = aJikokuOrder.getEkiOrder() * 2 ;
		if ( aJikokuOrder.getEkiJikokuItem() == CdDedJikokuOrder::EkiJikokuItem_Hatsu )
		{
			iRv ++ ;
		}
	}
	return iRv ;
}

CdDedJikokuOrder 
CDlgModifyEkijikokuOperation2::COMBO_JikokuOuderCopySrcToJikokuOrder( 
		int iComboIndex ) 
{
	CdDedJikokuOrder	aRv ;
	if ( 0 <= iComboIndex && iComboIndex < (int)m_contstrEkimei.size() * 2 )
	{
		CdDedJikokuOrder::EEkiJikokuItem eEkiJikokuItem = CdDedJikokuOrder::EkiJikokuItem_Chaku ;
		if ( iComboIndex % 2 == 1 )
		{
			eEkiJikokuItem = CdDedJikokuOrder::EkiJikokuItem_Hatsu ;
		}
		aRv.setEkiOrder( iComboIndex / 2 , eEkiJikokuItem ) ;
	}
	return aRv ;
}

// ----------------------------------------------------------------
//	MFC
// ----------------------------------------------------------------

CDlgModifyEkijikokuOperation2::CDlgModifyEkijikokuOperation2(
 	CentDedRessya_EkijikokuModifyOperation2& aEkijikokuModifyOperation2 ,
	const Mu<CentDedEkiCont::CdDedEki>* pCentDedEkiContGet , 
	CWnd* pParent )
	: CDialog(CDlgModifyEkijikokuOperation2::IDD, pParent)
	, m_EkijikokuModifyOperation2( aEkijikokuModifyOperation2 ) 
{
	//{{AFX_DATA_INIT(CDlgModifyEkijikokuOperation2)
	m_iRADIO_Ekiatsukai = aEkijikokuModifyOperation2.getEkiatsukai() ;
	m_bCHECK_EkiatsukaiModify = aEkijikokuModifyOperation2.getSetEkiatsukai() ;
	m_iRADIO_EkijikokuOperation = aEkijikokuModifyOperation2.getOperation() ;
	m_iCOMBO_JikokuOuderCopySrc = -1 ;
	m_iEDIT_Seconds1 = aEkijikokuModifyOperation2.getSeconds();
	m_iEDIT_Seconds2 = aEkijikokuModifyOperation2.getSeconds();
	//}}AFX_DATA_INIT

	CdDedJikokuOrder	aJikokuOrderCopySrc = aEkijikokuModifyOperation2.getJikokuOrderCopySrc() ;
	m_iCOMBO_JikokuOuderCopySrc = aJikokuOrderCopySrc.getEkiOrder()*2 ;
	if ( aJikokuOrderCopySrc.getEkiJikokuItem() == CdDedJikokuOrder::EkiJikokuItem_Hatsu ){
		m_iCOMBO_JikokuOuderCopySrc ;
	}


	{
		int idxEki ;
		for ( idxEki = 0 ; idxEki < pCentDedEkiContGet->size() ; idxEki ++ )
		{
			m_contstrEkimei.push_back( pCentDedEkiContGet->get( idxEki ).getEkimei() ) ;
		}
	}
}


void CDlgModifyEkijikokuOperation2::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgModifyEkijikokuOperation2)
	DDX_Radio(pDX, IDC_RADIO_Ekiatsukai, m_iRADIO_Ekiatsukai);
	DDX_Check(pDX, IDC_CHECK_EkiatsukaiModify, m_bCHECK_EkiatsukaiModify);
	DDX_Radio(pDX, IDC_RADIO_EkijikokuOperation, m_iRADIO_EkijikokuOperation);
	DDX_CBIndex(pDX, IDC_COMBO_JikokuOrderCopySrc, m_iCOMBO_JikokuOuderCopySrc);
	DDX_Text(pDX, IDC_EDIT_Seconds1, m_iEDIT_Seconds1);
	DDX_Text(pDX, IDC_EDIT_Seconds2, m_iEDIT_Seconds2);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgModifyEkijikokuOperation2, CDialog)
	//{{AFX_MSG_MAP(CDlgModifyEkijikokuOperation2)
	ON_BN_CLICKED(IDC_RADIO_EkijikokuOperation, OnRADIOEkijikokuOperation)
	ON_BN_CLICKED(IDC_RADIO_EkijikokuOperation1, OnRADIOEkijikokuOperation1)
	ON_BN_CLICKED(IDC_RADIO_EkijikokuOperation3, OnRADIOEkijikokuOperation3)
	ON_BN_CLICKED(IDC_RADIO_EkijikokuOperation2, OnRADIOEkijikokuOperation2)
	ON_BN_CLICKED(IDC_CHECK_EkiatsukaiModify, OnCHECKEkiatsukaiModify)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgModifyEkijikokuOperation2 bZ[W nh

BOOL CDlgModifyEkijikokuOperation2::OnInitDialog() 
{
	CDialog::OnInitDialog();
	{
		CComboBox*	pCComnoBox = (CComboBox*)GetDlgItem( IDC_COMBO_JikokuOrderCopySrc ) ;
		CString	strChaku ;
		CString	strHatsu ;
		strChaku.LoadString( IDS_WORD_Chaku ) ;
		strHatsu.LoadString( IDS_WORD_Hatsu ) ;
		int idxEki ;
		for ( idxEki = 0 ; idxEki < (int)m_contstrEkimei.size() ; idxEki ++ )
		{
			CString	strItem ;
			strItem = m_contstrEkimei[idxEki].c_str() ;
			pCComnoBox->AddString( strItem + strChaku ) ;
			pCComnoBox->AddString( strItem + strHatsu ) ;
		}
		pCComnoBox->SetCurSel( 
			COMBO_JikokuOuderCopySrcFromJikokuOrder( 
				m_EkijikokuModifyOperation2.getJikokuOrderCopySrc() ) );
	}
	updateControl() ;
	
	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

void CDlgModifyEkijikokuOperation2::OnRADIOEkijikokuOperation() 
{
	updateControl() ;
	
}

void CDlgModifyEkijikokuOperation2::OnRADIOEkijikokuOperation1() 
{
	updateControl() ;
	
}

void CDlgModifyEkijikokuOperation2::OnRADIOEkijikokuOperation3() 
{
	updateControl() ;
	
}

void CDlgModifyEkijikokuOperation2::OnRADIOEkijikokuOperation2() 
{
	updateControl() ;
	
}

void CDlgModifyEkijikokuOperation2::OnOK() 
{
	int iRv = 0 ;
	if ( iRv >= 0 )
	{
		if ( !UpdateData() )
		{
			iRv = -1 ;	//	lsłB
		}
		else
		{
			m_EkijikokuModifyOperation2.setSetEkiatsukai( m_bCHECK_EkiatsukaiModify != FALSE ) ;
			m_EkijikokuModifyOperation2.setEkiatsukai( 
				(CentDedEkiJikoku::EEkiatsukai)m_iRADIO_Ekiatsukai ) ;
			m_EkijikokuModifyOperation2.setOperation( 
				(CentDedRessya_EkijikokuModifyOperation2::EOperation)m_iRADIO_EkijikokuOperation ) ;
			if ( m_EkijikokuModifyOperation2.getOperation() == 
				CentDedRessya_EkijikokuModifyOperation2::OperationModify )
			{
				m_EkijikokuModifyOperation2.setSeconds( m_iEDIT_Seconds1 ) ;
			}
			else if ( m_EkijikokuModifyOperation2.getOperation() == 
				CentDedRessya_EkijikokuModifyOperation2::OperationCopy )
			{
				m_EkijikokuModifyOperation2.setJikokuOrderCopySrc( 
					COMBO_JikokuOuderCopySrcToJikokuOrder( m_iCOMBO_JikokuOuderCopySrc ) ) ;
				m_EkijikokuModifyOperation2.setSeconds( m_iEDIT_Seconds2 ) ;
			}
		}
	}

	if ( iRv >= 0 )
	{
		CDialog::OnOK();
	}
}

void CDlgModifyEkijikokuOperation2::OnCHECKEkiatsukaiModify() 
{
	updateControl() ;
	
}
} //namespace ViewJikokuhyou

