/*
OuDiaSecond Copyright (C) 2017 diagram_mania

̃vÓAtake-okm쐬OuDia\tgEFAłB
̃vOpɂẮAtake-okmLڂ̉Lɏ܂B
*/
/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CentDedDgrEki.cpp
//	$Id: CentDedDgrEki.cpp 94 2012-09-29 12:11:37Z okm $
// ****************************************************************
*/
/** @file */
#include "stdafx.h"
#include <algorithm>
using namespace std ;

#include "CentDedDgrEki.h"

namespace entDgr{

// ****************************************************************
//	CentDedDgrEki
// ****************************************************************
// ********************************
//	RXgN^
// ********************************
CentDedDgrEki::CentDedDgrEki( const tstring&  strEkimei ,
		bool bIsSyuyoueki , 
		int iEkikanSaisyouSecKudari ,
		int iEkikanSaisyouSecNobori , 
		int	iDgrYSizeEkikanDefault , 
		EDiagramRessyajouhouHyouji eDiagramRessyajouhouHyoujiKudari ,
		EDiagramRessyajouhouHyouji eDiagramRessyajouhouHyoujiNobori ,
		int iDownMain,
		int iUpMain,
		int iBrunchCoreEkiIndex,
		bool bBrunchOpposite,
		int iLoopOriginEkiIndex,
		bool bLoopOpposite,
		int iDiagramTrackDisplay,
		vector<tstring> strOuterTerminalEkimei,
		const CentDedEkiTrack2Cont* pCentDedEkiTrack2Cont,
		bool bIncludeOpposite
		) :
		m_strEkimei( strEkimei ) ,
		m_bIsSyuyoueki( bIsSyuyoueki ) ,
		m_iEkikanSaisyouSecKudari( iEkikanSaisyouSecKudari ) ,
		m_iEkikanSaisyouSecNobori( iEkikanSaisyouSecNobori ) , 
		m_iDgrYSizeEkikanDefault( iDgrYSizeEkikanDefault ) ,
		m_eDiagramRessyajouhouHyoujiKudari( eDiagramRessyajouhouHyoujiKudari ),
		m_eDiagramRessyajouhouHyoujiNobori( eDiagramRessyajouhouHyoujiNobori ),
		m_iDownMain(iDownMain),
		m_iUpMain(iUpMain),
		m_iBrunchCoreEkiIndex(iBrunchCoreEkiIndex),
		m_bBrunchOpposite(bBrunchOpposite),
		m_iLoopOriginEkiIndex(iLoopOriginEkiIndex),
		m_bLoopOpposite(bLoopOpposite),
		m_iDiagramTrackDisplay(iDiagramTrackDisplay),
		m_strOuterTerminalEkimei(strOuterTerminalEkimei),
		m_bIncludeOpposite(bIncludeOpposite),
		m_iDgrYSize( 0 ) 
{

	for (int idx = 0; idx < pCentDedEkiTrack2Cont->size(); idx++)
	{
		const CentDedEkiTrack2 aCentDedEkiTrack2 = pCentDedEkiTrack2Cont->get(idx);
		CentDedDgrEkiTrack2 aCentDedDgrEkiTrack2(
			aCentDedEkiTrack2.getTrackName(),
			aCentDedEkiTrack2.getTrackRyakusyou(Ressyahoukou_Kudari),
			aCentDedEkiTrack2.getTrackRyakusyou(Ressyahoukou_Nobori)
		);
		m_MuCentDedDgrEkiTrack2.insert(aCentDedDgrEkiTrack2);

	}
	if (m_iDiagramTrackDisplay > 0)
	{
		m_iEkiTrackDisplaySpace = (m_MuCentDedDgrEkiTrack2.size() + 1) * m_iDgrYSizeEkikanDefault;
	}
	else
	{
		m_iEkiTrackDisplaySpace = 0;
	}

};
	

CentDedDgrEki::CentDedDgrEki() :
		m_bIsSyuyoueki( false ) ,
		m_iEkikanSaisyouSecKudari( 0 ) ,
		m_iEkikanSaisyouSecNobori( 0 ) ,
		m_iDgrYSizeEkikanDefault( 60 ),
		m_eDiagramRessyajouhouHyoujiKudari( DiagramRessyajouhouHyouji_Origin ),
		m_eDiagramRessyajouhouHyoujiNobori( DiagramRessyajouhouHyouji_Origin ),
		m_iDownMain(1),
		m_iUpMain(1),
		m_iBrunchCoreEkiIndex(-1),
		m_bBrunchOpposite(false),
		m_iLoopOriginEkiIndex(-1),
		m_bLoopOpposite(false),
		m_iDiagramTrackDisplay(0),
		m_bIncludeOpposite(false),
		m_iDgrYSize( 0 ) 
{
};

CentDedDgrEki::~CentDedDgrEki()
{
};
	
// ********************************
//	CentDedDgrEki
// ********************************
	// ********************************
	//@name	CentDedDgrEki-
	// ********************************
//int CentDedDgrEki::getDgrYZahyouKyori(bool bIsOrigin)const
//{ 
//	int iRv = 0 ;	
//	
//	if ( m_iEkikanSaisyouSecKudari > 0 && m_iEkikanSaisyouSecNobori > 0 )
//	{
//		iRv = min( m_iEkikanSaisyouSecKudari , m_iEkikanSaisyouSecNobori );
//	}
//	else if ( m_iEkikanSaisyouSecKudari > 0 && 
//			m_iEkikanSaisyouSecNobori <= 0 )
//	{
//		iRv = m_iEkikanSaisyouSecKudari ;
//	}
//	else if ( m_iEkikanSaisyouSecKudari <= 0 && 
//			m_iEkikanSaisyouSecNobori > 0 )
//	{
//		iRv = m_iEkikanSaisyouSecNobori ;
//	}
//
//	if (iRv == 0)
//	{
//		//	Ԑݒ̂ȂwԂ́w_COGeBeBYWxł̋
//		iRv = m_iDgrYSizeEkikanDefault;
//	}
//	if (bIsOrigin)
//	{
//		iRv += getDgrEkiTrackDisplaySpace();
//	}
//
//	return ( iRv ) ;		
//}
int CentDedDgrEki::getDgrYZahyouKyoriOrg()const
{
	int iRv = 0;

	if (m_iEkikanSaisyouSecKudari > 0 && m_iEkikanSaisyouSecNobori > 0)
	{
		iRv = min(m_iEkikanSaisyouSecKudari, m_iEkikanSaisyouSecNobori);
	}
	else if (m_iEkikanSaisyouSecKudari > 0 &&
		m_iEkikanSaisyouSecNobori <= 0)
	{
		iRv = m_iEkikanSaisyouSecKudari;
	}
	else if (m_iEkikanSaisyouSecKudari <= 0 &&
		m_iEkikanSaisyouSecNobori > 0)
	{
		iRv = m_iEkikanSaisyouSecNobori;
	}

	if (iRv == 0)
	{
		//	Ԑݒ̂ȂwԂ́w_COGeBeBYWxł̋
		iRv = m_iDgrYSizeEkikanDefault;
	}

	iRv += getDgrEkiTrackDisplaySpace();
	

	return (iRv);
}
int CentDedDgrEki::getDgrYZahyouKyoriTer()const
{
	int iRv = 0;

	if (m_iEkikanSaisyouSecKudari > 0 && m_iEkikanSaisyouSecNobori > 0)
	{
		iRv = min(m_iEkikanSaisyouSecKudari, m_iEkikanSaisyouSecNobori);
	}
	else if (m_iEkikanSaisyouSecKudari > 0 &&
		m_iEkikanSaisyouSecNobori <= 0)
	{
		iRv = m_iEkikanSaisyouSecKudari;
	}
	else if (m_iEkikanSaisyouSecKudari <= 0 &&
		m_iEkikanSaisyouSecNobori > 0)
	{
		iRv = m_iEkikanSaisyouSecNobori;
	}

	if (iRv == 0)
	{
		//	Ԑݒ̂ȂwԂ́w_COGeBeBYWxł̋
		iRv = m_iDgrYSizeEkikanDefault;
	}

	return (iRv);
}
int CentDedDgrEki::getDgrEkiTrackDisplaySpace() const
{
	//if (m_iDiagramTrackDisplay > 0)
	//{
	//	//ōݐ\\̏ꍇAN_EԐ(Ԑ)EI_
	//	//Ԑ+1@̕ԂKvɂȂBāAw܂ł̋
	//	return (m_MuCentDedDgrEkiTrack2.size() + 1) * m_iDgrYSizeEkikanDefault;
	//}
	//else
	//{
	//	return 0;
	//}
	return m_iEkiTrackDisplaySpace;
}
;

} //namespace entDgr
