/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
// ****************************************************************
//$Id: CconvDcDrawProp.h 92 2012-09-21 10:56:03Z okm $
// ****************************************************************
/** @file */
#pragma once
#include "DcdCd\DcDrawProp\CdFontProp.h"
#include "DcdCd\DcDrawProp\CdColorProp.h"
#include "DcdCd\DcDrawProp\CdDcdFreeLineProp.h"
#include "str\CdConnectedString2.h"

namespace DcDrawLib{
namespace DcdCd{
namespace DcDrawProp{

using namespace OuLib::Str;

/**
	DcDraw̒Pf[^̕ϊ@\񋟂܂B
*/
class CconvDcDrawProp
{
public:
	// ********************************
	//	RXgN^
	// ********************************
	CconvDcDrawProp(void);
	virtual ~CconvDcDrawProp(void);

public:
	// ********************************
	///@name CdFontProp
	// ********************************
	///@{
	/**
	  	CdFontProp ̑A CdConnectedString2 IuWFNgɒǉ܂B
	   @param aCdFontProp [in]
	  	ϊΏۂƂȂ CdFontProp w肵ĂB
	   @param pCdConnectedString2 [in,out]
	  	  ̊֐́ÃIuWFNgɁA CdConnectedString2::CdItem 
	  	ǉ܂B
	  	  ̃IuWFNg܂ŕێĂ CdConnectedString2::CdItem 
	  	ێ܂B
	   @return
	  	 0 ȏAG[Ȃ畉̐łB
	 */
	int CdFontProp_to_CdConnnectedString2( 
		const CdFontProp& aCdFontProp ,
		CdConnectedString2*	pCdConnectedString );

	/**
	  	 CdConnectedString2 IuWFNgA
	  	 CdFontProp_to_CdConnectedString2() Œǉ CdItem ǂݎA
	  	CdFontProp IuWFNg̑ɔf܂B
	   @param pCdFontProp [out]
	  	̊֐͂̃IuWFNg̑ɁA̓e𔽉f܂B
	   @param aCdConnectedString [in]
	  	 CdFontProp_to_CdConnectedString2() Œǉ CdItem 
	  	 CdConnectedString2 IuWFNgw肵ĂB
	   @return
	  	 0 ȏAG[Ȃ畉̐łB
	  	-	-12 ;	//	PointTextHeight ̒ls
	  	-	-22 ;	//	LogicalunitTextHeight ̒ls
	  	-	-32 ;	//	LogicalunitCellHeight ̒ls
	  	-	-42 ;	//	Facename ̒ls
	  	-	-52 ;	//	Bold ̒ls
	  	-	-62 ;	//	Itaric ̒ls
	  	-	-72 ;	//	Underline ̒ls
	  	-	-82 ;	//	StrikeOut ̒ls
	  	-	-92 ;	//	Escapement ̒ls
	 */
	int CdFontProp_from_CdConnectedString2( CdFontProp* pCdFontProp ,
		const CdConnectedString2& aCdConnectedString ) ;


	/**
	  	CdFontProp ̑Aɕϊ܂B
	   @param aCdFontProp [in]
	  	ϊΏۂƂȂ CdFontProp w肵ĂB
	   @return
	  	ϊʂԂ܂B
	 */
	tstring CdFontProp_to_string( const CdFontProp& aCdFontProp );

	/**
	  	 CdFontProp_to_string() ō쐬߂A
	  	CdFontProp IuWFNg̑ɔf܂B
	   @param pCdFontProp [out]
	  	̊֐͂̃IuWFNg̑ɁA̓e𔽉f܂B
	   @param aString [in]
	  	 CdFontProp_to_string() ō쐬w肵ĂB
	   @return
	  	 0 ȏAG[Ȃ畉̐łB
	  	-	-12 ;	//	PointTextHeight ̒ls
	  	-	-22 ;	//	LogicalunitTextHeight ̒ls
	  	-	-32 ;	//	LogicalunitCellHeight ̒ls
	  	-	-42 ;	//	Facename ̒ls
	  	-	-52 ;	//	Bold ̒ls
	  	-	-62 ;	//	Itaric ̒ls
	  	-	-72 ;	//	Underline ̒ls
	  	-	-82 ;	//	StrikeOut ̒ls
	  	-	-92 ;	//	Escapement ̒ls
	 */
	int CdFontProp_from_string( 
		CdFontProp* pCdFontProp , 
		const tstring& aString  );
	///@}
	// ********************************
	///@name CdColorProp
	// ********************************
	///@{
	/**
		aCdColorProp 𕶎ɕϊ܂B
	@param aCdColorProp [in]
		ϊ̒lw肵ĂB
	@return
		ϊʂԂ܂B
	*/
	tstring CdColorProp_to_string( const CdColorProp& aCdColorProp );

	/**
		 aCdColorProp ɕϊ܂B
	@param aString [in]
		ϊ̒lw肵ĂB
	@return
		ϊʂԂ܂B
	 */
	CdColorProp CdColorProp_from_string( const tstring& aString  );
	///@}
	// ********************************
	///@name CdDcdFreeLineProp
	// ********************************
	///@{
	/**
	  	CdDcdFreeLineProp ̑A CdConnectedString2 IuWFNgɒǉ܂B
	@param aCdDcdFreeLineProp [in]
	  	ϊΏۂƂȂ CdDcdFreeLineProp w肵ĂB
	@param pCdConnectedString2 [in,out]
	  	  ̊֐́ÃIuWFNgɁA CdConnectedString2::CdItem 
	  	ǉ܂B
	  	  ̃IuWFNg܂ŕێĂ CdConnectedString2::CdItem 
	  	ێ܂B
	@return
	  	 0 ȏAG[Ȃ畉̐łB

	*/
	int CdDcdFreeLineProp_to_CdConnectedString2( 
		const CdDcdFreeLineProp& aCdDcdFreeLineProp ,
		CdConnectedString2*	pCdConnectedString ) ;

	/**
	  	CdDcdFreeLineProp ̑Aɕϊ܂B
	@param aCdDcdFreeLineProp [in]
	  	ϊΏۂƂȂ CdFontProp w肵ĂB
	@return
	  	ϊʂԂ܂B
		sꍇ͋󕶎ƂȂ܂B
	*/
	tstring CdDcdFreeLineProp_to_string( 
		const CdDcdFreeLineProp& aCdDcdFreeLineProp );

	/**
	  	CdDcdFreeLineProp_to_CdConnectedString2 ō쐬
		*pCdConnectedString ̓eA
		CdDcdFreeLineProp IuWFNgɔf܂B
	@param pCdDcdFreeLineProp [out]
		̊֐͂̃IuWFNg̑ɁA̓e𔽉f܂B
	@param aCdConnectedString [in]
		 CdDcdFreeLineProp_to_CdConnectedString2() Œǉ CdItem 
		 CdConnectedString2 IuWFNgw肵ĂB
	@return
	  	 0 ȏAG[Ȃ畉̐łB
		-	-11 ;	//	LogicalunitWidth ̒lsł
		-	-12 ;	//	Color ̒lsł

	*/
	int CdDcdFreeLineProp_from_CdConnectedString2( 
		CdDcdFreeLineProp* pCdDcdFreeLineProp ,
		const CdConnectedString2*	pCdConnectedString ) ;

	/**
	  	CdDcdFreeLineProp_to_CdConnectedString2 ō쐬
		*pCdConnectedString ̓eA
		CdDcdFreeLineProp IuWFNgɔf܂B
	@param pCdDcdFreeLineProp [out]
		̊֐͂̃IuWFNg̑ɁA̓e𔽉f܂B
	@param aString [in]
		 CdDcdFreeLineProp_to_string() Ő
		 w肵ĂB
	@return
	  	 0 ȏAG[Ȃ畉̐łB
		-	-11 ;	//	LogicalunitWidth ̒lsł
		-	-12 ;	//	Color ̒lsł
	*/
	int CdDcdFreeLineProp_from_string( 
		CdDcdFreeLineProp* pCdDcdFreeLineProp ,
		const tstring& aString  );

	///@}

};

} //namespace DcDrawProp
} //namespace DcdCd
} //namespace DcDrawLib
