/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CDcdGrid.h
// ****************************************************************
*/
/** @file */

#ifndef  CDcdGrid_h
#define  CDcdGrid_h
#include <limits.h>

#include <deque>

#include "DcDraw/IfDcDraw.h"
#include "DcDraw/CaDcdTargetClip.h"

#include "DcdGrid/CDcdGridYColumn.h"
#include "DcdGrid/CDcdGridXColumn.h"
#include "DcdGrid/CDcdGridCell.h"

namespace DcDrawLib{
namespace DcdGrid{

// ****************************************************************
//	CDcdGrid
// ****************************************************************
/**
@brief
 Obh`悷NXłB
  
  Cӂ̐YEX쐬AZɃeLXgzu邱Ƃł܂B
  eLXgzuƁA DcDraw() \bhgāACӂDC
(IfDcdTargetIuWFNg)ɑ΂ăObh̕`sƂł܂B

g|Obh`ăZɃeLXg`
 ================================================================

PD  setYColumnCount() E setXColumnCount() gAObhY񐔁E
X񐔂w肵ĂB

QD  eYEX̃TCYiEjݒ肵ĂBYԍEXԍ
w肵āiォ0N_̐j getYColumn() E getXColumn() 
ĂяoƂɂAYEX\ CDcdGridYColumn E CDcdGridXColumn IuWFNg
|C^擾邱Ƃł܂B
eYEX̃TCÝAIuWFNgɑ΂
 CDcdGridXColumn::setColumnSize() , CDcdGridYColumn::setColumnSize() 
Őݒ肵ĂBPʂ́A_PʂłB

RD  YԍEXԍw肵 getCell() ĂяoƂɂAZ\
 CDcdGridCell IuWFNg̃|C^擾邱Ƃł܂B
CDcdGridCell ́AZ̒g`悷 IfDcDraw IuWFNg
֘AĂA
֘A IfDcDraw IuWFNggĕ`s܂B
  this ́AftHgł CDcdGridCell IuWFNg
 IfDcDraw IuWFNgƂāA CDcdTextbox IuWFNg𐶐
o^܂̂߁A CDcdTextbox IuWFNg m_strText 
eLXgݒ肷ƁA CDcdGrid ̓Z̒ɃeLXg`悵܂B

() Zԍ (1,0) ɁA "0000" ZbgĂ܂B
@code
Ou<CDcdTextbox>(pCDcdGrid->getCell( 1 , 0 )->getIfDcDraw())->setText( "0000" )  ;	
@endcode

SD  getItemSize() ĂяoƂɂÃObh̑傫
_PʂŎ擾邱Ƃł܂B܂A DcDraw() ŔCӂDCɃObh
`悳邱Ƃł܂B

@attention
CDcdGridXColumn , CDcdGridYColumn ́AftHgł
 m_bAutoColumnSize , m_bAutoColumnBorderSize ^ɂȂĂ܂B
̑^ƁAObh̕`ɎԂ܂B
̐ꍇ́A CDcdGridXColumn ,  CDcdGridYColumn 
m_bAutoColumnSize,m_bAutoColumnBorderSize UɂŁA
m_iColumnSize,m_iColumnBorderSize ɖI
lݒ肷邱Ƃ߂܂B
 */
class CDcdGrid : public IfDcDraw
{
private:
	// --------------------------------
	//	Ci[^Cv
	// --------------------------------
	typedef	std::deque<CDcdGridYColumn*>	CDcdGridYColumnCont ;
	typedef	std::deque<CDcdGridXColumn*>	CDcdGridXColumnCont ;
	typedef	std::deque< CDcdGridCell* > CDcdGridYColumnCellCont ;
	typedef	std::deque< CDcdGridYColumnCellCont* > CDcdGridCellCont ;
	friend class CDcdGridYColumn ;
	friend class CDcdGridXColumn ;
	friend class CDcdGridCell ;
	
	
	
 private:
	// ********************************
	///	@name W
	// ********************************
	///@{

	/**
		Y̐擪([)̌r\IuWFNgłB
	*/
	CDcdGridYBorder	m_CDcdGridYBorderTop ;

	/**
	  	YIuWFNgێReiłBvf́A  Y 
	  	łB
	  
	  	擪̗vf(Y0)Yԍ0A
	  	2ԖځiY1jYԍ1A
	  	3Ԗ(Y2)Yԍ2EEEƂȂ܂B
	  
	  	  RXgN^ł́AƂȂ܂B
	  	̌́A
	  		setYColumnCount() 
	  	AReiɑ΂YIuWFNg̒ǉE폜s܂B
	  
	  	ReĩIuWFNg̔j̐Ӗ́Athisɂ܂B
	 */
	CDcdGridYColumnCont		m_CDcdGridYColumnCont ;


	/**
		Y̖([)̌r\IuWFNgłB
	*/
	CDcdGridYBorder	m_CDcdGridYBorderBottom ;

	/**
		X̐擪([)̌r\IuWFNgłB
	*/
	CDcdGridXBorder	m_CDcdGridXBorderTop ;

	/**
	  	XIuWFNgێReiłBvf́A  X 
	  	łB
	  
	  	擪̗vf(Y0)Xԍ0A
	  	2ԖځiY1jXԍ1A
	  	3Ԗ(Y2)Xԍ2EEEƂȂ܂B
	  
	  	  RXgN^ł́AƂȂ܂B
	  	̌́A
	  		setYColumnCount() 
	  	AReiɑ΂XIuWFNg̒ǉE폜X񂢂܂B
	  
	  	ReĩIuWFNg̔j̐Ӗ́Athisɂ܂B
	 */
	CDcdGridXColumnCont 	m_CDcdGridXColumnCont ;

	/**
		X̖(E[)̌r\IuWFNgłB
	*/
	CDcdGridXBorder	m_CDcdGridXBorderBottom ;

	
	/**
	  	ZIuWFNgێReiłB
	  	
	  	̃Rei̗vf́AYColumn ̐ɓȂ܂B
	  	̃Rei̊evf́A XColumn  CDcdGridCell ێ
	  	ReiłB
	  	
	  	āA
	  
	  	m_CDcdGridCellCont[Yԍ][Xԍ]
	  
	  	̌`ŁAΉ CDcdGridCell IuWFNgɃANZXł܂B
	  
	  	ReĩIuWFNg̔j̐Ӗ́Athisɂ܂B
	 */
	CDcdGridCellCont 	m_CDcdGridCellCont ;
	///@}
	// ********************************
	/// @name 
	// ********************************
	///@{

	/**
	  	XN[@\ɂAŒY
	  	iXN[̑Ώۂ珜OYj̐łB
	  
	  	͈͂́A0ȏ Y񐔈ȉłB
	  	Y񐔂ωƂAthis͈͂̑̔͂ɐK܂B
	  	
	  	l0łB
	 */
	int	m_iYFixColumnCount ;

	/**
	  	XN[@\ɂāAԏ㑤ɈʒuYԍłB
	  	AŒY̐PȏłꍇA̒l͌ŒỶׂYԍ
	  	ƂȂ܂B
	  	
	  	Ⴆ΁Am_iYFixColumnCount 1ŁA̒l2̏ꍇA
	  	DcDraw() ł̕`挋ʂ́AォYԍ0EYԍ2̏łB
	  	
	  	͈͂́Am_iFixRiwCount ȏ Y񐔖łB
	  	Y񐔂ωƂA m_iYFixColumnCount ωƂɁA
	  	this͈͂̑̔͂ɐK܂B
	  	
	  	l0łB
	 */
	int	m_iYFixafterColumnNumber ;

	/**
	  	XN[@\ɂAŒX
	  	iXN[̑Ώۂ珜OXj̐łB
	  
	  	͈͂́A0ȏ X񐔈ȉłB
	  	X񐔂ωƂAthis͈͂̑̔͂ɐK܂B
	  	
	  	l0łB
	 */
	int	m_iXFixColumnCount ;
	
	/**
	  	XN[@\ɂāAԍɈʒuXԍłB
	  	AŒX̐PȏłꍇA̒l͌ŒX̉EׂXԍ
	  	ƂȂ܂B
	  	
	  	Ⴆ΁Am_iXFixColumnCount 1ŁA̒l2̏ꍇA
	  	DcDraw() ł̕`挋ʂ́AXԍ0EXԍ2̏łB
	  	
	  	͈͂́Am_iXFixColumnCount ȏ X񐔖łB
	  	X񐔂ωƂA m_iXFixColumnCount ωƂɁA
	  	this͈͂̑̔͂ɐK܂B
	  	
	  	l0łB
	 */
	int	m_iXFixafterColumnNumber ;

	///@}
private:
	// --------------------------------
	///@name	f[^( createZoneCache() )
	// --------------------------------
	///@{
	/**
	  	ʏ͗vfOłB
	  	createZoneCache()  destroyZoneCache() ܂ł̊Ԃ
	  	getXColumnBorderZone() ̌ʂێ܂B
	  	ÝAԍ{PƂȂ܂B
	 */
	std::deque< CdDcdZone >	m_zonecontXColumnBorderZoneCache ;
	/**
	  	ʏ͗vfOłB
	  	createZoneCache()  destroyZoneCache() ܂ł̊Ԃ
	  	getXColumnZone() ̌ʂێ܂B
	  	ÝAԍƂȂ܂B
	 */
	std::deque< CdDcdZone >	m_zonecontXColumnZoneCache ;

	/**
	  	ʏ͗vfOłB
	  	createZoneCache()  destroyZoneCache() ܂ł̊Ԃ
	  	getXColumnZoneOverlap() ̌ʂێ܂B
	  	ÝAԍƂȂ܂B
	 */
	std::deque< CdDcdZone >	m_zonecontXColumnZoneOverlapCache ;

	/**
	  	ʏ͗vfOłB
	  	createZoneCache()  destroyZoneCache() ܂ł̊Ԃ
	  	getYColumnBorderZone() ̌ʂێ܂B
	  	ÝAԍ{PƂȂ܂B
	 */
	std::deque< CdDcdZone >	m_zonecontYColumnBorderZoneCache ;
	/**
	  	ʏ͗vfOłB
	  	createZoneCache()  destroyZoneCache() ܂ł̊Ԃ
	  	getYColumnZone() ̌ʂێ܂B
	  	ÝAԍƂȂ܂B
	 */
	std::deque< CdDcdZone >	m_zonecontYColumnZoneCache ;
	/**
	  	ʏ͗vfOłB
	  	createZoneCache()  destroyZoneCache() ܂ł̊Ԃ
	  	getYColumnZoneOverlap() ̌ʂێ܂B
	  	ÝAԍƂȂ܂B
	 */
	std::deque< CdDcdZone >	m_zonecontYColumnZoneOverlapCache ;
	///@}


protected:
	// --------------------------------
	///@name	֐
	// --------------------------------
	///@{
	/**
	  	wX͈̔͂̑傫߂܂B
	   @param pIfDcdTarget [in]
	  	`Ώۂw肵ĂB 
	   @param iXColumnNumberSrc [in]
	  	N_Xԍw肵ĂB
	  	bSrcIsBorder ^̏ꍇA-1wł܂B
	  	INT_MAX ́AŏIw肵̂Ƃ݂Ȃ܂B
	   @param bSrcIsBorder [in]
	  	N_XԍAXԍ̋Ew肵ĂȂ^
	   @param iXColumnNumberDst [in]
	  	I_Xԍw肵ĂB
	  	bDstIsBorder ^̏ꍇA-1wł܂B
	  	INT_MAX ́AŏIw肵̂Ƃ݂Ȃ܂B
	   @param bDstIsBorder [in]
	  	I_XԍAXԍ̋Ew肵ĂȂ^
	   @return
	  	TCYԂ܂B
	  
	  	ij
	  
	  	ԍ-1̋EAԍ2̗܂ł͈̔͂߂ꍇ́A
	  	( iXColumnNumberSrc ,bSrcIsBorder ,
	  		iXColumnNumberDst ,bDstIsBorder) = ( -1 , true , 2 , false )
	  	ƂȂ܂
	 */
	int getXColumnsSize( 	IfDcdTarget* pIfDcdTarget ,
			int iXColumnNumberSrc , bool bSrcIsBorder ,
			int iXColumnNumberDst , bool bDstIsBorder) ;

	/**
	  	wY͈̔͂̑傫߂܂B
	   @param pIfDcdTarget [in]
	  	`Ώۂw肵ĂB 
	   @param iYColumnNumberSrc [in]
	  	N_Yԍw肵ĂB
	  	bSrcIsBorder ^̏ꍇA-1wł܂B
	  	INT_MAX ́AŏIw肵̂Ƃ݂Ȃ܂B
	   @param bSrcIsBorder [in]
	  	N_YԍAYԍ̋Ew肵ĂȂ^
	   @param iYColumnNumberDst [in]
	  	I_Yԍw肵ĂB
	  	bDstIsBorder ^̏ꍇA-1wł܂B
	  	INT_MAX ́AŏIw肵̂Ƃ݂Ȃ܂B
	   @param bDstIsBorder [in]
	  	I_YԍAYԍ̋Ew肵ĂȂ^
	   @return
	  	TCYԂ܂B
	  
	  	ij
	  
	  	ԍ-1̋EAԍ2̗܂ł͈̔͂߂ꍇ́A
	  	( iYColumnNumberSrc ,bSrcIsBorder ,
	  		iYColumnNumberDst ,bDstIsBorder) = ( -1 , true , 2 , false )
	  	ƂȂ܂
	 */
	int getYColumnsSize( 	IfDcdTarget* pIfDcdTarget ,
			int iYColumnNumberSrc , bool bSrcIsBorder ,
			int iYColumnNumberDst , bool bDstIsBorder) ;

	/**
	  	setYColumnCount()  insertYColumn() ̉֐łB
	  
	  	YPAẅʒuɒǉ܂B
	  	̊֐́A 
	  	m_CDcdGridXColumnCont,m_CDcdGridYColumnCont,
	  	m_CDcdGridCellCont
	  	̑s܂B
	  	adjustProp() ͍s܂B
	   @param iYColumnNumber
	  	Yԍw肵ĂB
	  	VǉꂽY񂪁AYԍɂȂ܂B
	  	͈͂ 0 ȏ getYColumnNumber() ȉŁA
	  	0 Ȃ擪EgetYColumnNumber() Ȃ疖ւ̒ǉƂȂ܂B
	  	  A INT_MAX w肷ƁAw肵ƂɂȂ܂B
	   @return
	  	0ȏAG[Ȃ畉̐łB
	   -	-2 ;	//	CfNXs
	 */
	int insertYColumn_insertColumnCell( int iYColumnNumber ) ;

	/**
	  	setXColumnCount()  insertXColumn() ̉֐łB
	  
	  	XPAẅʒuɒǉ܂B
	  	̊֐́A 
	  	m_CDcdGridXColumnCont,m_CDcdGridYColumnCont,
	  	m_CDcdGridCellCont
	  	̑s܂B
	  	adjustProp() ͍s܂B
	   @param iXColumnNumber
	  	Xԍw肵ĂB
	  	VǉꂽX񂪁AXԍɂȂ܂B
	  	͈͂ 0 ȏ getXColumnNumber() ȉŁA
	  	0 Ȃ擪EgetXColumnNumber() Ȃ疖ւ̒ǉƂȂ܂B
	  	  A INT_MAX w肷ƁAw肵ƂɂȂ܂B
	   @return
	  	0ȏAG[Ȃ畉̐łB
	   -	-2 ;	//	CfNXs
	 */
	int insertXColumn_insertColumnCell( int iXColumnNumber ) ;
	
	/**
	  	setYColumnCount()  eraseYColumn() ̉֐łB
	  
	  	YPA폜܂B
	  	̊֐́A 
	  	m_CDcdGridXColumnCont,m_CDcdGridYColumnCont,
	  	m_CDcdGridCellCont
	  	̑s܂B
	  	adjustProp() ͍s܂B
	   @param iYColumnNumber
	  	Yԍw肵ĂB
	  	͈͂ 0 ȏ getYColumnNumber() łB
	  	  A INT_MAX w肷ƁAw肵ƂɂȂ܂B
	   @return
	  	0ȏAG[Ȃ畉̐łB
	   -	-2 ;	//	CfNXs
	 */
	int eraseYColumn_eraseColumnCell( int iYColumnNumber ) ;

	/**
	  	setXColumnCount()  eraseXColumn() ̉֐łB
	  
	  	XPA폜܂B
	  	̊֐́A 
	  	m_CDcdGridXColumnCont,m_CDcdGridYColumnCont,
	  	m_CDcdGridCellCont
	  	̑s܂B
	  	adjustProp() ͍s܂B
	   @param iXColumnNumber
	  	Xԍw肵ĂB
	  	͈͂ 0 ȏ getXColumnNumber() łB
	  	  A INT_MAX w肷ƁAw肵ƂɂȂ܂B
	   @return
	  	0ȏAG[Ȃ畉̐łB
	   -	-2 ;	//	CfNXs
	 */
	int eraseXColumn_eraseColumnCell( int iXColumnNumber ) ;

	/**
	  	YԍEXԍɊ֌W鑮̐Ks܂B
	  	YXǉE폜ꍇɂ́Å֐gYԍE
	  	Xԍ̐Ks܂B
	  	ḰAȉ̏ɍs܂B
	  
	  
	  	- m_iXFixColumnCount
	  	- m_iXFixafterColumnNumber
	  	- m_iYFixColumnCount
	  	- m_iYFixafterColumnNumber
	  
	  	- CDcdGridCell::m_iXAttachCellCount
	  	- CDcdGridCell::m_iYAttachCellCount
	  
	  	- CDcdGridCell::m_pcellAttachTo
	 */
	virtual void adjustProp() ;
 
	/**
	  	getXColumnZone(),getXColumnBorderZone(),getXColumnZoneOverlap()
	  	getYColumnZone(),getYColumnBorderZone(),getYColumnZoneOverlap()
	  	̌ʂ̃LbV
	  
	  	-	m_zonecontXColumnBorderZoneCache ;
	  	-	m_zonecontXColumnZoneCache ;
	  	-	m_zonecontXColumnZoneOverlapCache ;
	  	-	m_zonecontYColumnBorderZoneCache ;
	  	-	m_zonecontYColumnZoneCache ;
	  	-	m_zonecontXYColumnZoneOverlapCache ;
	  
	  	ɍ쐬܂B
	@param pIfDcdTarget [in]
	  	`Ώۂw肵ĂB 
	@return
		- true : LbV쐬܂B
		- false: LbVłɑ݂܂B
	*/
	bool createZoneCache( IfDcdTarget* pIfDcdTarget ) ;

	/**
	  	getXColumnZone(),getXColumnBorderZone(),getXColumnZoneOverlap()
	  	getYColumnZone(),getYColumnBorderZone(),getYColumnZoneOverlap()
	  	̌ʂ̃LbV
	  
	  	-	m_zonecontXColumnBorderZoneCache ;
	  	-	m_zonecontXColumnZoneCache ;
	  	-	m_zonecontXColumnZoneOverlapCache ;
	  	-	m_zonecontYColumnBorderZoneCache ;
	  	-	m_zonecontYColumnZoneCache ;
	  	-	m_zonecontXYColumnZoneOverlapCache ;
	  
	  	j܂B
	 */
	void destroyZoneCache() ;
	///@}
	// --------------------------------
	///@name	DcDraw̉֐
	// --------------------------------
	///@{

	/**
		uwXr(cr)́AwŸʒuAZɂĕ\Ȃv
		ꍇ𔻒肵܂B
	@param iXColumnNumber
		Ώۂ̌rXIndexw肵ĂB
	@param iYColumnNumber
		`ꏊYIndexw肵ĂB
	*/
	bool IsXBorderOverlappedByAttachedCell( int iXColumnNumber , int iYColumnNumber ) ;


	/**
		uwYr(r)́AwẌʒuAZɂĕ\Ȃv
		ꍇ𔻒肵܂B
	@param iXColumnNumber
		`ꏊXIndexw肵ĂB
	@param iYColumnNumber
		Yr(r)̗Indexw肵ĂB
	*/
	bool IsYBorderOverlappedByAttachedCell( int iXColumnNumber , int iYColumnNumber ) ;


	/**
		DcDraw̉֐łB
		X̌r`悵܂B
		Y̌Œ񑤂ւ̕`EXN[\񑤂ւ̕`̂QI邱Ƃł܂B
	@param isYFixColumn
		- true: Y̌Œ񑤂ւ̕`
		- false: ỸXN[\񑤂ւ̕`
	@param pTarget 
		`̈w肵ĂB
		̕`̈́ANbsOĂKv܂B
	@param iXColumnNumber
	  	 Xԍw肵ĂB͈͂́A-1ȏ getXColumnCount() łB
	  	-	-1 ;	[̌rIuWFNgɑ΂`B
	  	-	getXColumnCount()-1 , INT_MAX ;	
	  		E[̌rIuWFNgɑ΂`B
	@return
		- true:炩̕`s܂B
		- false:`s܂łB
	*/
	bool DcDraw_DrawXColumn( bool isYFixColumn , CaDcdTargetClip* pTarget , int iXColumnNumber ) ;


	/**
		DcDraw̉֐łB
		Y̌r`悵܂B
		X̌Œ񑤂ւ̕`EXN[\񑤂ւ̕`̂QI邱Ƃł܂B
	@param isXFixColumn
		- true: X̌Œ񑤂ւ̕`
		- false: X̃XN[\񑤂ւ̕`
	@param pTarget 
		`̈w肵ĂB
		̕`̈́ANbsOĂKv܂B
	@param iYColumnNumber
	  	 Yԍw肵ĂB͈͂́A-1ȏ getYColumnCount() łB
	  	-	-1 ;	[̌rIuWFNgɑ΂`B
	  	-	getYColumnCount()-1 , INT_MAX ;	
	  		E[̌rIuWFNgɑ΂`B
	@return
		- true:炩̕`s܂B
		- false:`s܂łB
	*/
	bool DcDraw_DrawYColumn( bool isXFixColumn , CaDcdTargetClip* pTarget , int iYColumnNumber ) ;

	///@}
 public:
	// ********************************
	//	RXgN^
	// ********************************
	CDcdGrid() ;
	virtual ~CDcdGrid() ;
	
 private:
	CDcdGrid( const CDcdGrid& ev ){} ;
	void operator=( const CDcdGrid& ev ){} ;
	
 public:
	// ********************************
	///@name	IfDcDraw
	// ********************************
	///@{
	/**
	 	`v܂B
	 	̊֐́A pIfDcdTarget ɁA`s܂B
	 @param pIfDcdTarget  [in]
	 	̃IuWFNgɕ`s킹DCƗ̈w肵ĂB
	 @return
	 	`sꍇ͐^Ë̗ւ̕`悪łȂꍇ͋UłB
	*/
	virtual bool DcDraw( IfDcdTarget* pIfDcdTarget ) ;
	
	/**
	 	̃IuWFNg`悷ACȇ傫܂Ăꍇ́A
	 	̑傫𒲂ׂ邱Ƃł܂B
	 	֐Ăяo IfDcDraw IuWFNg`悷ꍇɂ́A
	 	֐ĂяóÅ֐ŃACȇ傫𒲂ׂāA
	 	K؂ȃCAEglĂADcDraw() s邱Ƃł܂B
	 @param pIfDcdTarget [in]
	 	̃IuWFNgɕ`s킹DCƗ̈w肵ĂB
	 @param pCdDcdSizeXy [out]
	 	̃IuWFNg̕`悷ACȇ傫܂Ăꍇ́A
	 	̊֐͂̃AhXɁÃACẽTCYԂ܂B
	 	̃IuWFNg̕`悷ACȇ傫܂ĂȂꍇ́A
	 	̒l͕słB
	 @return
	 	̃IuWFNg̕`悷ACȇ傫܂ĂāA
	 	̑傫 *pCdDcdSizeXyɏ񂾏ꍇ͐^łB
	 	łȂꍇ́AUłB
	*/
	virtual bool getItemSize( IfDcdTarget* pIfDcdTarget , 
							CdDcdSizeXy* pCdDcdSizeXy ) ;
	
	///@}
 protected:
	// --------------------------------
	///@name sEEZ̏
	// --------------------------------
	///@{
	/**
	  	this ́AV Column ꂽɁÅ֐Ăяo܂B
	  	V Column ɑ΂āA IfDcDraw C^[tF[XIuWFNg
	  	̐Eo^͂߂Ƃ
	  	s܂B
	  
	  	̊֐I[oCh邱ƂɂA Column ɓL̏
	  	sƂł܂B
	  	
	   @param iXColumnNumber [in]
	  	  V Column ̗ԍłB
	   @param pCDcdGridXColumn [in,out]
	  	  Vꂽ CDcdGridXColumn IuWFNgłB
	  	  ̊֐͂̃IuWFNgɑ΂āAsƂł܂B
	  	
	   [I[oCh]
	  	   CDcdLine IuWFNg new ŐA
	  	pCDcdGridXColumn  IfDcDraw C^[tF[Xɓo^܂B
	  	̂Ƃ̑́AP̍̎
	  	ƂȂ܂B
	 */
	virtual void OnCreateXColumn( int iXColumnNumber , 
		CDcdGridXColumn* pCDcdGridXColumn ) ;
	
	/**
	  	this ́AColumn j钼OɁÅ֐Ăяo܂B
	  	j Column ɑ΂āA IfDcDraw C^[tF[XIuWFNg
	  	o^Ej͂߂Ƃ
	  	ns܂B
	  
	  	̊֐I[oCh邱ƂɂA Column ɓĽn
	  	sƂł܂B
	  	
	   @param iXColumnNumber [in]
	  	  j Column ̗ԍłB
	   @param pCDcdGridXColumn [in,out]
	  	  j CDcdGridXColumn IuWFNgłB
	  	  ̊֐͂̃IuWFNgɑ΂āAnsƂł܂B
	  	
	   [I[oCh]
	  	pCDcdGridXColumn  IfDcDraw C^[tF[Xo^A
	  	IuWFNg delete Ŕj܂B
	 */
	virtual void OnDeleteXColumn( int iXColumnNumber , 
		CDcdGridXColumn* pCDcdGridXColumn ) ;

	/**
	  	this ́AV Column ꂽɁÅ֐Ăяo܂B
	  	V Column ɑ΂āA IfDcDraw C^[tF[XIuWFNg
	  	̐Eo^͂߂Ƃ
	  	s܂B
	  
	  	̊֐I[oCh邱ƂɂA Column ɓL̏
	  	sƂł܂B
	  	
	   @param iYColumnNumber [in]
	  	  V Column ̗ԍłB
	   @param pCDcdGridYColumn [in,out]
	  	  Vꂽ CDcdGridYColumn IuWFNgłB
	  	  ̊֐͂̃IuWFNgɑ΂āAsƂł܂B
	  	
	   [I[oCh]
	  	   CDcdLine IuWFNg new ŐA
	  	pCDcdGridYColumn  IfDcDraw C^[tF[Xɓo^܂B
	  	̂Ƃ̑́AP̍̎
	  	ƂȂ܂B
	 */
	virtual void OnCreateYColumn( int iYColumnNumber , 
		CDcdGridYColumn* pCDcdGridYColumn ) ;
	
	/**
	  	this ́AColumn j钼OɁÅ֐Ăяo܂B
	  	j Column ɑ΂āA IfDcDraw C^[tF[XIuWFNg
	  	o^Ej͂߂Ƃ
	  	ns܂B
	  
	  	̊֐I[oCh邱ƂɂA Column ɓĽn
	  	sƂł܂B
	  	
	   @param iYColumnNumber [in]
	  	  j Column ̗ԍłB
	   @param pCDcdGridYColumn [in,out]
	  	  j CDcdGridYColumn IuWFNgłB
	  	  ̊֐͂̃IuWFNgɑ΂āAnsƂł܂B
	  	
	   [I[oCh]
	  	pCDcdGridYColumn  IfDcDraw C^[tF[Xo^A
	  	IuWFNg delete Ŕj܂B
	 */
	virtual void OnDeleteYColumn( int iYColumnNumber , 
		CDcdGridYColumn* pCDcdGridYColumn ) ;

	/**
	  	this ́AV Cell ꂽɁÅ֐Ăяo܂B
	  	V Cell ɑ΂āA IfDcDraw C^[tF[XIuWFNg
	  	̐Eo^͂߂Ƃ
	  	s܂B
	  
	  	̊֐I[oCh邱ƂɂA Cell ɓL̏
	  	sƂł܂B
	  	
	   @param iXColumnNumber [in]
	  	  V Cell XԍłB
	   @param iYColumnNumber [in]
	  	  V Cell YԍłB
	   @param pCDcdGridCell [in,out]
	  	  Vꂽ CDcdGridCell IuWFNgłB
	  	  ̊֐͂̃IuWFNgɑ΂āAsƂł܂B
	  	
	   [I[oCh]
	  	   CDcdTextbox IuWFNg new ŐA
	  	pCDcdGridCell  IfDcDraw C^[tF[Xɓo^܂B
	  	̂Ƃ̑́A
	  
	  		- tHg̓XgbNIuWFNg DEFAULT_GUI_FONT 
	  		- eLXgzu 
	  			CdDrawTextFormat::H_LEFT | 
	  			CdDrawTextFormat::V_SINGLELINT_CENTER
	  		- wiF 
	  		- eLXg̏㉺EE̘g̈̑͘_PʂłP
	  
	  	ƂȂ܂B
	 */
	virtual void OnCreateCell( int iXColumnNumber , int iYColumnNumber , 
		CDcdGridCell* pCDcdGridCell ) ;
	
	/**
	  	this ́ACell j钼OɁÅ֐Ăяo܂B
	  	j Cell ɑ΂āA IfDcDraw C^[tF[XIuWFNg
	  	o^Ej͂߂Ƃ
	  	ns܂B
	  
	  	̊֐I[oCh邱ƂɂA Cell ɓĽn
	  	sƂł܂B
	  	
	   @param iXColumnNumber [in]
	  	  j Cell XԍłB
	   @param iYColumnNumber [in]
	  	  j Cell YԍłB
	   @param pCDcdGridCell [in,out]
	  	  j CDcdGridCell IuWFNgłB
	  	  ̊֐͂̃IuWFNgɑ΂āAnsƂł܂B
	  	
	   [I[oCh]
	  	pCDcdGridCell  IfDcDraw C^[tF[Xo^A
	  	IuWFNg delete Ŕj܂B
	 */
	virtual void OnDeleteCell( int iXColumnNumber , int iYColumnNumber , 
		CDcdGridCell* pCDcdGridCell ) ;
	///@}
 public:
	// ********************************
	///	@name YEX̐
	// ********************************
	///@{
	/**
	   @return
	  	݂Y̐Ԃ܂BԂł́AOԂ܂B
	 */
	virtual int		getYColumnCount() ;
	
	/**
	   @param ev [in]
	  	Y̐w肵ĂB
	 */
	virtual CDcdGrid& setYColumnCount( int ev ) ;
	
	/**
	   @return
	  	݂X̐Ԃ܂BԂł́AOԂ܂B
	 */
	virtual int		getXColumnCount() ;

	/**
	   @param ev [in]
	  	X̐w肵ĂB
	 */
	virtual CDcdGrid& setXColumnCount( int ev ) ;

	///@}
	
 public:
	// ********************************
	///	@name YEX}/폜
	// ********************************
	///@{
	/**
	  	YPAẅʒuɒǉ܂B
	   @param iYColumnNumber
	  	Yԍw肵ĂB
	  	VǉꂽY񂪁AYԍɂȂ܂B
	  	͈͂ 0 ȏ getYColumnNumber() ȉŁA
	  	0 Ȃ擪EgetYColumnNumber() Ȃ疖ւ̒ǉƂȂ܂B
	  	  A INT_MAX w肷ƁAw肵ƂɂȂ܂B
	   @return
	  	0ȏAG[Ȃ畉̐łB
	   -	-2 ;	//	CfNXs
	 */
	virtual int insertYColumn( int iYColumnNumber ) ;

	/**
	  	XPAẅʒuɒǉ܂B
	   @param iXColumnNumber
	  	Xԍw肵ĂB
	  	VǉꂽX񂪁AXԍɂȂ܂B
	  	͈͂ 0 ȏ getXColumnNumber() ȉŁA
	  	0 Ȃ擪EgetXColumnNumber() Ȃ疖ւ̒ǉƂȂ܂B
	  	  A INT_MAX w肷ƁAw肵ƂɂȂ܂B
	   @return
	  	0ȏAG[Ȃ畉̐łB
	   -	-2 ;	//	CfNXs
	 */
	virtual int insertXColumn( int iXColumnNumber ) ;
	
	/**
	  	YPA폜܂B
	   @param iYColumnNumber
	  	Yԍw肵ĂB
	  	͈͂ 0 ȏ getYColumnNumber() łB
	  	  A INT_MAX w肷ƁAw肵ƂɂȂ܂B
	   @return
	  	0ȏAG[Ȃ畉̐łB
	   -	-2 ;	//	CfNXs
	 */
	virtual int eraseYColumn( int iYColumnNumber ) ;
	/**
	  	XPA폜܂B
	   @param iXColumnNumber
	  	Xԍw肵ĂB
	  	͈͂ 0 ȏ getXColumnNumber() łB
	  	  A INT_MAX w肷ƁAw肵ƂɂȂ܂B
	   @return
	  	0ȏAG[Ȃ畉̐łB
	   -	-2 ;	//	CfNXs
	 */
	virtual int eraseXColumn( int iXColumnNumber ) ;
	///@}
	
 public:
	// ********************************
	///	@name YEXEZIuWFNg
	// ********************************
	///@{
	/**
	@return
		Obh̊Og̘gIuWFNgԂ܂B
		[̃IuWFNgԂ܂B
	*/
	virtual CDcdGridYBorder* getCDcdGridYBorderTop()
	{	return &m_CDcdGridYBorderTop ;};

	/**
	 	  w肳ꂽYԍ́AYIuWFNg CDcdGridYColumn ̃|C^
	  	擾邱Ƃł܂B̃|C^gāAYɑ΂鑀
	  	Y񂤂Ƃł܂B
	   @param iYColumnNumber [in] 
	  	 Yԍw肵ĂB͈͂́A-1ȏ getYColumnCount() łB
	  	 A INT_MAX w肷ƁAŏIYw肵ƂɂȂ܂B
	   @return
	  	  ΉYIuWFNgԂ܂B
	  	  CfNXsȏꍇ́ANULLԂ܂B
	  
	  	  ԂꂽIuWFNg̔j̐Ӗ́Athisɂ܂B
	  	  YY CDcdGrid ̕ʂ̃\bhɂč폜ƁAԂꂽ
	  	|C^͖ɂȂ܂B
	  	   thisjꂽƂɂAԂꂽ|C^͖ɂȂ܂B
	 */
	virtual CDcdGridYColumn*	getYColumn( int iYColumnNumber )  ;

	/**
	  	  w肳ꂽYԍ́ArIuWFNg CDcdGridYBorder ̃|C^
	  	擾邱Ƃł܂B̃|C^gāAY̌rɑ΂鑀
	  	sƂł܂B
	   @param iYColumnNumber [in] 
	  	 Yԍw肵ĂB͈͂́A-1ȏ getYColumnCount() łB
	  	-	-1 ;	[̌rIuWFNgim_CDcdGridYBorderTopjԂ܂B
	  	-	getYColumnCount()-1 , INT_MAX ;	
	  		[̌rIuWFNgim_CDcdGridYBorderBottomjԂ܂B
	   @return
	  	 ΉYrIuWFNgԂ܂B
	  	 CfNXsȏꍇ́ANULLԂ܂B
	  
	  	  ԂꂽIuWFNg̔j̐Ӗ́Athisɂ܂B
	  	  YY CDcdGrid ̕ʂ̃\bhɂč폜ƁAԂꂽ
	  	|C^͖ɂȂ܂B
	  	   thisjꂽƂɂAԂꂽ|C^͖ɂȂ܂B
	 */
	virtual CDcdGridYBorder*	getYBorder( int iYColumnNumber )  ;

	/**
	@return
		Obh̊Og̘gIuWFNgԂ܂B
		[̃IuWFNgԂ܂B
	*/
	virtual CDcdGridYBorder* getCDcdGridYBorderBottom(){ return &m_CDcdGridYBorderBottom ;};

	/**
	@return
		Obh̊Og̘gIuWFNgԂ܂B
		[̃IuWFNgԂ܂B
	*/
	virtual CDcdGridXBorder* getCDcdGridXBorderTop(){	return &m_CDcdGridXBorderTop ;};

	/**
	  	  w肳ꂽXԍ́AXIuWFNg CDcdGridYColumn ̃|C^
	  	擾邱Ƃł܂B̃|C^gāAXɑ΂鑀
	  	sƂł܂B
	   @param iXColumnNumber [in] 
	  	 Xԍw肵ĂB͈͂́A-1ȏ getXColumnCount() łB
	  	 A INT_MAX w肷ƁAŏIXw肵ƂɂȂ܂B
	   @return
	  	 ΉXIuWFNgԂ܂B
	  	 CfNXsȏꍇ́ANULLԂ܂B
	  
	  	  ԂꂽIuWFNg̔j̐Ӗ́Athisɂ܂B
	  	  YX CDcdGrid ̕ʂ̃\bhɂč폜ƁAԂꂽ
	  	|C^͖ɂȂ܂B
	  	   thisjꂽƂɂAԂꂽ|C^͖ɂȂ܂B
	 */
	virtual CDcdGridXColumn*	getXColumn( int iXColumnNumber )  ;

	/**
	  	  w肳ꂽXԍ́ArIuWFNg CDcdGridXBorder ̃|C^
	  	擾邱Ƃł܂B̃|C^gāAX̌rɑ΂鑀
	  	sƂł܂B
	   @param iXColumnNumber [in] 
	  	 Xԍw肵ĂB͈͂́A-1ȏ getYColumnCount() łB
	  	-	-1 ;	[̌rIuWFNgim_CDcdGridXBorderTopjԂ܂B
	  	-	getXColumnCount()-1 , INT_MAX ;	
	  		E[̌rIuWFNgim_CDcdGridXBorderBottomjԂ܂B
	   @return
	  	 ΉXrIuWFNgԂ܂B
	  	 CfNXsȏꍇ́ANULLԂ܂B
	  
	  	  ԂꂽIuWFNg̔j̐Ӗ́Athisɂ܂B
	  	  YX CDcdGrid ̕ʂ̃\bhɂč폜ƁAԂꂽ
	  	|C^͖ɂȂ܂B
	  	   thisjꂽƂɂAԂꂽ|C^͖ɂȂ܂B
	 */
	virtual CDcdGridXBorder*	getXBorder( int iXColumnNumber )  ;

	/**
	@return
		Obh̊Og̘gIuWFNgԂ܂B
		E[̃IuWFNgԂ܂B
	*/
	virtual CDcdGridXBorder* getCDcdGridXBorderBottom()
	{ return &m_CDcdGridXBorderBottom ;};

	/**
		w CDcdGridYColumn IuWFNǵAԍԂ܂B
	@param pCDcdGridYColumn [in]
		YColumn IuWFNgw肵ĂB
	@return
		ԍԂ܂B͈͂ 0 ȏ getYColumnCount() łB
		YIuWFNg CDcdGrid IuWFNgɏW񂳂ĂȂꍇ́A
		INT_MIN Ԃ܂B
	*/
	virtual int getYColumnNumberOfCoulmn( CDcdGridYColumn*	pCDcdGridYColumn ) ;
	/**
		@see YColumnNumberOfCoulmn() 
	*/
	virtual int getXColumnNumberOfCoulmn( CDcdGridXColumn*	pCDcdGridXColumn ) ;

	/**
		w CDcdGridYBorder IuWFNǵAԍԂ܂B
	@param pCDcdGridYBorder [in]
		YBorder IuWFNgw肵ĂB
	@return
		ԍԂ܂B͈͂ -1 ȏ getYColumnCount() łB
		IuWFNg CDcdGrid IuWFNgɏW񂳂ĂȂꍇ́A
		INT_MIN Ԃ܂B
	 	-	-1 ;	[̌rIuWFNgim_CDcdGridYBorderTopj
	 	-	getYColumnCount()-1  ;	[̌rIuWFNgim_CDcdGridYBorderBottomjE	@n
		 m_CDcdGridYColumnCont ̖̗vfłB
	*/
	virtual int getYColumnNumberOfBorder( CDcdGridYBorder*	pCDcdGridYBorder ) ;

	
	/**
		w CDcdGridXBorder IuWFNǵAԍԂ܂B
	@param pCDcdGridXBorder [in]
		XBorder IuWFNgw肵ĂB
	@return
		ԍԂ܂B͈͂ -1 ȏ getXColumnCount() łB
		IuWFNg CDcdGrid IuWFNgɏW񂳂ĂȂꍇ́A
		INT_MIN Ԃ܂B
	 	-	-1 ;	[̌rIuWFNgim_CDcdGridXBorderTopj
	 	-	getXColumnCount()-1  ;	E[̌rIuWFNgim_CDcdGridXBorderBottomjE	@n
		 m_CDcdGridXColumnCont ̖̗vfłB
	*/
	virtual int getXColumnNumberOfBorder( CDcdGridXBorder*	pCDcdGridXBorder ) ;

	/**
	  	  w肳ꂽYEXԍ́AZIuWFNg CDcdGridCell ̃|C^
	  	擾邱Ƃł܂B̃|C^gāAZɑ΂鑀
	  	sƂł܂B
	   @param iXColumnNumber [in] 
	  	 Xԍw肵ĂB͈͂́A0ȏ getYColumnCount() łB
	  	INT_MAX ́AŏIw肵̂Ƃ݂Ȃ܂B
	   @param iYColumnNumber [in] 
	  	 Yԍw肵ĂB͈͂́A0ȏ getYColumnCount() łB
	  	INT_MAX ́AŏIw肵̂Ƃ݂Ȃ܂B
	   @return
	  	  ΉZIuWFNgԂ܂B
	  	  CfNXsȏꍇ́ANULLԂ܂B
	  
	  	  ԂꂽIuWFNg̔j̐Ӗ́Athisɂ܂B
	  	  YX CDcdGrid ̕ʂ̃\bhɂč폜ƁAԂꂽ
	  	|C^͖ɂȂ܂B
	  	   thisjꂽƂɂAԂꂽ|C^͖ɂȂ܂B
	 */
	virtual CDcdGridCell*	getCell( int iXColumnNumber , int iYColumnNumber );
 

	/**
		w CDcdGridCell IuWFNǵAԍԂ܂B
	@param pCDcdGridCell [in]
		CDcdGridCell IuWFNgw肵ĂB
	@return
		XԍԂ܂B
		IuWFNg CDcdGrid IuWFNgɏW񂳂ĂȂꍇ́A
		INT_MIN łB
	*/
	virtual int getXColumnNumberOfCell( 
		CDcdGridCell* pCDcdGridCell ) ;
	/**
		w CDcdGridCell IuWFNǵAԍԂ܂B
	@param pCDcdGridCell [in]
		CDcdGridCell IuWFNgw肵ĂB
	@return
		YԍԂ܂B
		IuWFNg CDcdGrid IuWFNgɏW񂳂ĂȂꍇ́A
		INT_MIN łB
	*/
	virtual int getYColumnNumberOfCell( 
		CDcdGridCell* pCDcdGridCell ) ;
	
	///@}

 public:
	
	// ********************************
	///	@name YEẌʒu
	// ********************************
	///@{
	/**
	  	ŸʒuԂ܂B
	   @param pIfDcdTarget [in]
	  	`Ώۂw肵ĂB 
	   @param iYColumnNumber [in]
	  	Yԍw肵ĂB
	  	INT_MAX ́AŏIw肵̂Ƃ݂Ȃ܂B
	   @return
	  	Y͈̔͂Ԃ܂B
	  
	   @attention
	  	̊֐́AcreateZoneCacnẻe󂯂܂B
	  	̊֐ AČĂяoꍇ́A
	  	O createZoneCache() ĂяoƁA
	  	ptH[}XP܂B
	  	
	 */
	virtual CdDcdZone	getYColumnZone( 
			IfDcdTarget* pIfDcdTarget , int iYColumnNumber ) ;
	/**
	  	ẌʒuԂ܂B
	   @param pIfDcdTarget [in]
	  	`Ώۂw肵ĂB 
	   @param iXColumnNumber [in]
	  	Xԍw肵ĂB
	  	INT_MAX ́AŏIw肵̂Ƃ݂Ȃ܂B
	   @return
	  	X͈̔͂Ԃ܂B
	  
	   @attention
	  	̊֐́AcreateZoneCacnẻe󂯂܂B
	  	̊֐ AČĂяoꍇ́A
	  	O createZoneCache() ĂяoƁA
	  	ptH[}XP܂B
	 */
	virtual CdDcdZone	getXColumnZone( 
			IfDcdTarget* pIfDcdTarget , int iXColumnNumber ) ;
	
	/**
	  	Ỷ̋ËʒuԂ܂B
	   @param pIfDcdTarget [in]
	  	`Ώۂw肵ĂB 
	   @param iYColumnNumber [in]
	  	Yԍw肵ĂB͈͂-1ȏ getYColumnCount() łB
	  	INT_MAX ́AŏIw肵̂Ƃ݂Ȃ܂B
	   @return
	  	Y̋E͈̔͂Ԃ܂B
	  
	   @attention
	  	̊֐́AcreateZoneCacnẻe󂯂܂B
	  	̊֐ AČĂяoꍇ́A
	  	O createZoneCache() ĂяoƁA
	  	ptH[}XP܂B
	 */
	virtual CdDcdZone	getYColumnBorderZone( 
			IfDcdTarget* pIfDcdTarget , int iYColumnNumber ) ;

	/**
	  	X̉E̋ËʒuԂ܂B
	   @param pIfDcdTarget [in]
	  	`Ώۂw肵ĂB 
	   @param iXColumnNumber [in]
	  	Xԍw肵ĂB͈͂-1ȏ getXColumnCount() łB
	  	INT_MAX ́AŏIw肵̂Ƃ݂Ȃ܂B
	   @return
	  	X̋E͈̔͂Ԃ܂B
	  
	   @attention
	  	̊֐́AcreateZoneCacnẻe󂯂܂B
	  	̊֐ AČĂяoꍇ́A
	  	O createZoneCache() ĂяoƁA
	  	ptH[}XP܂B
	 */
	virtual CdDcdZone	getXColumnBorderZone( 
			IfDcdTarget* pIfDcdTarget , int iXColumnNumber ) ;

	/**
	  	Z̈ʒuԂ܂B
	   @param pIfDcdTarget [in]
	  	`Ώۂw肵ĂB 
	   @param iXColumnNumber [in]
	  	Xԍw肵ĂB͈͂0ȏ getXColumnCount() łB
	  	INT_MAX ́AŏIw肵̂Ƃ݂Ȃ܂B
	   @param iYColumnNumber [in]
	  	Yԍw肵ĂB͈͂0ȏ getYColumnCount() łB
	  	INT_MAX ́AŏIw肵̂Ƃ݂Ȃ܂B
	   @return
	  	Z̈ʒuԂ܂B
	  
	   @attention
	  	̊֐́AcreateZoneCacnẻe󂯂܂B
	  	̊֐ AČĂяoꍇ́A
	  	O createZoneCache() ĂяoƁA
	  	ptH[}XP܂B
	 */
	virtual CdDcdZoneXy	getCellZone( 
		IfDcdTarget* pIfDcdTarget , int iXColumnNumber , int iYColumnNumber ) ;

	/**
	  	YWɑΉAYԍ𒲂ׂ܂B
	   @param pIfDcdTarget [in]
	  	`Ώۂw肵ĂB 
	   @param iPos [in]
	  	YWw肵ĂB
	   @param pbIsBorder [out]
	  	̊֐́A iPos Eɂꍇ true A
	  	 iPos ͈̔͂ɂȂ false łB
	   @return
	  	YԍԂ܂B
	  
	  	- Yԍ = -1 , *pbIsBorder=false : Obh̏̊OłB
		- Yԍ = -1 , *pbIsBorder=true : Obh̏̋EłB
		- Yԍ = 0 ȏ getYColumnCount() , *pbIsBorder = false : 
	  		ObhY͈͂łB
	  	- Yԍ = 0 ȏ getYColumnCount() , *pbIsBorder = true : 
	  		ObhY񉺑̋E͈̔͂łB
	  	- Yԍ = getYColumnCount() , *pbIsBorder = false : 
	  		Obh̉̊OłB
	  
	   @attention
	  	̊֐́AcreateZoneCacnẻe󂯂܂B
	  	̊֐ AČĂяoꍇ́A
	  	O createZoneCache() ĂяoƁA
	  	ptH[}XP܂B
	 */
	virtual int getYColumnNumberOfPos( 
		IfDcdTarget* pIfDcdTarget , int iPos , bool* pbIsBorder ) ;

	/**
	  	XWɑΉAXԍ𒲂ׂ܂B
	   @param pIfDcdTarget [in]
	  	`Ώۂw肵ĂB 
	   @param iPos [in]
	  	XWw肵ĂB
	   @param pbIsBorder [out]
	  	̊֐́A iPos Eɂꍇ true A
	  	 iPos ͈̔͂ɂȂ false łB
	   @return
	  	XԍԂ܂B
	  
	  	- Xԍ = -1 , *pbIsBorder=false : Obh̍̊OłB
	  	- Xԍ = -1 , *pbIsBorder=true : Obh̍̋EłB
	  	- Xԍ = 0 ȏ getXColumnCount() , *pbIsBorder = false : 
	  		ObhX͈͂łB
	  	- Xԍ = 0 ȏ getXColumnCount() , *pbIsBorder = true : 
	  		ObhXE̋E͈̔͂łB
	  	- Xԍ = getXColumnCount() , *pbIsBorder = false : 
	  		Obh̉E̊OłB
	  
	   @attention
	  	̊֐́AcreateZoneCacnẻe󂯂܂B
	  	̊֐ AČĂяoꍇ́A
	  	O createZoneCache() ĂяoƁA
	  	ptH[}XP܂B
	 */
	virtual int getXColumnNumberOfPos( 
		IfDcdTarget* pIfDcdTarget , int iPos , bool* pbIsBorder ) ;


	/**
	  	X,Y WɑΉAZ𒲂ׂ܂B
	   @param pIfDcdTarget [in]
	  	`Ώۂw肵ĂB 
	   @param aCdDcdPosXy [in]
	  	XYWw肵ĂB
	   @return
	  	ZIuWFNgԂ܂B
	  	w̍WZ͈̔͂ɈʒuĂȂꍇ́ANULLԂ܂B
	  
	   @attention
	  	̊֐́AcreateZoneCacnẻe󂯂܂B
	  	̊֐ AČĂяoꍇ́A
	  	O createZoneCache() ĂяoƁA
	  	ptH[}XP܂B
	 */
	virtual CDcdGridCell* getCellOfPos( 
		IfDcdTarget* pIfDcdTarget , const CdDcdPosXy& aCdDcdPosXy ) ;

	///@}
 public:
	// ********************************
	///	@name	XN[
	// ********************************
	///@{
	
	///@see m_iXFixColumnCount
	virtual int	getXFixColumnCount() ;
	///@see m_iXFixColumnCount
	virtual CDcdGrid& setXFixColumnCount( int ev ) ;
	///@see m_iXFixafterColumnNumber
	virtual int	getXFixafterColumnNumber() ;
	///@see m_iXFixafterColumnNumber
	virtual CDcdGrid& setXFixafterColumnNumber( int ev ) ;
	///@see m_iYFixColumnCount
	virtual int	getYFixColumnCount() ;
	///@see m_iYFixColumnCount
	virtual CDcdGrid& setYFixColumnCount( int ev ) ;
	///@see m_iYFixafterColumnNumber
	virtual int	getYFixafterColumnNumber() ;
	///@see m_iYFixafterColumnNumber
	virtual CDcdGrid& setYFixafterColumnNumber( int ev ) ;
	
	/**
	  	w̕`̈ɂāAPy[W̃XN[sꍇ
	  	 FixafterColumnNumber ߂܂B
	  
	  	̊֐́A FixafterColumnNumber w肵lɂȂĂꍇ
	  	āAuPy[W̃XN[ɂ́A FixafterColumnNumber 
	  	ɕύX΂悢v߂܂B
	   @param pIfDcdTarget [in]
	  	`̈w肵ĂB
	   @param iFixafterColumnNumber [in]
	  	Py[W̃XN[sꍇ̊ɂȂA FixafterColumnNumber
	  	w肵ĂB
	   @param bPagedown [in]
	  	- false ;	//	Pageup(-)̃XN[
	  	- true ;	//	Pagedown(+)̃XN[
	   @return 
	  	Py[W̃XN[s߂́AV
	  	 FixafterColumnNumber Ԃ܂B@n
	  	bPagedown ^ getXColumnCount() A
	  	bPagedown U getXFixColumnCount() - 1 ̏ꍇA
	  	ȏ̃XN[삪łȂƂ܂B
	 */
	int calcXFixafterColumnNumberPagemove( IfDcdTarget* pIfDcdTarget , 
		int iFixafterColumnNumber , bool bPagedown ) ;
	
	/**
	  	w̕`̈ɂāAPy[W̃XN[sꍇ
	  	 FixafterColumnNumber ߂܂B
	  
	  	̊֐́A FixafterColumnNumber w肵lɂȂĂꍇ
	  	āAuPy[W̃XN[ɂ́A FixafterColumnNumber 
	  	ɕύX΂悢v߂܂B
	   @param pIfDcdTarget [in]
	  	`̈w肵ĂB
	   @param iFixafterColumnNumber [in]
	  	Py[W̃XN[sꍇ̊ɂȂA FixafterColumnNumber
	  	w肵ĂB
	   @param bPagedown [in]
	  	- false ;	//	Pageup(-)̃XN[
	  	- true ;	//	Pagedown(+)̃XN[
	   @return 
	  	Py[W̃XN[s߂́AV
	  	 FixafterColumnNumber Ԃ܂B@n
	  	bPagedown ^ getXColumnCount() A
	  	bPagedown U getXFixColumnCount() - 1 ̏ꍇA
	  	ȏ̃XN[삪łȂƂ܂B
	 */
	int calcYFixafterColumnNumberPagemove( IfDcdTarget* pIfDcdTarget , 
		int iFixafterColumnNumber , bool bPagedown ) ;

	/**
	  	ŸʒuԂ܂AXN[@\ɂĔ\ɂȂĂ
	  	Yi YFixafterColumnNumber j̈ʒuԂ܂B̏ꍇA
	  	ŸʒúAŒYɏdȂAObḧԏ
	  	Ȃ邱Ƃ܂B
	   @param pIfDcdTarget [in]
	  	`Ώۂw肵ĂB 
	   @param iYColumnNumber [in]
	  	Yԍw肵ĂB
	  	INT_MAX ́AŏIw肵̂Ƃ݂Ȃ܂B
	   @return
	  	Y͈̔͂Ԃ܂B
	  
	   @attention
	  	̊֐́AcreateZoneCacnẻe󂯂܂B
	  	̊֐ AČĂяoꍇ́A
	  	O createZoneCache() ĂяoƁA
	  	ptH[}XP܂B
	 */
	virtual CdDcdZone	getYColumnZoneOverlap( 
			IfDcdTarget* pIfDcdTarget , int iYColumnNumber ) ;
	/**
	  	ẌʒuԂ܂AXN[@\ɂĔ\ɂȂĂ
	  	Xi XFixafterColumnNumber j̈ʒuԂ܂B̏ꍇA
	  	ẌʒúAŒXɏdȂAObḧԍ
	  	Ȃ邱Ƃ܂B
	   @param pIfDcdTarget [in]
	  	`Ώۂw肵ĂB 
	   @param iXColumnNumber [in]
	  	Xԍw肵ĂB
	  	INT_MAX ́AŏIw肵̂Ƃ݂Ȃ܂B
	   @return
	  	X͈̔͂Ԃ܂B
	  
	   @attention
	  	̊֐́AcreateZoneCacnẻe󂯂܂B
	  	̊֐ AČĂяoꍇ́A
	  	O createZoneCache() ĂяoƁA
	  	ptH[}XP܂B
	 */
	virtual CdDcdZone	getXColumnZoneOverlap( 
			IfDcdTarget* pIfDcdTarget , int iXColumnNumber ) ;

	/**
	  	Z̈ʒuԂ܂AXN[@\ɂĔ\ɂȂĂ
	  	Z̈ʒuԂ܂B̏ꍇA
	  	̃Z̈ʒúAŒYEXɏdȂA
	  	ObḧԍEԏ
	  	Ȃ邱Ƃ܂B
	   @param pIfDcdTarget [in]
	  	`Ώۂw肵ĂB 
	   @param iXColumnNumber [in]
	  	Xԍw肵ĂB
	  	INT_MAX ́AŏIw肵̂Ƃ݂Ȃ܂B
	   @param iYColumnNumber [in]
	  	Yԍw肵ĂB
	  	INT_MAX ́AŏIw肵̂Ƃ݂Ȃ܂B
	   @return
	  	Z͈̔͂Ԃ܂B
	  
	   @attention
	  	̊֐́AcreateZoneCacnẻe󂯂܂B
	  	̊֐ AČĂяoꍇ́A
	  	O createZoneCache() ĂяoƁA
	  	ptH[}XP܂B
	 */
	virtual CdDcdZoneXy	getCellZoneOverlap( 
		IfDcdTarget* pIfDcdTarget , int iXColumnNumber , int iYColumnNumber ) ;
	
	///@}
 public:
	// ********************************
	///	@name	CDcdGrid-
	// ********************************
	///@{
	/**
		 Cell Aw肳ꂽ XColumn,YColumn̐ړꏊ
		Cell ߂邱Ƃł܂B
		  ړ̍ۂ́AAttachedCell ̓XLbvĈړ܂B
		  ړ́A XColumn E  YColumn ړ܂B
		  CDcdGrid ͈̔͂zĂ̈ړ͍s܂B
		͈͂zĂ̈ړ悤ƂꍇA
		ړ Cell  ColumnNumber ́A 0 E 
		܂ ColumnCount - 1 ƂȂ܂B
	 @param pCDcdGridCell [in]
		ړ̃Zw肵ĂB
	 @param iXColumnMoveCount [in]
		ړ XColumn ̗ʂw肵ĂB
		XColumn  ̐̏ꍇ͍ւ̈ړA
		̐̏ꍇ͉Eւ̈ړƂȂ܂B
	 @param iYColumnMoveCount [in]
		ړ YColumn ̗ʂw肵ĂB
		YColumn  ̐̏ꍇ͏ւ̈ړA
		̐̏ꍇ͉ւ̈ړƂȂ܂B
	 @param bSkipScrolloutColumn [in]
		^ȂAScrolloutColumn щzĈړ܂B
		UȂAScrolloutColumn ւړ܂B
		̂ƂAKvȂ XN[܂
		iFixafterColumnNumber ύX܂jB
	 @return 
		ړ̃ZԂ܂B
	 */
	CDcdGridCell* calcMovedCell( CDcdGridCell* pCDcdGridCell , 
		int iXColumnMoveCount , int iYColumnMoveCount ,
		bool bSkipScrolloutColumn = false ) ;


	/**
		ԍ iXColumnNumber ŜAIfDcdTargeẗ̗ɊS
		\邱Ƃ̂łAŏ 
		XFixafterColumnNumber ߂܂B
	 @param pIfDcdTarget [in]
		`Ώۂ pIfDcTarget C^[tF[Xw肵ĂB
	 @param iXColumnNumber [in]
		\s̗ԍw肵ĂB
	 @return 
		ԍ iXColumnNumber ɑ΂
		"XFixafterColumnNumberMinForColumn"
		iɑ΂ŏFixafterColumnNumberjԂ܂B
		̒l̍őĺA iXColumnNumber łB
		FixafterColumnNumnberForColumnNumber  iXColumnNumber 
		ꍇAFocusCellColumnNumber ̗ŜEChE
		\Ƃ͌܂B
		i̕EChẼTCYقǑ傫ꍇ
		ɂ܂j@n
		iXColumnNumber  FixColumn ̏ꍇ́AG[ -1 Ԃ܂B
	 */
	int calcXFixafterColumnNumberMinForColumn( 
		IfDcdTarget* pIfDcdTarget , int iXColumnNumber ) ;
	
	/**
		ԍ iYColumnNumber ŜAIfDcdTargeẗ̗ɊS
		\邱Ƃ̂łAŏ 
		YFixafterColumnNumber ߂܂B
	 @param pIfDcdTarget [in]
		`Ώۂ pIfDcTarget C^[tF[Xw肵ĂB
	 @param iYColumnNumber [in]
		\s̗ԍw肵ĂB
	 @return 
		ԍ iYColumnNumber ɑ΂
		"YFixafterColumnNumberMinForColumn"
		iɑ΂ŏFixafterColumnNumberjԂ܂B
		̒l̍őĺA iYColumnNumber łB
		FixafterColumnNumnberForColumnNumber  iYColumnNumber 
		ꍇAFocusCellColumnNumber ̗ŜEChE
		\Ƃ͌܂B
		i̕EChẼTCYقǑ傫ꍇ
		ɂ܂j@n
		iYColumnNumber  FixColumn ̏ꍇ́AG[ -1 Ԃ܂B
	 */
	int calcYFixafterColumnNumberMinForColumn(
		IfDcdTarget* pIfDcdTarget , int iYColumnNumber ) ;

	/**
		IfDcdTargeẗ̗őS\łĂ
		ő ColumnNumber ߂܂B
	 @param pIfDcdTarget [in]
		`Ώۂ pIfDcTarget C^[tF[Xw肵ĂB
	 @return 
		ԍ Ԃ܂B
		-	-1 ;	//	S\łĂ񂪂ЂƂȂꍇ
	 */
	int getXColumnNumberMaxInDcdTarget( 
		IfDcdTarget* pIfDcdTarget ) ;
	
	/**
		IfDcdTargeẗ̗őS\łĂ
		ő ColumnNumber ߂܂B
	 @param pIfDcdTarget [in]
		`Ώۂ pIfDcTarget C^[tF[Xw肵ĂB
	 @return 
		ԍ Ԃ܂B
		-	-1 ;	//	S\łĂ񂪂ЂƂȂꍇ
	 */
	int getYColumnNumberMaxInDcdTarget( 
		IfDcdTarget* pIfDcdTarget ) ;
	
	///@}

};

} //namespace DcdGrid
} //namespace DcDrawLib

#endif /*CDcdGrid_h*/
