/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/** @file */
//$Id: CMuiCopiedParent.h 369 2016-08-20 13:40:07Z okm $
#ifndef  OuLib_NsMu_CMuiCopiedParent_h
#define  OuLib_NsMu_CMuiCopiedParent_h

#include "CMuiCopied.h"
#include "CParentBase.h"
#include "CChildBase.h"

#include <limits.h>
#include <deque>

namespace OuLib{
namespace NsMu{



/**
@brief
@ElementTypeNX̃IuWFNgێReiłBweqReixp^[̐eIuWFNgƂċ@\܂B

@ref parent_child_container

@qIuWFNg(ReĩACe)AeIuWFNg(gێĂRei)ɃANZX邱Ƃł܂B

@̃NXev[ǵACMuiCopied {NXƂĂ܂B

@qIuWFNgeIuWFNg(this)ɒǉꂽƂAeIuWFNǵAqIuWFNg CChildBase::setParent() \bhĂяoāAeIuWFNg(this)̃AhXqIuWFNgɓo^܂B̂ƂneIuWFNǧ^́ACParentBase* łB
@qIuWFNǵACChildBase::getParent() ŁAeIuWFNg̃AhX擾ł܂BCChildBase::getParent() Ԃ CParentBase* łBqIuWFNǵÃAhXAۂ̐eIuWFNg(Rei)̌^Ƀ_ELXg邱ƂɂAeIuWFNg̃\bhĂяoƂł܂B

@
@param ElementType
  i[IuWFNǧ^w肵ĂB
@ElementTypéACChildBase p^łȂĂ͂Ȃ܂B
@param ContType
  ElementType* ێSTLReiw肵ĂB
  ł́Astd::deque łA std::vector gƂł܂B
*/
template <
	class ElementType,
	class ContType =std::deque< ElementType* > >
class CMuiCopiedParent 
	: public CMuiCopied< ElementType , ContType > 
	, public CParentBase
{
public:
	// ********************************
	// RXgN^
	// ********************************
	/** ftHgRXgN^ */
	CMuiCopiedParent(){} ; 
	
	/** 
		Rs[RXgN^B
		value Ɋi[ĂIuWFNg̃Rs[Ag̎qACe
		܂B
		SĂ̎qACeɑ΂āAsetParent( this ) s܂B
	*/
	CMuiCopiedParent( const CMuiCopiedParent<ElementType,ContType>& value )
		: CMuiCopied( value ) 
	{
		//	SĂ̗vfɑ΂āAsetParent()s
		for ( int idx = 0 ; idx < value.size() ; idx ++ )
		{
			getMuPtr()->get( idx )->setParent( this ) ;
		}
	};

	/** 
		ZqB
		value Ɋi[ĂIuWFNg̃Rs[Ag̎qACe
		܂B
		SĂ̎qACeɑ΂āAsetParent( this ) s܂B
	*/
	CMuiCopiedParent& operator=( 
		const CMuiCopiedParent<ElementType,ContType>& value ) 
	{
		CMuiCopied::operator=( value ) ; 
		
		//	SĂ̗vfɑ΂āAsetParent()s
		for ( int idx = 0 ; idx < value.size() ; idx ++ )
		{
			getMuPtr()->get( idx )->setParent( this ) ;
		}

		return *this ;
	};
	// ********************************
	///@name Mu
	// ********************************

	///@{

	/**
		Rei̎qACẽRs[擾܂B
		̊֐ԂRs[́Athis ̎qACeł͂܂B
		Rs[ CChildItem::m_pParent NULLłB
	@param iIndex
		0 n܂CfNXw肵ĂB ͈͂ 0 ȏ size() 
		łB AAINT_MAX ́Aw肵̂Ƃ݂Ȃ܂B 
	*/
	virtual ElementType  get (int iIndex) const
	{
		ElementType value 
			= CMuiCopied< ElementType , ContType >::get( iIndex ) ;
		value.setParent( NULL ) ; 
		return value ;
	}
	///@}
	// ********************************
	///@name Mui
	// ********************************
	///@{

	/**
		ReíACfNXŎw肳ꂽꏊɁA vf̃Rs[
		ǉ܂B 
		ǉꂽRs[ CChildItem::m_pParent ɂ́Athis o^܂B
	@param element
		vfw肵ĂB 
	@param iIndex
		0 n܂CfNXw肵ĂB 
		͈͂͂Oȏ size() ȉłB ÓA擪Esize()Ȃ疖ւ
		ǉɂȂ܂B AAINT_MAX ́Aw肵̂Ƃ݂Ȃ܂B 
	*/
	virtual int insert( const ElementType& element ,  int iIndex=INT_MAX) 
	{
		if ( iIndex == INT_MAX )
		{
			iIndex = size() ;
		}
		CMuiCopied< ElementType , ContType >::insert( element , iIndex ) ;
		getMuPtr()->get( iIndex )->setParent( this ) ;  

		return 0 ; 
	}
	/**
		ReíACfNXŎw肳ꂽꏊɁA vf㏑܂B 
		㏑̗vf CChildItem::m_pParent ɂ́Athis o^܂B
	@param element
		vfw肵ĂB 
	@param iIndex
		On܂CfNXw肵ĂB ͈͂͂Oȏ size() 
		łB AAINT_MAX ́Aw肵̂Ƃ݂Ȃ܂B 
	*/
	virtual int set( const ElementType& element , int iIndex ) 
	{
		if ( iIndex == INT_MAX )
		{
			iIndex = size() - 1 ;
		}
		CMuiCopied< ElementType , ContType >::set( 
			element , iIndex ) ;
		getMuPtr()->get( iIndex )->setParent( this ) ;  
		return 0 ; 
	}
	///@}
};


} //namespace NsMu
} //namespace OuLib
#endif //OuLib_NsMu_CMuiCopiedParent_h
