/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	vectorToFile.cpp
// ****************************************************************
//yTvz
//	vector<char> ̓et@C֏o
//	t@C̓e vector<char> ւ̓ǂݍ
//	s֐łB
*/
#include "vectorToFile.h"
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <tchar.h>
#include <wchar.h>
#include "Str\strToWstr.h"

namespace OuLib{
namespace Str{

// ****************************************************************

int vectorToFile( const std::vector<TCHAR>& aVector ,
					const tstring& strFilename ) 
{
	int	iRv = 0 ;
	if ( strFilename.empty() )
	{
		iRv = -1 ;	//	t@CI[vG[
	}
	if ( iRv >= 0 )
	
	{
		//FILE*	pFile = _tfopen( strFilename.c_str() , _T("wb") ) ;
		FILE*	pFile;
		errno_t err;
		err = _tfopen_s(&pFile,strFilename.c_str(), _T("wb"));
		
		if (err == 0 ){
			//if (pFile != NULL) {
			int	iReadBytes = 0 ;
			iReadBytes = fwrite( &aVector.front() , 1 , 
								aVector.size() , pFile ) ;
			if ( iReadBytes != aVector.size() ){
				iRv = -2 ;	//	݂Ɏs܂B
			}
			if ( fclose( pFile ) != 0 ){
				if ( iRv >= 0 ){
					iRv = -2 ;	//	݂Ɏs܂B
				}
			}
		}	else	{
			iRv = -1 ;	//	t@CI[vG[
		}
	}
	return ( iRv ) ;
}


int vectorFromFile( std::vector<TCHAR>* pVector ,
					const tstring& strFilename ) 
{
	int	iRv = 0 ;
	
	if ( strFilename.empty() )
	{
		iRv = -1 ;	//	t@CI[vG[
	}
	
	
	if ( iRv >= 0 ){
		pVector->clear() ;
	}
	if ( iRv >= 0 ){
		
		
		//FILE*	pFile = _tfopen( strFilename.c_str() , _T("rb") ) ;
		FILE*	pFile;
		errno_t err;
		err = _tfopen_s(&pFile, strFilename.c_str(), _T("rb"));

		if (err == 0) {
		//if ( pFile != NULL ){
			TCHAR	szLs[1024] ;
			int	iReadBytes = 0 ;
			do{
				iReadBytes = fread( szLs , 1 , sizeof(szLs) , pFile ) ;
				if ( iReadBytes > 0 ){
					pVector->insert( pVector->end() , szLs , 
													szLs + iReadBytes ) ;
				}	else if ( iReadBytes < 0 ){
					iRv = -2 ;	//	ǂݍ݂Ɏs܂B
				}
			}	while ( iReadBytes > 0 && iRv >= 0 ) ;
			if ( fclose( pFile ) != 0 ){
				if ( iRv >= 0 ){
					iRv = -2 ;	//	ǂݍ݂Ɏs܂B
				}
			}
		}	else	{
			iRv = -1 ;	//	t@CI[vG[
		}

	}
	return ( iRv ) ;
}



int stringToFile( const tstring& aString , 
					const tstring& strFilename ) 
{
	int	iRv = 0 ;
	if ( strFilename.empty() )
	{
		iRv = -1 ;	//	t@CI[vG[
	}
	if ( iRv >= 0 ){
		//FILE*	pFile = _tfopen( strFilename.c_str() , _T("wt") ) ;

		FILE*	pFile;
		errno_t err;
		err = _tfopen_s(&pFile, strFilename.c_str(), _T("w , ccs=UTF-8"));

		if (err == 0) {
		//if ( pFile != NULL ){
			int	iReadBytes = 0 ;
			iReadBytes = fwrite( aString.c_str() , sizeof(TCHAR) , 
								aString.size() , pFile ) ;
			if ( iReadBytes != aString.size() ){
				iRv = -2 ;	//	݂Ɏs܂B
			}
			if ( fclose( pFile ) != 0 ){
				if ( iRv >= 0 ){
					iRv = -2 ;	//	݂Ɏs܂B
				}
			}
		}	else	{
			iRv = -1 ;	//	t@CI[vG[
		}
	}
	return ( iRv ) ;
}

int stringToFileANSI(const tstring& aString,
	const tstring& strFilename)
{
	int	iRv = 0;
	if (strFilename.empty())
	{
		iRv = -1;	//	t@CI[vG[
	}
	if (iRv >= 0) {
		//FILE*	pFile = _tfopen( strFilename.c_str() , _T("wt") ) ;

		FILE*	pFile;
		errno_t err;
		err = _tfopen_s(&pFile, strFilename.c_str(), _T("wt"));
		std::string aStringTemp = stringOf(aString);
		if (err == 0) {
			//if ( pFile != NULL ){
			int	iReadBytes = 0;
			iReadBytes = fwrite(aStringTemp.c_str(), sizeof(char),
				aStringTemp.size(), pFile);
			if (iReadBytes != aStringTemp.size()) {
				iRv = -2;	//	݂Ɏs܂B
			}
			if (fclose(pFile) != 0) {
				if (iRv >= 0) {
					iRv = -2;	//	݂Ɏs܂B
				}
			}
		}
		else {
			iRv = -1;	//	t@CI[vG[
		}
	}
	return (iRv);
}




int stringFromFile( tstring* pString , 
					const tstring& strFilename ) 
{
	int	iRv = 0 ;
	
	if ( strFilename.empty() )
	{
		iRv = -1 ;	//	t@CI[vG[
	}
	
	if ( iRv >= 0 ){
		pString->erase() ;
	}
	// --------------------------------
	//	t@CTCYǂ݂āA
	//	string Ƀm
	// --------------------------------
	if ( iRv >= 0 ){
		long lSize = 0 ;
		struct _stat aStat ;
		if (_tstat( strFilename.c_str() , &aStat ) == 0 ){
			lSize = aStat.st_size ;
			if ( lSize > 0 ){
				pString->reserve( lSize ) ;
			}
		}
	}
	// --------------------------------
	bool bUTF8 = true;
	//ltrue,SJISzł̓ǂݍdo[vɁABOM`FbNA
	//UTF-8BOMmFłꍇ́Atruê܂܂ŁABOMꍇfalseɂB
	//truȅꍇAdo[v甲ApStringւ̏o̓XLbvAfclosêݍsB
	//ltrueȂ̂́Ado[v̏񂩂ǂm߂邽(2ڈȍ~́AfalseɂȂ邽߁A`FbNɓȂ)
	//̌AUTF-8zł̓ǂݍ݂ɓB

	//ShiftJIS
	if ( iRv >= 0 )
	{
		FILE*	pFile;
		errno_t err;
		err = _tfopen_s(&pFile, strFilename.c_str(), _T("rt"));

		if (err == 0) {
			char szLsc[1024 + 1];
			std::string aStringTemp;
			int	iReadBytes = 0 ;
			do{
				iReadBytes = fread(szLsc, 1, sizeof(szLsc) - sizeof(char), pFile);
				if (bUTF8)
				{
					if (iReadBytes / sizeof(char) < 3)
					{
						bUTF8 = false;
					}
					else if(szLsc[0] == '\xEF' &&
						szLsc[1] == '\xBB' &&
						szLsc[2] == '\xBF')
					{
						//bUTF8 = true;
						break;
					}
					else
					{
						bUTF8 = false;
					}

				}
				if ( iReadBytes > 0 )
				{
					int cBytes = iReadBytes / sizeof(char);
					szLsc[cBytes] = '\0' ;
					int idx ;
					for (idx = 0; szLsc[idx] != '\0'; idx++) {};
					if (idx != cBytes)
					{
						iRv = -3 ;	//	t@Cɂ'\0' ܂܂܂B
					}	else	{
						aStringTemp += szLsc;
					}
				}	
				else if ( iReadBytes < 0 )
				{
					iRv = -2 ;	//	ǂݍ݂Ɏs܂B
				}
			}	while ( iReadBytes > 0 && iRv >= 0 ) ;
			if (!bUTF8)
			{
				tstring aStringWTemp = tstringOf(aStringTemp);

				for (int idx = 1; idx < (int)aStringWTemp.length(); idx++)
				{
					tstring Moji5c = _T("\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\xx\\");
						/*{ _T("\"), _T("\"), _T("\"), _T("\"), _T("\"),
						_T("\"), _T("\"), _T("\"), _T("\."), _T("\"),
						_T("\"), _T("\"), _T("\"), _T("\"), _T("\"),
						_T("\"), _T("\"), _T("\"), _T("\"), _T("\"),
						_T("\"), _T("\"), _T("\"), _T("\"), _T("\"),
						_T("\"), _T("\"), _T("\"), _T("\"), _T("\"),
						_T("\"), _T("\"), _T("\"), _T("\"), _T("\"),
						_T("\"), _T("\"), _T("\"), _T("x"), _T("x"),
						_T("\"), _T("\") };*/
					if (aStringWTemp[idx] == '\\')
					{
						for (int idx5c = 0; idx5c < (int)Moji5c.length(); idx5c++)
						{
							if (aStringWTemp[idx - 1] == Moji5c[idx5c])
							{
								//int c = 0;
								aStringWTemp.erase(idx, 1);
								break;
							}
						}
					}
				}

				*pString = aStringWTemp;
				//*pString = tstringOf(aStringTemp);
			}
			if ( fclose( pFile ) != 0 ){
				if ( iRv >= 0 ){
					iRv = -2 ;	//	ǂݍ݂Ɏs܂B
				}
			}
		}	else	{
			iRv = -1 ;	//	t@CI[vG[
		}

	}
	//UTF-8
	if (iRv >= 0 && bUTF8)
	{
		FILE*	pFile;
		errno_t err;
		err = _tfopen_s(&pFile, strFilename.c_str(), _T("r, ccs=UTF-8"));

		if (err == 0) {
			TCHAR	szLs[1024 + 1];
			//char szLsc[1024 + 1];
			//std::string aStringTemp;
			int	iReadBytes = 0;
			do {
				//iReadBytes = fread(szLsc, 1, sizeof(szLsc) - sizeof(char), pFile);
				iReadBytes = fread( szLs , 1 , sizeof(szLs) - sizeof(TCHAR), pFile ) ;
				if (iReadBytes > 0)
				{
					int tBytes = iReadBytes / sizeof(TCHAR);
					//int cBytes = iReadBytes / sizeof(char);
					szLs[tBytes] = '\0' ;
					//szLsc[cBytes] = '\0';
					int idx;
					for ( idx = 0 ; szLs[idx] != '\0' ; idx ++ ){} ;
					//for (idx = 0; szLsc[idx] != '\0'; idx++) {};
					if ( idx != tBytes)
					//if (idx != cBytes)
					{
						iRv = -3;	//	t@Cɂ'\0' ܂܂܂B
					}
					else {
						*pString += szLs ;
						//mbstowcs(szLs, szLsc, 1025);
						//aStringTemp += szLsc;
						//*pString += szLsc;
					}
				}
				else if (iReadBytes < 0)
				{
					iRv = -2;	//	ǂݍ݂Ɏs܂B
				}
			} while (iReadBytes > 0 && iRv >= 0);
			//*pString = tstringOf(aStringTemp);
			if (fclose(pFile) != 0) {
				if (iRv >= 0) {
					iRv = -2;	//	ǂݍ݂Ɏs܂B
				}
			}
		}
		else {
			iRv = -1;	//	t@CI[vG[
		}

	}
	return ( iRv ) ;
}


} //namespace Str{
} //namespace OuLib{
