/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
// CMainFrame.cpp : CMainFrame NX̓̒`s܂B
//	$Id: CMainFrame.cpp 295 2016-06-11 05:14:13Z okm $
/** @file */

#include "stdafx.h"

#include "NsOu/OuNew.h"
#include "str/vectorToFile.h"
#include "str/strToWstr.h"
#include "str/tstring.h"
#include "str\OuPropertiesText\ErrorInfo\COuErrorInfoContainer.h"
#include "str\OuPropertiesText\CConvNodeContainer.h"


#include "DiagramEdit.h"
#include "CMainFrame.h"
#include "DedRosenFileData\EditCmd\EditCmd.h"
#include "DedRosenFileData\CconvCDedRosenFileData.h"
#include "ViewRosen\CDlgRosenFileProp.h"
#include "ViewRosen\CDlgDiaList.h"
#include "ViewRosen\CDlgRosenCreateSubRosen.h"
#include "ViewRosen\CDlgRosenfileInsert.h"

using namespace std ;
using namespace OuLib::Str ;
using namespace OuLib::Str::OuPropertiesText ;
using namespace OuLib::Str::OuPropertiesText::ErrorInfo ;


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame
// --------------------------------
//	CFrameWnd
// --------------------------------
void CMainFrame::RecalcLayout( BOOL bNotify )
{
	CWndSplitBarV::CMDIFrameWnd_RecalcLayout( this , 
		&m_CDlgRosenView , &m_CWndSplitBarV , bNotify ) ;
}
void CMainFrame::OnSetPreviewMode( BOOL bPreview, CPrintPreviewState* pModeStuff )
{
	m_CDlgRosenView.EnableWindow( !bPreview ) ;
	super::OnSetPreviewMode(  bPreview, pModeStuff ) ;
}
	// --------------------------------
	//@name j[R}h̉֐
	// --------------------------------
//	[t@C]-[Ht@C̑g]
int CMainFrame::OnFileRosenFileInsert_Process( BOOL bQueryEnable ) 
{
	int iRv = 0; 
	// ****************************************************************
	//	R}h̗LE
	// ****************************************************************
	const CDedRosenFileData* pRosenFileDataCurrent = getCDiagramEditDoc()->getCDedRosenFileData() ;
	if ( iRv >= 0 )
	{
		//	w2ȂÃR}h͎gpł܂B
		const CentDedEkiCont* pEkiCont = pRosenFileDataCurrent->getCentDedRosen()->getCentDedEkiCont() ;
		if ( pEkiCont->size() < 2 )
		{
			iRv = -21 ;	//	w2ȂÃR}h͎gpł܂B
		}
	}

	if ( bQueryEnable || iRv < 0 )
	{
		return iRv ;
	}
	// ****************************************************************
	//	R}h̎s
	// ****************************************************************
	CString strErrorMsgSub ;

	//(2)[Ht@C̑g]_CAO
	CString strOudFilename ;
	int iEkiIndexToInsert = -1 ;
	{
		const CentDedEkiCont* pCentDedEkiCont = pRosenFileDataCurrent->getCentDedRosen()->getCentDedEkiCont() ;
		CDlgRosenfileInsert	aDlg( *pCentDedEkiCont , this ) ;
		int iResult = aDlg.DoModal() ;
		if ( iResult != IDOK )
		{
			iRv = -1 ;	//	[U[ɂLZ
		}
		else
		{
			iEkiIndexToInsert = aDlg.getEkiIndexToInsert() ;
			strOudFilename = aDlg.getOudFilenameToInsert() ;
		}
	}
	//strOudFilename = t@C_CAOŎw肳ꂽ .oud t@C
	//iEkiIndexToInsert = gwIndex
	
	// --------------------------------
	//	.oudt@Cǂݍ
	//	CDedRosenFileData 𐶐
	// --------------------------------
	CDedRosenFileData	rosenfiledataAdd ;
	if ( iRv >= 0 )
	{
		tstring strFileContent ;
		if ( iRv >= 0 )
		{
			int iResult = stringFromFile( 
				&strFileContent , 
				tstringOf( (LPCTSTR)strOudFilename ) ) ;
			if ( iResult < 0 )
			{
				iRv = -11 ;	//	t@C݂܂B
			}
		}
		if ( iRv >= 0 )
		{
			CconvCDedRosenFileData	aConv ;
			COuErrorInfoContainer	aCOuErrorInfoContainer ;
			int iResult = aConv.CDedRosenFileData_from_string( 
				&rosenfiledataAdd , 
				strFileContent , 
				&aCOuErrorInfoContainer ) ;
			if ( iResult < 0 )
			{
				strErrorMsgSub = aCOuErrorInfoContainer.toOuErrorInfoText().c_str() ;
				iRv = -12 ;	//	t@Č`słB
			}
		}
	}
	//rosenfiledataAdd = ǉ .oud ̃f[^ێĂ܂B

	// --------------------------------
	//	rosenfiledataCurrent ̘H̖
	//	rosenfiledataAdd ̘Hǉ
	// --------------------------------
	CDedRosenFileData rosenfiledataCurrent = *getCDiagramEditDoc()->getCDedRosenFileData() ;
	if ( iRv >= 0 )
	{
		CentDedRosen* prosenCurrent = rosenfiledataCurrent.getCentDedRosen() ;
		CentDedRosen* prosenAdd = rosenfiledataAdd.getCentDedRosen() ; 
		prosenCurrent->insert( *prosenAdd , iEkiIndexToInsert ) ;

		Ou< CRfEditCmd > pCmd = OuNew< CRfEditCmd >( new
			CRfEditCmd_Rosen( *prosenCurrent ) ) ;
		getCDiagramEditDoc()->executeEditCmd( pCmd ) ;
	}
	// ****************************************************************
	//	G[bZ[W
	// ****************************************************************
	CString strErrorMsg ;
	if ( iRv < 0 )
	{
		switch( iRv )
		{
		case -1 :	//	LZ
			break ;
		case -11 :	//	t@C݂܂B
			strErrorMsg.Format( IDS_ERR_FILENOTFOUND , strOudFilename ) ;
		case -12 :	//	t@Č`słB
			strErrorMsg.Format( IDS_ERR_FILEFORMAT , strOudFilename ) ;
		default:
			strErrorMsg.Format( _T( "Error(%d)" ) , iRv ) ;
			break ;
		}
		if ( !strErrorMsgSub.IsEmpty() )
		{

			strErrorMsg += _T( "\n" ) ;
			strErrorMsg += strErrorMsgSub ;
		}
	}
	if ( !strErrorMsg.IsEmpty() )
	{
		MessageBox( strErrorMsg , NULL , MB_ICONSTOP ) ;
	}
	return iRv ;
}

//[t@C]-[Ht@C̐؂o]
int CMainFrame::OnFileRosenCreateSubRosen_Process( BOOL bQueryEnable ) 
{
	int iRv = 0;
	// ****************************************************************
	//	R}h̗LE
	// ****************************************************************
	{
		int iEkiCount = getCDiagramEditDoc()->getCDedRosenFileData()->getCentDedRosen()->getCentDedEkiCont()->size() ;
		if ( iEkiCount < 3 )
		{
			iRv = -31 ;	//	3w̘Hł́Agpł܂B
		}
	}
	if ( bQueryEnable || iRv < 0 )
	{
		return iRv ;
	}
	// ****************************************************************
	//	R}h̎s
	// ****************************************************************
	CString strErrorMsgSub ;
	CDedRosenFileData rosenfiledataCurrent = *getCDiagramEditDoc()->getCDedRosenFileData() ;

	//(2)[ꕔwԂ̘Ht@C쐬]_CAO
	int iEkiIndex = 0 ;
	int iEkiCount = 0 ;
	bool bEnableOuter = false;
	if ( iRv >= 0 )
	{
		const CentDedEkiCont& aCentDedEkiCont = *rosenfiledataCurrent.getCentDedRosen()->getCentDedEkiCont() ;
		CDlgRosenCreateSubRosen	aDlg( aCentDedEkiCont , this ) ;
		int iResult = aDlg.DoModal() ;
		if ( iResult != IDOK )
		{
			iRv = -1 ;	//	[U[ɂLZ
		}
		else
		{
			iEkiIndex = aDlg.getSihatsuEkiIndex() ;
			iEkiCount = aDlg.getSyuuchakuEkiIndex() + 1 - iEkiIndex ;
			bEnableOuter = aDlg.getEnableOuter();
		}
	}
	//iEkiIndex = VHt@ĆAnwIndex
	//iEkiCount = VHt@C̉w


	//@Oĕۑ_CAO
	CString strNewOudFilename ;
	if ( iRv >= 0 )
	{
		CString	strExt ;
		getCDiagramEditApp()->pRootDoctmpl()->GetDocString( strExt , CDocTemplate::filterExt ) ;
		CFileDialog	aDlg( FALSE , strExt , NULL ,
			OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT | OFN_PATHMUSTEXIST,
			getCDiagramEditApp()->getCFileDialogFilterSave() , this ) ;
		int iResult = aDlg.DoModal() ;
		if ( iResult != IDOK )
		{
			iRv = -1 ;	//	[U[ɂLZ
		}
		else
		{
			strNewOudFilename = aDlg.GetPathName() ;
		}
	}
	//strNewOudFilename = VHt@C

	// --------------------------------
	//	rosenfiledataCurrent ̘HA
	//	ꕔԂ̘H
	//	rosenfiledataSub 𐶐
	// --------------------------------
	CDedRosenFileData	rosenfiledataSub ;
	if ( iRv >= 0 )
	{
		rosenfiledataSub = rosenfiledataCurrent ;
		*rosenfiledataSub.getCentDedRosen() = 
			rosenfiledataCurrent.getCentDedRosen()->createSubRosen( iEkiIndex , iEkiCount , bEnableOuter) ;
	}
	// --------------------------------
	//	CDedRosenFileData 
	//	.oud2t@Cɕۑ
	// --------------------------------
	OuPropertiesText::CNodeContainer	aCNodeContainer ;  
	if ( iRv >= 0 )
	{
		CconvCDedRosenFileData aConv ;
		int iResult = aConv.CDedRosenFileData_to_OuPropertiesText( 
			&rosenfiledataSub , 
			&aCNodeContainer ) ;
		if ( iResult < 0 )
		{
			iRv = -11 ;	//	Hf[^̕ϊɎs܂B
		}
	}
	// --------------------------------
	//	FileTypeAppComment t^
	// --------------------------------
	if ( iRv >= 0 )
	{
		tstring strFileTypeAppComment ;
		strFileTypeAppComment += AfxGetAppName() ;
		strFileTypeAppComment += _T(" Ver. ") ;
		strFileTypeAppComment += getCDiagramEditApp()->getProgramVer() ;
		aCNodeContainer.setValue( nameFileTypeAppComment , strFileTypeAppComment );
	}
	// --------------------------------
	//	t@Cɕۑ
	// --------------------------------
	if ( iRv >= 0 )
	{
		OuPropertiesText::CConvNodeContainer aConv ;
		tstring strOudContent = aConv.encode( &aCNodeContainer ) ;
		int iResult = stringToFile( 
			strOudContent , 
			tstringOf( (LPCTSTR)strNewOudFilename ) ) ;
		//iResult 
		//	-1: t@CI[vł܂B
		//	-2 ; // ݂Ɏs܂B 
		if ( iResult < 0 )
		{
			iRv = iResult - 20 ;
		}
		//iRv
		//	-21: t@CI[vł܂B
		//	-22 ; // ݂Ɏs܂B 
		
	}
	// ****************************************************************
	//	G[bZ[W
	// ****************************************************************
	CString strErrorMsg ;
	if ( iRv < 0 )
	{
		switch( iRv )
		{
		case -21:	//	t@CI[vł܂B
			strErrorMsg.Format( IDS_ERR_FILECREATE , (LPCTSTR)strNewOudFilename ) ;
			break ;
		case -22: // ݂Ɏs܂B 
			strErrorMsg.Format( IDS_ERR_FILEWRITE , (LPCTSTR)strNewOudFilename ) ;
			break ;
		case -1: // [U[ɂLZ
			break ;
		default:
			strErrorMsg.Format( _T( "Error(%d)" ) , iRv ) ;
			break ;
		}
		if ( !strErrorMsgSub.IsEmpty() )
		{

			strErrorMsg += _T( "\n" ) ;
			strErrorMsg += strErrorMsgSub ;
		}
	}
	if ( !strErrorMsg.IsEmpty() )
	{
		MessageBox( strErrorMsg , NULL , MB_ICONSTOP ) ;
	}
	return iRv ;

}

// ********************************
//	CMainFrame
// ********************************
	// ********************************
	//@name	
	// ********************************
	/**
	 *	wHt@C̃vpeBx_CAOJ܂B
	 *
	 *	_CAOwOKxŕꂽAHt@C
	 *	vpeBw[ghLgx CDiagramEditDoc 
	 *	ɔf܂B
	 * @return
	 *	0 ȏ͐AG[Ȃ畉̐łB 
	 *	-	1 ;	//	wOKxāA͓e
	 *		w[ghLgxɔf܂B
	 *	-	0 ;	//	wCancelx܂B
	 *	
	 */
int CMainFrame::execCDlgRosenFileProp() 
{
	int iRv = 0 ;
	
	// --------------------------------
	//	r[̕ҏWe[ghLgɔf
	//	iɁARgr[j
	// --------------------------------
	getCDiagramEditDoc()->UpdateAllSubDocviews( NULL , LHINT_SUBVIEW_TO_ROOTDOC ) ;
	
	// --------------------------------
	const CDedRosenFileData*	pCDedRosenFileData = getCDiagramEditDoc()->getCDedRosenFileData() ;

	CDlgRosenFileProp	aPps( 
		pCDedRosenFileData , 
		this ) ;
	int iResult = aPps.DoModal() ;
	if ( iResult == IDOK ){
		// --------------------------------
		//	R}hIuWFNg̐Es
		// --------------------------------
		{
			Ou<CRfEditCmd> pCmd = aPps.getPropEditorData()->createEditCmd() ;
			int  iResult = getCDiagramEditDoc()->executeEditCmd( pCmd ) ;
			ASSERT( iResult >= 0 ) ;

		}

		iRv = 1 ;
	}
	return ( iRv ) ;
}
int CMainFrame::execCDlgDiaList() 
{
	int iRv = 0 ;

	CDlgDiaList	aDlg( getCDiagramEditDoc() , &m_CDlgRosenView ) ;
	aDlg.DoModal() ;
	
	return iRv ;
}

CView* CMainFrame::getMDIChildActiveView() 
{
	CView *pView = NULL ;
	{
		CMDIFrameWnd *pFrame = this ;
		CMDIChildWnd *pChild = pFrame->MDIGetActive();
		if ( pChild != NULL ){
			pView = pChild->GetActiveView();
		}
	}
	return pView ;
}

// ----------------------------------------------------------------



IMPLEMENT_DYNAMIC(CMainFrame, CHidemdiMainfrm)

BEGIN_MESSAGE_MAP(CMainFrame, CHidemdiMainfrm)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(ID_ROSEN_FILE_PROP, OnRosenFileProp)
	ON_COMMAND(ID_WINDOW_ROSEN_VIEW, OnWindowRosenView)
	ON_COMMAND(ID_ROSEN_DIALIST, OnRosenDialist)
	//}}AFX_MSG_MAP
	ON_UPDATE_COMMAND_UI(ID_INDICATOR_PasteZoubun, OnUpdateINDICATOR_PasteZoubun)
	ON_COMMAND(ID_FILE_ROSEN_FILE_INSERT, &CMainFrame::OnFileRosenfileInsert)
	ON_UPDATE_COMMAND_UI(ID_FILE_ROSEN_FILE_INSERT, &CMainFrame::OnUpdateFileRosenfileInsert)
	ON_COMMAND(ID_FILE_ROSEN_CREATE_SUB_ROSEN, &CMainFrame::OnFileRosenCreateSubRosen)
	ON_UPDATE_COMMAND_UI(ID_FILE_ROSEN_CREATE_SUB_ROSEN, &CMainFrame::OnUpdateFileRosenCreateSubRosen)
//	ON_COMMAND(ID_MENUITEM_OPEN, &CMainFrame::OnMenuitemOpen)
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // Xe[^X C CWP[^
	ID_INDICATOR_PasteZoubun , //	\tړ
	ID_INDICATOR_KANA,
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame NX̍\z/

CMainFrame::CMainFrame()
{
	// TODO: ̈ʒuɃȍR[hǉĂB
	
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CHidemdiMainfrm::OnCreate(lpCreateStruct) == -1)
		return -1;

	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // 쐬Ɏs
	}

	//attention Diagramc[o[́AMainFrameɓ
	//
	//	if (!m_wndToolBarDiagram.CreateEx(this, TBSTYLE_FLAT, 
	//		WS_CHILD | WS_VISIBLE | CBRS_TOP
	//		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
	//		!m_wndToolBarDiagram.LoadToolBar(IDR_DOCVIEW_Diagram))
	//	{
	//		TRACE0("Failed to create toolbar\n");
	//		return -1;      // 쐬Ɏs
	//	}



	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // 쐬Ɏs
	}

	// TODO: c[ o[hbLO\ɂȂꍇ͈ȉ̂Rs폜
	//       ĂB
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	//attention Diagramc[o[́AMainFrameɓ
	//	m_wndToolBarDiagram.EnableDocking(CBRS_ALIGN_ANY) ;
	//	DockControlBar(&m_wndToolBarDiagram);


	// ----------------------------------------------------------------
	// --------------------------------
	//	yC	
	// --------------------------------
	{
		m_CDlgRosenView.Create( m_CDlgRosenView.IDD , this ) ;
		m_CDlgRosenView.ShowWindow( SW_SHOW ) ;
	}

	// --------------------------------
	//	yCƂ̊Ԃ̃Xvbgo[	
	// --------------------------------
	{
		m_CWndSplitBarV.Create( this , &m_CDlgRosenView , 0 ) ;
	}



	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CHidemdiMainfrm::PreCreateWindow(cs) )
		return FALSE;
	// TODO: ̈ʒu CREATESTRUCT cs CāAWindow NXX^C
	//       CĂB

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame NX̐ff

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CHidemdiMainfrm::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CHidemdiMainfrm::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame bZ[W nh


void CMainFrame::OnRosenFileProp() 
{
	execCDlgRosenFileProp() ;
}


/**
 *	[EChE][yC̐؂ւ]
 *	j[R}h̉֐łB
 */
void CMainFrame::OnWindowRosenView() 
{
	if ( ::IsChild( m_CDlgRosenView.GetSafeHwnd() , ::GetFocus() ) ){
		//	yCɃtH[JXƂ
		//	MDIChildEChEɃtH[JXړ܂B
		CMDIChildWnd* pActive = MDIGetActive() ;
		if ( pActive != NULL ){
			pActive->SetFocus() ;
		}
	}	else	{
		//	yCɃtH[JXȂƂ
		//	yCɃtH[JXړ܂B
		m_CDlgRosenView.SetFocus() ;
	}
}
/**
 *	w\tړʁxXe[^Xo[ւ̃eLXgݒ肵܂B
 *
 * [I[oCh]
 *	󕶎ݒ肵܂B
 *
 * @note
 *	CJikokuhyouView ANeBuȂƂ́A
 *	CJikokuhyouView::OnUpdateINDICATOR_PasteZoubun()
 *	Őݒ肳܂B
 */
void CMainFrame::OnUpdateINDICATOR_PasteZoubun(CCmdUI *pCmdUI)
{
    pCmdUI->Enable( FALSE ); 
    pCmdUI->SetText( _T("") ); 

}

void CMainFrame::OnRosenDialist() 
{
	execCDlgDiaList() ;	
}


//	[t@C]-[Ht@C̑g]
void CMainFrame::OnFileRosenfileInsert()
{
	OnFileRosenFileInsert_Process( FALSE ) ;
}

void CMainFrame::OnUpdateFileRosenfileInsert(CCmdUI *pCmdUI)
{
	pCmdUI->Enable( OnFileRosenFileInsert_Process( TRUE ) >= 0 ) ;
}

//	[t@C]-[Ht@C̐؂o]
void CMainFrame::OnFileRosenCreateSubRosen()
{
	OnFileRosenCreateSubRosen_Process( FALSE ) ;
}

void CMainFrame::OnUpdateFileRosenCreateSubRosen(CCmdUI *pCmdUI)
{
	pCmdUI->Enable( OnFileRosenCreateSubRosen_Process( TRUE ) >= 0 ) ;
}

