/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CconvCdPrintPageProp.h
// ****************************************************************
*/
/** @file */

#ifndef  CconvCdPrintPageProp_h
#define  CconvCdPrintPageProp_h

#include "DcdCd\Pos\CdDcdZoneXy.h"

#include "CdPrintPageProp.h"
#include <windows.h>

namespace Print{
	using namespace DcDrawLib::DcdCd::Pos;
	using namespace DcDrawLib::DcDraw;

// ****************************************************************
//	CconvCdPrintPageProp
// ****************************************************************
/**
 *	@brief
 *	CdPrintPageProp IuWFNg̑Ǎ`ɕϊ铮񋟂܂B
 */
class CconvCdPrintPageProp
{
 public:
	/**
	 *	CdPrintPageProp ݂̗̌]
	 *	(m_dMarginLeftMm ,  m_dMarginTopMm , 
	 *	m_dMarginRightMm , m_dMarginBottomMm )̑ƂɁA
	 *	v^̕W]Ẅ߂܂B
	 *
	 * @param aCdPrintPageProp [in]
	 *	]̐ݒێĂ CdPrintPageProp IuWFNg
	 *	w肵ĂB
	 * @param hDc [in]
	 *	v^DCw肵ĂB
	 * @return 
	 *	v^̃foCXWA]Ẅ
	 *	Ԃ܂B
	 *
	 *	X̗]傫ꍇ	(m_dMarginLeftMm +m_dMarginRightMm 
	 *	v^̗̉p̑傫ꍇj́A
	 *	߂l CdDcdZone::getX().getSize() ̒l̐ɂȂ܂B
	 *	̏ꍇ́A炩̃G[ׂłB
	 *
	 *	lɁAY̗]傫ꍇ́A
	 *	߂l CdDcdZone::getY().getSize() ̒l̐ɂȂ܂B
	 *
	 *	̗]Av^̍̈󎚕s\̈̕菬ꍇ́A
	 *	ۂ̗]͈󎚕s\̈̕ƂȂ܂B̓́AEEE
	 *	̗]ɂĂ͂܂܂B
	 */
	CdDcdZoneXy calcZoneInnerMargin( 
		const CdPrintPageProp& aCdPrintPageProp , HDC hDc ) ;
	
	
	/**
	 *	v^DC ł́A
	 *	X̊eTCYAfoCXPʂŎ擾܂B
	 *	Win32  GetDeviceCaps() ̃bp[łƂ܂B
	 * @param hDc [in]
	 *	v^DCw肵ĂB
	 * @param piPhysicalPageSize [out]
	 *	̊֐́A
	 *	[̈󎚕s\̈܂߂A
	 *	Iȃy[Wiv^̗pj̑傫
	 *	ÃAhXɏ݂܂Bsvł NULL w肵Ă
	 *	܂܂B
	 * @param piPhysicalOffset1 [out]
	 *	̊֐́A
	 *	W̏ij̈󎚕s\̈̑傫
	 *	ÃAhXɏ݂܂Bsvł NULL w肵Ă
	 *	܂܂B
	 * @param piRes [out]
	 *	̊֐́A
	 *	󎚉\̈̑傫
	 *	ÃAhXɏ݂܂Bsvł NULL w肵Ă
	 *	܂܂B
	 * @param piPhysicalOffset2 [out]
	 *	̊֐́A
	 *	W̑傫iEj̈󎚕s\̈̑傫
	 *	ÃAhXɏ݂܂Bsvł NULL w肵Ă
	 *	܂܂B
	 */
	static void getPhysicalXPageSize( HDC hDc , 
		int* piPhysicalPageSize ,
		int* piPhysicalOffset1 ,
		int* piRes ,
		int* piPhysicalOffset2 ) ;

	/**
	 *	v^DC ł́A
	 *	Y̊eTCYAfoCXPʂŎ擾܂B
	 *	Win32  GetDeviceCaps() ̃bp[łƂ܂B
	 * @param hDc [in]
	 *	v^DCw肵ĂB
	 * @param piPhysicalPageSize [out]
	 *	̊֐́A
	 *	[̈󎚕s\̈܂߂A
	 *	Iȃy[Wiv^̗pj̑傫
	 *	ÃAhXɏ݂܂Bsvł NULL w肵Ă
	 *	܂܂B
	 * @param piPhysicalOffset1 [out]
	 *	̊֐́A
	 *	W̏i㑤j̈󎚕s\̈̑傫
	 *	ÃAhXɏ݂܂Bsvł NULL w肵Ă
	 *	܂܂B
	 * @param piRes [out]
	 *	̊֐́A
	 *	󎚉\̈̑傫
	 *	ÃAhXɏ݂܂Bsvł NULL w肵Ă
	 *	܂܂B
	 * @param piPhysicalOffset2 [out]
	 *	̊֐́A
	 *	W̑傫ij̈󎚕s\̈̑傫
	 *	ÃAhXɏ݂܂Bsvł NULL w肵Ă
	 *	܂܂B
	 */
	static void getPhysicalYPageSize( HDC hDc , 
		int* piPhysicalPageSize ,
		int* piPhysicalOffset1 ,
		int* piRes ,
		int* piPhysicalOffset2 ) ;
};

} //namespace Print

#endif /*CconvCdPrintPageProp_h*/
