/*
OuDiaSecond Copyright (C) 2017 diagram_mania

̃vÓAtake-okm쐬OuDia\tgEFAłB
̃vOpɂẮAtake-okmLڂ̉Lɏ܂B
*/
/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
// ****************************************************************
//	CRessyajouhouDraw.cpp
//	$Id: CRessyajouhouDraw.cpp 367 2016-08-19 10:14:24Z okm $
// ****************************************************************
/** @file */
#include "stdafx.h"
#include <math.h>

#include "DcDraw\CDcdText.h"
#include "DcDraw\CConverter_Wingdi.h"

#include "CRessyajouhouDraw.h"

namespace ViewDiagram{

using namespace std ;

// ****************************************************************
///	~
const double Pi = 3.14159265 ;

/**
 	px̒PʂAx烉WA֕ϊ܂B
 
 	180 x = 1 WA
  @param value [in]
 	ϊΏۂ̒lB
  @return
 	ϊ̒lB
*/
static double DegToRad( double value )
{
	return value * Pi / 180 ;
}

/**
 	px̒PʂAWAx֕ϊ܂B
 
 	180 x = 1 WA
  @param value [in]
 	ϊΏۂ̒lB
  @return
 	ϊ̒lB
*/
static double RadToDeg( double value )
{
	return value * 180 / Pi ;
}
	// ********************************
	//	RXgN^
	// ********************************
CRessyajouhouDraw::CRessyajouhouDraw( CDcdDiagram* pCDcdDiagram , 
			IfDcdTarget* pIfDcdTarget , 
			bool bDisplayRessyasenKudari ,
			bool bDisplayRessyasenNobori ) :
	super( 
		pCDcdDiagram->getCentDedDgrDia() , 
		pCDcdDiagram->DgrFromDcd( pIfDcdTarget , pIfDcdTarget->getZone() ) , 
		bDisplayRessyasenKudari , 
		bDisplayRessyasenNobori ) ,
	m_pCDcdDiagram( pCDcdDiagram ) ,
	m_pIfDcdTarget( pIfDcdTarget ) 
{
};

// ********************************
//	CDcdDiagram::CEnumRessyasen
// ********************************

void CRessyajouhouDraw::onCentDedDgrEkiJikoku( 
		ERessyahoukou eRessyahoukou ,
		int iRessyaIdx ,
		const CentDedDgrRessya* pCentDedDgrRessya ,
		int iRessyasenIdx ,
		const CentDedDgrRessyasen* pCentDedDgrRessyasen ,
		int iEkiOrder , 
		const CentDedDgrEkiJikoku* pCentDedDgrEkiJikoku ) 
{
	if ( iEkiOrder == pCentDedDgrRessyasen->getRessyasenSyuutenEkiOrder() )
	{
		//	ԐI_ɂ́AeLXg̕`s܂
		return ;
	}
	if ( !pCentDedDgrEkiJikoku->getShouldRessyajouhouDraw() )
	{
		//	̉ẅʒuɂ́AeLXg̕`s܂B
		return ;
	}
	// --------------------------------
	//	eLXg̐FI
	// --------------------------------
	CdColorProp	colorText ;
	{
		int idxRessyasyubetsu = pCentDedDgrRessya->getRessyasyubetsuIndex() ;
		if ( 0 <= idxRessyasyubetsu && 
			idxRessyasyubetsu < getCentDedDgrDia()->getMuCentDedDgrRessyasyubetsu()->size() )
		{
			const CentDedDgrRessyasyubetsu* pCentDedDgrRessyasyubetsu = 
				getCentDedDgrDia()->getMuCentDedDgrRessyasyubetsu()->get( idxRessyasyubetsu ) ;
			colorText = pCentDedDgrRessyasyubetsu->getJikokuhyouMojiColor() ;
		}
	}
	//colorText = eLXg̐F

	// --------------------------------
	//	ԏeLXg̓e쐬
	//	傫v
	// --------------------------------
	tstring	strRessyajouhou ;
	if ( m_pCDcdDiagram->getDisplayRessyabangou() )
	{
		if ( !pCentDedDgrRessya->getRessyabangou().empty() )
		{
			if ( !strRessyajouhou.empty() )
			{
				strRessyajouhou += ' ' ;
			}
			strRessyajouhou += pCentDedDgrRessya->getRessyabangou() ;
		}
	}
	if (  m_pCDcdDiagram->getDisplayRessyamei() )
	{
		if ( !pCentDedDgrRessya->getRessyamei().empty() )
		{
			if ( !strRessyajouhou.empty() )
			{
				strRessyajouhou += ' ' ;
			}
			strRessyajouhou += pCentDedDgrRessya->getRessyamei() ;
		}
		if ( !pCentDedDgrRessya->getGousuu().empty() )
		{
			if ( !strRessyajouhou.empty() )
			{
				strRessyajouhou += ' ' ;
			}
			strRessyajouhou += pCentDedDgrRessya->getGousuu() ;
			CString	aStr ;
			aStr.LoadString( IDS_WORD_GOUSUU2 ) ;
			strRessyajouhou += (LPCTSTR)aStr ;
		}
	}
	if ( strRessyajouhou.empty() )
	{
		return ;
	}
	//strRessyajouhou = \ԏ̕
	CdDcdSizeXy	sizexyText_Dcd ;
	{
		CDcdText	dcdText( strRessyajouhou , 
			m_pCDcdDiagram->getDiaRessyaFont() ) ;
		dcdText.getItemSize( m_pIfDcdTarget , &sizexyText_Dcd ) ;
	}
	//sizexyText_Dcd = ԏeLXg̕ƍ
	//	iɕ`悵ꍇ̐@łj

	// --------------------------------
	//	ԏ̕`悳钼Zo
	// --------------------------------
	CdDcdPosXy	posRessyasen_Pos1_Dcd ;
	CdDcdPosXy	posRessyasen_Pos2_Dcd ;
	{
		CdDcdPosXy	posDgrPosRessyasenKiten = 
			getCentDedDgrDia()->calcDgrPosRessyasenKiten( 
				pCentDedDgrRessya , 
				pCentDedDgrRessyasen ) ;
		CdDcdPosXy	posDgrPosRessyasenSyuuten = 
			getCentDedDgrDia()->calcDgrPosRessyasenSyuuten( 
				pCentDedDgrRessya , 
				pCentDedDgrRessyasen ) ;
		//posDgrPosRessyasenKiten,posDgrPosRessyasenSyuuten = 
		//	w_COGeBeBԐx̋N_ƏI_̍W
		//	Pʂ́Aw_COGeBeBWnx

		posRessyasen_Pos1_Dcd = m_pCDcdDiagram->DgrToDcd( 
			m_pIfDcdTarget , 
			posDgrPosRessyasenKiten ) ;
		posRessyasen_Pos2_Dcd = m_pCDcdDiagram->DgrToDcd( 
			m_pIfDcdTarget , 
			posDgrPosRessyasenSyuuten ) ;
	}
	//posRessyasen_Pos1_Dcd,posRessyasen_Pos2_Dcd = 
	//	w_COGeBeBԐx̋N_ƏI_̍W
	//	Pʂ́A IfDcdTarget ̍W

	// --------------------------------
	//	ԏ̕`悳w̗Ԑł̈ʒuZo
	// --------------------------------
	int iX_Dcd = 0 ;
	int iY_Dcd = 0 ;
	{
		int iY_Dgr = 0 ;
		int iX_Dgr = 0 ;
		iY_Dgr = getCentDedDgrDia()->getDgrYPosOfEkiTer( 
			pCentDedDgrRessya->getRessyahoukou() , iEkiOrder) ;
		int iResult = pCentDedDgrRessya->getDgrXPosOfEkiOrder( 
			iEkiOrder , &iX_Dgr ) ;
		if ( iResult < 0 ){
			return ;
		}
		//iX_Dgr,iY_Dgr = ԏ\w̔̍W
		//	Pʂ́Aw_COGeBeBWnx

		iX_Dcd = m_pCDcdDiagram->XDgrToDcd( m_pIfDcdTarget , iX_Dgr  ) ;
		iY_Dcd = m_pCDcdDiagram->YDgrToDcd( m_pIfDcdTarget , iY_Dgr  ) ;
	}
	//iX_Dcd,iY_Dcd = ԏ\w̔̍W
	//	Pʂ́A IfDcdTarget ̍Wn

	// --------------------------------
	//	eLXg̈ʒuƊpxvZ
	// --------------------------------
	CdDcdPosXy	posText_Dcd ;
	int iDeg = 0 ;
	{
		double d = sizexyText_Dcd.getY() + 2 ;
		if ( pCentDedDgrRessya->getRessyahoukou() == 
			Ressyahoukou_Kudari )
		{
			double a = posRessyasen_Pos2_Dcd.getX() - 
				posRessyasen_Pos1_Dcd.getX() ;
			double b =  posRessyasen_Pos2_Dcd.getY() - 
				posRessyasen_Pos1_Dcd.getY() ;
			double a_b =  a / b ;
			int c = (int)( RadToDeg( atan( a_b ) ) ) ;
			int e = (int)( d / cos( DegToRad( c ) ) ) ;
			posText_Dcd = CdDcdPosXy( iX_Dcd + e , iY_Dcd ) ;
			iDeg = 270 + c ;
		}
		else
		{
			double a = posRessyasen_Pos2_Dcd.getX() - 
				posRessyasen_Pos1_Dcd.getX() ;
			double b =  posRessyasen_Pos1_Dcd.getY() - 
				posRessyasen_Pos2_Dcd.getY() ;
			double a_b =  a / b ;
			int c = (int)( RadToDeg( atan( a_b ) ) ) ;
			int e = (int)( d * cos( DegToRad( c ) ) ) ;
			int f = (int)( d * sin( DegToRad( c ) ) ) ;
			posText_Dcd = CdDcdPosXy( iX_Dcd - e , iY_Dcd - f ) ;
			iDeg = 90 -c ;
		}
	}
	//posText_Dcd = eLXg̍W
	//iDeg = eLXg̊pxiPʂ͓xj

	// --------------------------------
	//	eLXg̕`
	// --------------------------------
	{
		//	tHg̑
		//	pxwǉ܂B
		CdFontProp	aCdFontProp = m_pCDcdDiagram->getDiaRessyaFont() ;
		aCdFontProp.setEscapement( iDeg * 10 ) ;

		//	tHg̐
		Ou<CGdiHFontHolder>	pHFontHolder = m_pIfDcdTarget->createGdiHFontHolder(
			aCdFontProp ) ;
		
		// --------------------------------
		//	tHgEFEwi[h̑I
		HFONT	hFontPrev = NULL ;
		hFontPrev = (HFONT)SelectObject( m_pIfDcdTarget->getHdc() , 
			pHFontHolder->getHFont() ) ;

		CConverter_WinGdi	aCConverter_WinGdi ;
		COLORREF	colorTextPrev = SetTextColor( 
			m_pIfDcdTarget->getHdc() , 
			aCConverter_WinGdi.COLORREFOf( colorText ) ) ;
		int iBkModePrev = SetBkMode( m_pIfDcdTarget->getHdc() , 
			TRANSPARENT ) ;
		// --------------------------------
		TextOut( m_pIfDcdTarget->getHdc() , 
			posText_Dcd.getX() , posText_Dcd.getY() ,
			strRessyajouhou.c_str() , strRessyajouhou.size() ) ;

		// --------------------------------
		//	tHgEFEwi[h̑I
		{
			SetBkMode( m_pIfDcdTarget->getHdc() , iBkModePrev ) ;
			SetTextColor( m_pIfDcdTarget->getHdc() , colorTextPrev ) ;
		}
		if ( hFontPrev != NULL ){
			SelectObject( m_pIfDcdTarget->getHdc() , hFontPrev ) ;
			hFontPrev = NULL ;
		}
		// --------------------------------
		//	tHgj
		if ( pHFontHolder != NULL )
		{
			pHFontHolder = Ou<CGdiHFontHolder>() ;
		}
	}
}

} //namespace ViewDiagram
