/*
OuDiaSecond Copyright (C) 2017-2018 diagram_mania

̃vÓAtake-okm쐬OuDia\tgEFAłB
̃vOpɂẮAtake-okmLڂ̉Lɏ܂B
*/
/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CDedOperationConnecter.cpp
// ****************************************************************
*/
/** @file */
#include "stdafx.h"
//#include <algorithm>
#include "CDedOperationConnecter.h"
#include "NsMu\CaMui.h"
#include "NsMu\CMup_vector.h"
#include "NsMu\CaMup_vector.h"
#include "..\entDgr\CentDedDgrRessya.h"
#include "CdDedRessyaProperty.h"



namespace entDed{
using namespace std ;

// ****************************************************************
//	CDedOperationConnecter
// ****************************************************************
	// --------------------------------
	//@name ֐
	// --------------------------------



	// ********************************
	//	RXgN^
	// ********************************
CDedOperationConnecter::CDedOperationConnecter(
	const CentDedRosen* pDedRosen , 
	CentDedDia* pDedDia ) :  
	m_pDedRosen( pDedRosen ) ,
	m_pDedDia( pDedDia ) 
{
	m_KitenJikoku = m_pDedRosen->getKitenJikoku();
	m_CentDedDgrDia.readCentDedRosen(
		m_pDedRosen,
		m_pDedDia,
		true);
	operationConnect();
}

CDedOperationConnecter::CDedOperationConnecter(
	const CentDedRosen * pDedRosen, 
	CentDedDia * pDedDia, 
	const CdDedJikoku aCdDedJikokuMin, 
	const CdDedJikoku aCdDedJikokuMax, 
	const ERessyahoukou eRessyahoukouEdit, 
	const int iIndexDst, const int iSizeDst, const int iAddSize) :
	m_pDedRosen(pDedRosen),
	m_pDedDia(pDedDia)
{
	m_KitenJikoku = m_pDedRosen->getKitenJikoku();
	m_CentDedDgrDia.readCentDedRosen(
		m_pDedRosen,
		m_pDedDia,
		true);
	operationUpdate(
		aCdDedJikokuMin, aCdDedJikokuMax,
		eRessyahoukouEdit, iIndexDst,
		iSizeDst, iAddSize);
}

CDedOperationConnecter::~CDedOperationConnecter()
{
}
	
	// ********************************
	//@name 
	// ********************************


bool CDedOperationConnecter::RessyaConnectCheck(
	const int iEkiOrder, 
	const CentDedRessya * pRessyaSearch, 
	//const CentDedRessya * pRessyaSearchEstimate,
	const int idxRessya,
	const CdDedRessyaProperty * sRessyaBefore, 
	const int iTrackIndexTer, 
	CdDedRessyaProperty * sRessyaCurrent,
	const int iMainTrack/*, 
	const bool bAlreadyNumbered*/)
{
	/**
		iEkiOrdernw̏ꍇ
			oȐꍇreturn true(^s̉\̓[)
			iTrackIndexTerʂȂꍇreturn true(̏ꍇ́AԐmFA{ݒ̏ꍇ𒍈ӁB)
			ƂȂEȍꍇ͔AOԒEb莟ԎƔrB
				Before)Ԃɓꍇ́Ab莟Ԏ㏑A
				̗Ԃɉ^pς݂ȂAb莟IdxAłȂȂ炱̗Ԃ̕Idxb莟Ԃɏ
				After)ƂȂ̏ꍇAAsRessyaBeforeȏsRessyaCurrentȂAb莟ԕEidxE̗ԂōXV
				sRessyaCurrentƈvꍇ́Ab莟Idx
				ȍꍇAAsRessyaBeforeȏsRessyaCurrentȂAb莟IdxAXVA
				sRessyaCurrentƈvꍇ́Ab莟Idx
			HOn̏ꍇ́AɉrA̔ԐƓlAݍ݂̃`FbNsB
			̏ꍇ́AԐƓԐ̂ǂ炪vĂ邩ŏςB
			Ԑ̏ꍇ́AɁAƂȂƓB
			Ԑ̏ꍇ́AOԒOȂAreturn true;
			OԈȍ~AOԒO(ݍތ`)̏ꍇ́As`Ƃ݂ȂAreturn false
			EɑOԒ̏ꍇAb莟Ԏ"ȉ"ȂA
			Ŏb莟Ԏ㏑Ab莟Idx͏B
	*/
	if (pRessyaSearch->getSihatsuEki() == iEkiOrder)
	{
		CentDedEkiJikoku aEkiJikokuSearch = pRessyaSearch->getCentDedEkiJikoku(iEkiOrder);
		if (aEkiJikokuSearch.getEkiatsukai() == CentDedEkiJikoku::Ekiatsukai_Keiyunasi)
		{
			return true;
		}

		CentDedRessyaTrack aRessyaTrackSearch = pRessyaSearch->getCentDedRessyaTrack(iEkiOrder);
		if (aRessyaTrackSearch.getOperation() == CentDedRessyaTrack::Operation_Shunt)
		{
			if (aRessyaTrackSearch.getShuntTrackIndex() != iTrackIndexTer &&
				aRessyaTrackSearch.getRessyaTrackIndex() != iTrackIndexTer)
			{
				return true;
			}
		}
		else// if(aCentDedRessyaTrackSearch.getOperation() == CentDedRessyaTrack::Operation_NoneorInOutorOuter)
		{
			int iRessyaTrackSearch = aRessyaTrackSearch.getRessyaTrackIndex();
			if (iRessyaTrackSearch == 0)
			{
				iRessyaTrackSearch = iMainTrack;
			}
			if (iRessyaTrackSearch != iTrackIndexTer)
			{
				return true;
			}
		}

		if (aRessyaTrackSearch.getOperation() == CentDedRessyaTrack::Operation_None)
		{
			if (sRessyaCurrent->getJikoku().compare(aEkiJikokuSearch.getHatsujikoku(true), m_KitenJikoku) == 0)
			{
				sRessyaCurrent->setRessyaIndex(INT_MIN);
			}
			else if (aEkiJikokuSearch.getHatsujikoku(true).compare(sRessyaBefore->getJikoku(), m_KitenJikoku) >= 0 &&
				sRessyaCurrent->getJikoku().compare(aEkiJikokuSearch.getHatsujikoku(true), m_KitenJikoku) > 0)
			{
				sRessyaCurrent->setJikoku(aEkiJikokuSearch.getHatsujikoku(true));
				//bAlreadyNumbered`FbN폜AConnect,updateŁAԂɏ݂sƂɃ`FbNs
				//if (bAlreadyNumbered)
				//{
				//	sRessyaCurrent->setRessyaIndex(INT_MIN);
				//}
				//else
				//{
					sRessyaCurrent->setRessyaIndex(idxRessya);
					sRessyaCurrent->setRessyahoukou(pRessyaSearch->getRessyahoukou());
				//}
			}
			//else
			//{
			//	continue;
			//}
		}
		else if (aRessyaTrackSearch.getOperation() == CentDedRessyaTrack::Operation_InOut)
		{
			if (aEkiJikokuSearch.getHatsujikoku(true).compare(sRessyaBefore->getJikoku(), m_KitenJikoku) >= 0 &&
				sRessyaCurrent->getJikoku().compare(aEkiJikokuSearch.getHatsujikoku(true), m_KitenJikoku) >= 0)
			{
				sRessyaCurrent->setJikoku(aEkiJikokuSearch.getHatsujikoku(true));
				//bAlreadyNumbered`FbN폜AConnect,updateŁAԂɏ݂sƂɃ`FbNs
				//if (bAlreadyNumbered)
				//{
				//	sRessyaCurrent->setRessyaIndex(INT_MIN);
				//}
				//else
				//{
				sRessyaCurrent->setRessyaIndex(INT_MIN);
				//}
			}
			//else
			//{
			//	continue;
			//}
		}
		else if (aRessyaTrackSearch.getOperation() == CentDedRessyaTrack::Operation_Outer)
		{
			if (aEkiJikokuSearch.getHatsujikoku(true).compare(sRessyaBefore->getJikoku(), m_KitenJikoku) < 0)
			{
				return true;
			}
			else if (aEkiJikokuSearch.getChakujikoku(true).compare(sRessyaBefore->getJikoku(), m_KitenJikoku) <= 0)
			{
				//bContinueSearch = false;
				//break;
				return false;
				//Tł؂
			}
			else if (aEkiJikokuSearch.getChakujikoku(true).compare(sRessyaCurrent->getJikoku(), m_KitenJikoku) <= 0)
			{
				sRessyaCurrent->setJikoku(aEkiJikokuSearch.getChakujikoku(true));
				sRessyaCurrent->setRessyaIndex(INT_MIN);
			}
		}
		else if (aRessyaTrackSearch.getOperation() == CentDedRessyaTrack::Operation_Shunt&&
			aRessyaTrackSearch.getShuntTrackIndex() == iTrackIndexTer)
		{
			CdDedJikoku aJikokuOperationHatsu;
			if (aRessyaTrackSearch.getOperationHatsuJikoku().isNull())
			{
				aJikokuOperationHatsu = aEkiJikokuSearch.getHatsujikoku(true);
				aJikokuOperationHatsu.addSeconds(-60);
			}
			else
			{
				aJikokuOperationHatsu = aRessyaTrackSearch.getOperationHatsuJikoku();
			}

			if (sRessyaCurrent->getJikoku().compare(aJikokuOperationHatsu, m_KitenJikoku) == 0)
			{
				sRessyaCurrent->setRessyaIndex(INT_MIN);
			}
			else if (aJikokuOperationHatsu.compare(sRessyaBefore->getJikoku(), m_KitenJikoku) >= 0 &&
				sRessyaCurrent->getJikoku().compare(aJikokuOperationHatsu, m_KitenJikoku) > 0)
			{
				sRessyaCurrent->setJikoku(aJikokuOperationHatsu);
				//if (bAlreadyNumbered)
				//{
				//	sRessyaCurrent->setRessyaIndex(INT_MIN);
				//}
				//else
				//{
					sRessyaCurrent->setRessyaIndex(idxRessya);
					sRessyaCurrent->setRessyahoukou(pRessyaSearch->getRessyahoukou());
				//}
			}
			//else
			//{
			//	continue;
			//}
		}
		else if (aRessyaTrackSearch.getOperation() == CentDedRessyaTrack::Operation_Shunt &&
			aRessyaTrackSearch.getRessyaTrackIndex() == iTrackIndexTer)
		{
			CdDedJikoku aJikokuOperationChaku;
			if (aRessyaTrackSearch.getOperationChakuJikoku(true).isNull())
			{
				aJikokuOperationChaku = aEkiJikokuSearch.getHatsujikoku(true);
				aJikokuOperationChaku.addSeconds(-60);
			}
			else
			{
				aJikokuOperationChaku = aRessyaTrackSearch.getOperationChakuJikoku(true);
			}

			if (aEkiJikokuSearch.getHatsujikoku(true).compare(sRessyaBefore->getJikoku(), m_KitenJikoku) < 0)
			{
				return true;
			}
			else if (aJikokuOperationChaku.compare(sRessyaBefore->getJikoku(), m_KitenJikoku) <= 0)
			{
				//bContinueSearch = false;
				//break;
				return false;
				//Tł؂
			}
			else if (aJikokuOperationChaku.compare(sRessyaCurrent->getJikoku(), m_KitenJikoku) <= 0)
			{
				sRessyaCurrent->setJikoku(aJikokuOperationChaku);
				sRessyaCurrent->setRessyaIndex(INT_MIN);
			}
			//else
			//{
			//	continue;
			//}
		}
	}
	/**
		iEkiOrderIw̏ꍇ
			oȐꍇreturn true(^s̉\̓[)
			iTrackIndexTerʂȂꍇreturn true(̏ꍇ́AԐmFA{ݒ̏ꍇ𒍈ӁB)
			HOȈꍇ́AāAݍ݂mFB
			Iw̏ꍇ͎ԂɂȂ肦Ȃ̂ŁAb莟Ԏ̍XVсAEԐv̏ꍇ́Aݍ݃`FbN̂
	*/
	else if (pRessyaSearch->getSyuuchakuEki() == iEkiOrder)
	{
		CentDedEkiJikoku aEkiJikokuSearch = pRessyaSearch->getCentDedEkiJikoku(iEkiOrder);
		if (aEkiJikokuSearch.getEkiatsukai() == CentDedEkiJikoku::Ekiatsukai_Keiyunasi)
		{
			return true;
		}

		CentDedRessyaTrack aRessyaTrackSearch = pRessyaSearch->getCentDedRessyaTrack(iEkiOrder);
		if (aRessyaTrackSearch.getOperation() == CentDedRessyaTrack::Operation_Shunt)
		{
			if (aRessyaTrackSearch.getShuntTrackIndex() != iTrackIndexTer &&
				aRessyaTrackSearch.getRessyaTrackIndex() != iTrackIndexTer)
			{
				return true;
			}
		}
		else// if(aCentDedRessyaTrackSearch.getOperation() == CentDedRessyaTrack::Operation_NoneorInOutorOuter)
		{
			int iRessyaTrackSearch = aRessyaTrackSearch.getRessyaTrackIndex();
			if (iRessyaTrackSearch == 0)
			{
				iRessyaTrackSearch = iMainTrack;
			}
			if (iRessyaTrackSearch != iTrackIndexTer)
			{
				return true;
			}
		}


		if (aRessyaTrackSearch.getOperation() == CentDedRessyaTrack::Operation_None ||
			aRessyaTrackSearch.getOperation() == CentDedRessyaTrack::Operation_InOut)
		{
			if (aEkiJikokuSearch.getChakujikoku(true).compare(sRessyaBefore->getJikoku(), m_KitenJikoku) >= 0 &&
				sRessyaCurrent->getJikoku().compare(aEkiJikokuSearch.getChakujikoku(true), m_KitenJikoku) >= 0)
			{
				sRessyaCurrent->setJikoku(aEkiJikokuSearch.getChakujikoku(true));
				sRessyaCurrent->setRessyaIndex(INT_MIN);
			}
			//else
			//{
			//	continue;
			//}
		}
		else if (aRessyaTrackSearch.getOperation() == CentDedRessyaTrack::Operation_Outer)
		{
			if (aEkiJikokuSearch.getHatsujikoku(true).compare(sRessyaBefore->getJikoku(), m_KitenJikoku) < 0)
			{
				return true;
			}
			else if (aEkiJikokuSearch.getChakujikoku(true).compare(sRessyaBefore->getJikoku(), m_KitenJikoku) <= 0)
			{
				return false;
				//Tł؂
			}
			else if (aEkiJikokuSearch.getChakujikoku(true).compare(sRessyaCurrent->getJikoku(), m_KitenJikoku) <= 0)
			{
				sRessyaCurrent->setJikoku(aEkiJikokuSearch.getChakujikoku(true));
				sRessyaCurrent->setRessyaIndex(INT_MIN);
			}
		}

		else if (aRessyaTrackSearch.getOperation() == CentDedRessyaTrack::Operation_Shunt&&
			aRessyaTrackSearch.getShuntTrackIndex() == iTrackIndexTer)
		{
			CdDedJikoku aJikokuOperationChaku;
			if (aRessyaTrackSearch.getOperationChakuJikoku(true).isNull())
			{
				aJikokuOperationChaku = aEkiJikokuSearch.getChakujikoku(true);
				aJikokuOperationChaku.addSeconds(60);
			}
			else
			{
				aJikokuOperationChaku = aRessyaTrackSearch.getOperationChakuJikoku(true);
			}

			if (aJikokuOperationChaku.compare(sRessyaBefore->getJikoku(), m_KitenJikoku) >= 0 &&
				sRessyaCurrent->getJikoku().compare(aJikokuOperationChaku, m_KitenJikoku) >= 0)
			{
				sRessyaCurrent->setJikoku(aJikokuOperationChaku);
				sRessyaCurrent->setRessyaIndex(INT_MIN);
			}
			//else
			//{
			//	continue;
			//}
		}
		else if (aRessyaTrackSearch.getOperation() == CentDedRessyaTrack::Operation_Shunt &&
			aRessyaTrackSearch.getRessyaTrackIndex() == iTrackIndexTer)
		{
			CdDedJikoku aJikokuOperationHatsu;
			if (aRessyaTrackSearch.getOperationHatsuJikoku().isNull())
			{
				aJikokuOperationHatsu = aEkiJikokuSearch.getChakujikoku(true);
				aJikokuOperationHatsu.addSeconds(60);
			}
			else
			{
				aJikokuOperationHatsu = aRessyaTrackSearch.getOperationHatsuJikoku();
			}

			if (aJikokuOperationHatsu.compare(sRessyaBefore->getJikoku(), m_KitenJikoku) < 0)
			{
				//continue;
				return true;
			}
			else if (aEkiJikokuSearch.getChakujikoku(true).compare(sRessyaBefore->getJikoku(), m_KitenJikoku) <= 0)
			{
				//bContinueSearch = false;
				//break;
				return false;
				//Tł؂
			}
			else if (aEkiJikokuSearch.getChakujikoku(true).compare(sRessyaCurrent->getJikoku(), m_KitenJikoku) <= 0)
			{
				sRessyaCurrent->setJikoku(aEkiJikokuSearch.getChakujikoku(true));
				sRessyaCurrent->setRessyaIndex(INT_MIN);
			}
			//else
			//{
			//	continue;
			//}
		}

	}
	/**
		iEkiOrderrw̏ꍇ
			^sEoȐꍇreturn true
			ԐiTrackIndexTerƈvȂꍇreturn true
			iEkiOrderɎ݂ȂꍇAcreateEstimateRessyaŒʉ߉w𐄒肵āA̎ɂB
			OԒOȂreturn true
			ƔőOԒݍޏꍇreturn false
				sRessyaBeforeƈꏏ̏ꍇreturn false
			ƔɑOԒŁAb莟ԎOȂAŎb莟Ԏ㏑Ab莟Idx͏B
				sRessyaCurrentƈꏏ̎Ab莟IdxB
				AsRessyaCurrent̗ԂƓԂ̏ꍇ́Ab莟Ԃ͍sȂB
	
	*/
	else if (pRessyaSearch->getCentDedEkiJikoku(iEkiOrder).getEkiatsukai() == CentDedEkiJikoku::Ekiatsukai_Teisya ||
		pRessyaSearch->getCentDedEkiJikoku(iEkiOrder).getEkiatsukai() == CentDedEkiJikoku::Ekiatsukai_Tsuuka)
	{
		CentDedRessyaTrack aRessyaTrackSearch = pRessyaSearch->getCentDedRessyaTrack(iEkiOrder);
		int iRessyaTrackSearch = aRessyaTrackSearch.getRessyaTrackIndex();
		if (iRessyaTrackSearch == 0)
		{
			iRessyaTrackSearch = iMainTrack;
		}
		if (iRessyaTrackSearch != iTrackIndexTer)
		{
			return true;
		}

		CentDedEkiJikoku aEkiJikokuSearch = pRessyaSearch->getCentDedEkiJikoku(iEkiOrder);
		if (aEkiJikokuSearch.getChakujikoku(true).isNull())
		{
			//aEkiJikokuSearchƂNULL̏ꍇAʉ߉wԂ쐬A̗Ԃ̉waEkiJikokuSearch㏑B
			CentDedDgrRessya aCentDedDgrRessya =
				m_CentDedDgrDia.getCentDedDgrRessyaCont(pRessyaSearch->getRessyahoukou())->get(idxRessya);
			CentDedRessya aEstimateRessya(m_pDedDia->getCentDedRessyaCont(pRessyaSearch->getRessyahoukou())->createNullRessya());
			m_CentDedDgrDia.createEstimateRessya(
				&aCentDedDgrRessya,
				&aEstimateRessya);
			aEkiJikokuSearch = aEstimateRessya.getCentDedEkiJikoku(iEkiOrder);
		}

		if (aEkiJikokuSearch.getHatsujikoku(true).compare(sRessyaBefore->getJikoku(), m_KitenJikoku) < 0)
		{
			return true;
		}
		else if (aEkiJikokuSearch.getChakujikoku(true).compare(sRessyaBefore->getJikoku(), m_KitenJikoku) <= 0)
		{
			return false;
			//Tł؂
		}
		else if (aEkiJikokuSearch.getChakujikoku(true).compare(sRessyaCurrent->getJikoku(), m_KitenJikoku) <= 0)
		{
			if (sRessyaCurrent->getRessyaIndex() != idxRessya &&
				sRessyaCurrent->getRessyahoukou() != pRessyaSearch->getRessyahoukou())
			{
				sRessyaCurrent->setJikoku(aEkiJikokuSearch.getChakujikoku(true));
				sRessyaCurrent->setRessyaIndex(INT_MIN);
			}
		}


		//CentDedEkiJikoku aEkiJikokuSearch = pRessyaSearch->getCentDedEkiJikoku(iEkiOrder);
		//CentDedEkiJikoku aEkiJikokuSearchEstimate = pRessyaSearchEstimate->getCentDedEkiJikoku(iEkiOrder);
		////aEkiJikokuSearch.
		//if (aEkiJikokuSearchEstimate.getHatsujikoku(true).compare(sRessyaBefore->aJikoku, m_KitenJikoku) < 0)
		//{
		//	return true;
		//}
		//else if (aEkiJikokuSearchEstimate.getChakujikoku(true).compare(sRessyaBefore->aJikoku, m_KitenJikoku) < 0)
		//{
		//	//bContinueSearch = false;
		//	//break;
		//	return false;
		//	//Tł؂
		//}
		//else if (aEkiJikokuSearchEstimate.getChakujikoku(true).compare(sRessyaCurrent->aJikoku, m_KitenJikoku) < 0)
		//{
		//	sRessyaCurrent->aJikoku = aEkiJikokuSearchEstimate.getChakujikoku(true);
		//	sRessyaCurrent->iRessyaidx = INT_MIN;
		//}
	}

	return true;
}

void CDedOperationConnecter::operationConnect()
{
	//bool bAbort = false;
	const CentDedEkiCont* pEkiCont = m_pDedRosen->getCentDedEkiCont();


	//int iRessyahoukou = 0;
	//for (iRessyahoukou = Ressyahoukou_Kudari;
	//	iRessyahoukou <= Ressyahoukou_Nobori; iRessyahoukou++) {
	CentDedRessyaCont* pRessyaCont[2];
	for (int iRessyahoukou = Ressyahoukou_Kudari;
		iRessyahoukou <= Ressyahoukou_Nobori; iRessyahoukou++)
	{
		pRessyaCont[iRessyahoukou] = m_pDedDia->getCentDedRessyaCont((ERessyahoukou)iRessyahoukou);
	}

//	CentDedRessyaCont aEstimateRessyaContKudari = pRessyaCont[0]->createEmptyCont();
//	CentDedRessyaCont aEstimateRessyaContNobori = pRessyaCont[1]->createEmptyCont();
//#pragma omp parallel sections
//	{
//#pragma omp section
//		for (int idxRessya = 0; idxRessya < pRessyaCont[0]->size(); idxRessya++)
//		{
//			const CentDedRessya* pCentDedRessya = pRessyaCont[0]->getMuPtr()->get(idxRessya);
//			CentDedDgrRessya aCentDedDgrRessya =
//				m_CentDedDgrDia.getCentDedDgrRessyaCont(Ressyahoukou_Kudari)->get(idxRessya);
//			//CentDedDgrRessya	aCentDedDgrRessya(
//			//	m_pDedRosen,
//			//	&m_CentDedDgrDia,
//			//	pCentDedRessya);
//
//			CentDedRessya aEstimateRessya(aEstimateRessyaContKudari.createNullRessya());
//			//m_CentDedDgrDia.createEstimateRessya(
//			//	&aCentDedDgrRessya,
//			//	&aEstimateRessya);
//			m_CentDedDgrDia.createEstimateRessya2(
//				&aCentDedDgrRessya,
//				&aEstimateRessya,
//				pEkiCont);
//			aEstimateRessyaContKudari.insert(aEstimateRessya);
//		}
//#pragma omp section
//		for (int idxRessya = 0; idxRessya < pRessyaCont[1]->size(); idxRessya++)
//		{
//			const CentDedRessya* pCentDedRessya = pRessyaCont[1]->getMuPtr()->get(idxRessya);
//			CentDedDgrRessya aCentDedDgrRessya = 
//				m_CentDedDgrDia.getCentDedDgrRessyaCont(Ressyahoukou_Nobori)->get(idxRessya);
//			//CentDedDgrRessya	aCentDedDgrRessya(
//			//	m_pDedRosen,
//			//	&m_CentDedDgrDia,
//			//	pCentDedRessya);
//
//			CentDedRessya aEstimateRessya(aEstimateRessyaContKudari.createNullRessya());
//			//m_CentDedDgrDia.createEstimateRessya(
//			//	&aCentDedDgrRessya,
//			//	&aEstimateRessya);
//			m_CentDedDgrDia.createEstimateRessya2(
//				&aCentDedDgrRessya,
//				&aEstimateRessya,
//				pEkiCont);
//			aEstimateRessyaContNobori.insert(aEstimateRessya);
//		}
//	}
//#pragma omp barrier
//	CentDedRessyaCont* pEstimateRessyaCont[2];
//	pEstimateRessyaCont[0] = &aEstimateRessyaContKudari;
//	pEstimateRessyaCont[1] = &aEstimateRessyaContNobori;
	//aEstimateRessyaCont = pRessyaCont ɐ莞ǉ܂B



	//ςݗIndex쐬
	vector<vector<bool>> contRessyaNumbered;
	contRessyaNumbered.resize(2);
	for (int iRessyahoukou = Ressyahoukou_Kudari;
		iRessyahoukou <= Ressyahoukou_Nobori; iRessyahoukou++)
	{
		contRessyaNumbered[iRessyahoukou].assign(pRessyaCont[iRessyahoukou]->size(), false);
	}

	//Step1 nwƂoorHOn̗ԂTB
	//Step2-1 ̎nwƂ̉^ԂȂAstrOpeNumɂāA`FbNς݂ɓB
	//Step2-2 ̎nwƂɉ^ԂȂAstrOpeNumɉ^ԂāAԌɓB
	for (int iRessyahoukou = Ressyahoukou_Kudari;
		iRessyahoukou <= Ressyahoukou_Nobori; iRessyahoukou++)
	{
		int iSize = pRessyaCont[iRessyahoukou]->size();
#pragma omp parallel for schedule(dynamic)
		for (int idxRessya = 0; idxRessya < iSize; idxRessya++)
		{
			CentDedRessya* pCentDedRessya = pRessyaCont[iRessyahoukou]->getMuPtr()->get(idxRessya);
			if (pCentDedRessya->isNull())
			{
				continue;
			}
			CentDedEkiJikoku aCentDedEkiJikokuShihatsu =
				pCentDedRessya->getCentDedEkiJikoku(pCentDedRessya->getSihatsuEki());
			if (aCentDedEkiJikokuShihatsu.getEkiatsukai() == CentDedEkiJikoku::Ekiatsukai_Keiyunasi)
			{
				continue;
			}
			CentDedRessyaTrack aCentDedRessyaTrackShihatsu =
				pCentDedRessya->getCentDedRessyaTrack(pCentDedRessya->getSihatsuEki());
			if (aCentDedRessyaTrackShihatsu.getOperation() != CentDedRessyaTrack::Operation_InOut &&
				aCentDedRessyaTrackShihatsu.getOperation() != CentDedRessyaTrack::Operation_Outer)
			{
				continue;
			}
			else if (aCentDedRessyaTrackShihatsu.getOperationNumber().empty())
			{
				//Xgŉ^pԍɂ̂ŁAcontRessyaNumberedfalsê܂܂ɂĂA
				//ł͋ɂƂ͂ȂėǂƂB
				//pRessyaCont[iRessyahoukou]->getMuPtr()->get(idxRessya)->setOperationNumber("");
				//contRessyaNumbered[iRessyahoukou][idxRessya] = true;
				continue;
			}

			tstring strOperationNumber = aCentDedRessyaTrackShihatsu.getOperationNumber();
			pCentDedRessya->setOperationNumber(strOperationNumber);
			pCentDedRessya->setRessyaidxOut(idxRessya);
			pCentDedRessya->setRessyahoukouOut((ERessyahoukou)iRessyahoukou);
#pragma omp critical
			contRessyaNumbered[iRessyahoukou][idxRessya] = true;

//Step3 ԌƂāAIw̎ƔԐ擾BƂȂ̏ꍇ́AƔԐ
//̏ꍇ́AƓԐ擾B
		//iTerminalTrackIndex OԂ̏IԐ {(0)͎gpȂ悤ɂB
			int iTrackIndexTer;
		//iEkiIndexTerminal OԏIw̉wIndex
			int iEkiIndexTer = pCentDedRessya->EkiIndexOfEkiOrder(pCentDedRessya->getSyuuchakuEki());
			CdDedRessyaProperty sRessyaBefore;
			sRessyaBefore.setRessyaIndex(idxRessya);
			sRessyaBefore.setRessyahoukou(pCentDedRessya->getRessyahoukou());

			CentDedEkiJikoku aEkiJikokuOutSyuuchaku =
				pCentDedRessya->getCentDedEkiJikoku(pCentDedRessya->getSyuuchakuEki());
			if (aEkiJikokuOutSyuuchaku.getEkiatsukai() == CentDedEkiJikoku::Ekiatsukai_Keiyunasi)
			{
				pCentDedRessya->setRessyaidxNext(INT_MIN);
				continue;
			}
			CentDedRessyaTrack aRessyaTrackOutSyuuchaku =
				pCentDedRessya->getCentDedRessyaTrack(pCentDedRessya->getSyuuchakuEki());
			if (aRessyaTrackOutSyuuchaku.getOperation() == CentDedRessyaTrack::Operation_InOut ||
				aRessyaTrackOutSyuuchaku.getOperation() == CentDedRessyaTrack::Operation_Outer)
			{
				pCentDedRessya->setRessyaidxNext(INT_MIN);
				continue;
			}
			else if (aRessyaTrackOutSyuuchaku.getOperation() == CentDedRessyaTrack::Operation_None)
			{
				sRessyaBefore.setJikoku(pCentDedRessya
					->getCentDedEkiJikoku(pCentDedRessya->getSyuuchakuEki()).getChakujikoku(true));
				iTrackIndexTer = aRessyaTrackOutSyuuchaku.getRessyaTrackIndex();
				if (iTrackIndexTer == 0)
				{
					iTrackIndexTer = pEkiCont->get(iEkiIndexTer).getMainTrack(sRessyaBefore.getRessyahoukou());
				}
			}
			else if (aRessyaTrackOutSyuuchaku.getOperation() == CentDedRessyaTrack::Operation_Shunt)
			{
				if (aRessyaTrackOutSyuuchaku.getOperationChakuJikoku(true).isNull())
				{
					CdDedJikoku aCdDedJikoku = aEkiJikokuOutSyuuchaku.getChakujikoku(true);
					sRessyaBefore.setJikoku(aCdDedJikoku.addSeconds(60));
				}
				else
				{
					sRessyaBefore.setJikoku(aRessyaTrackOutSyuuchaku.getOperationChakuJikoku(true));
				}
				iTrackIndexTer = aRessyaTrackOutSyuuchaku.getShuntTrackIndex();
			}

			//Step4 ԒT
			//ԂƂȂƂāA
				//(1)OԂƓԐn܂
				//(2)OԂ̎(N_܂Ȃ)n܂
				//(3)OԂƎԂ̊ԂɁA̗Ԃ̔ԐgpȂ3𖞂
			//TΏۂ̗Ԃ
			//(1)iEkiIndexTerminaln̏ꍇ@Ƃ̏ꍇԐɂāAƂȂEȍꍇԐɂāAԐ擾AȂ玞擾
				//(1)b莟ԂAaJikokuTerォaJikokuAfterCurOȂAVȎb莟ԂɂB
				//AΏۂɔԍtĂȂaJikokuAfterCur㏑Ab莟Ԃ͋ɂB
				//(2)b莟Ԃ݂ꍇAaJikokuTerォaJikokuAfterCurOȂAVȎb莟ԂɂB
			//(2)iEkiIndexTerminalrw̏ꍇA܂́AnwEIw̔ԐɂāAԐ擾AȂ玞擾
				//(1)<<aJikokuTer<aJikokuAfterCurȂAցA
				//(2)<aJikokuTer<aJikokuAfterCur<ȂATł؂
				//(3)<aJikokuTer<<aJikokuAfterCurȂATł؂
				//(4)aJikokuTer<<<aJikokuAfterCurȂAaJikokuAfterCur𒅎ɂAb莟ԂɂĎ
				//(5)aJikokuTer<<aJikokuAfterCur<ȂAaJikokuAfterCur𒅎ɂAb莟ԂɂĎ
					//()̃p^[́Ab莟ԂƁATΏۂ̗Ԃ̍ݐĂ̂ŁA{Ă͂ȂȂp^[
				//(6)aJikokuTer<aJikokuAfterCur<<ȂA
			//(3)iEkiIndexTerminalȈꍇ@Ƃ̏ꍇԐɂāAƂȂ̏ꍇԐɂāAԐ擾AȂ玞擾
				//aJikokuTerォaJikokuAfterCurOȂAaJikokuAfterCur𒅎ɂAb莟ԂɂĎ
			//(3)iEkiIndexTerminal^sEoȐꍇ
				//E󗍂݂̒TŒǉ
			while (1)
			{
				//aJikokuAfterCur aCdDedJikokuTerminalƂ̒l̊ԂAT͈͂ƂȂ܂B
				//T͈͂ɗԂ݂ꍇA̗Ԃ̎ŁA̒lɏ㏑AT͈͂߂Ă܂B
				//ĺA_CON_1bOłB
				//CdDedJikoku aJikokuAfterCur = aKitenJikoku;
				//aJikokuAfterCur.addSeconds(-1);
				//iRessyaidxAfterCur b莟Ԃ̗IndexłAeRessyahoukouAfterCurƑgݍ킹Ďg܂B
				//lyюb莟Ԃ݂Ȃꍇ́AINT_MINłB
				//int iRessyaidxAfterCur = INT_MIN;
				//eRessyahoukouAfterCur b莟Ԃ̗ԕłBiRessyaidxAfterCurƑgݍ킹Ďg܂B
				//l͉(ftHg)Ab莟Ԃ݂Ȃꍇ́AsłB
				//ERessyahoukou eRessyahoukouAfterCur;
				CdDedRessyaProperty sRessyaCurrent;
				CdDedJikoku aJikokuTemp = m_KitenJikoku;
				aJikokuTemp.addSeconds(-1);
				sRessyaCurrent.setJikoku(aJikokuTemp);
				sRessyaCurrent.setRessyaIndex(INT_MIN);

				//------------------T------------------
				bool bContinueSearch = true;
				for (int iRessyahoukouSearch = Ressyahoukou_Kudari;
					iRessyahoukouSearch <= Ressyahoukou_Nobori && bContinueSearch; iRessyahoukouSearch++)
				{
					int iEkiOrderTerminal = pRessyaCont[iRessyahoukouSearch]->EkiOrderOfEkiIndex(iEkiIndexTer);
					int iMainTrack = pEkiCont->get(iEkiIndexTer).getMainTrack((ERessyahoukou)iRessyahoukouSearch);

					//EΉ iEkiIndexTerɁAEݒŌqĂwOrder߂B
					deque<int> iEkiOrderBrunchOriginSide;
					deque<int> iEkiOrderLoop;
					deque<int> iEkiOrderBrunchTerminalSide;
					int iResult = pEkiCont->getEkiOrderBrunchLoop(
						iEkiOrderTerminal,
						(ERessyahoukou)iRessyahoukouSearch,
						iEkiOrderBrunchOriginSide,
						iEkiOrderLoop,
						iEkiOrderBrunchTerminalSide);

					int iSizeSearch = pRessyaCont[iRessyahoukouSearch]->size();
					for (int idxRessyaSearch = 0;
						idxRessyaSearch < iSizeSearch && bContinueSearch;
						idxRessyaSearch++)
					{
						if (sRessyaBefore.getRessyahoukou() == (ERessyahoukou)iRessyahoukouSearch && sRessyaBefore.getRessyaIndex() == idxRessyaSearch)
						{
							//ΏۗԂAOԂƓȂ玟
							continue;
						}
						CentDedRessya* pRessyaSearch = pRessyaCont[iRessyahoukouSearch]->getMuPtr()->get(idxRessyaSearch);
						if (pRessyaSearch->isNull())
						{
							//ΏۗԂANullԂȂ玟
							continue;
						}
						//CentDedRessya* pRessyaSearchEstimate = pEstimateRessyaCont[iRessyahoukouSearch]->getMuPtr()->get(idxRessyaSearch);

						//EΉ
						if (iResult == -1)
						{
							bContinueSearch = RessyaConnectCheck(
								iEkiOrderTerminal,
								pRessyaSearch,
								//pRessyaSearchEstimate,
								idxRessyaSearch,
								&sRessyaBefore,
								iTrackIndexTer,
								&sRessyaCurrent,
								iMainTrack/*,
								contRessyaNumbered[iRessyahoukouSearch][idxRessyaSearch]*/);
							if (!bContinueSearch)
							{
								break;
							}
						}
						else
						{
							//origin->loop->terminal̏ɍsB́AnwƓȂ̐ڑwɂ͂ĂꍇA
							//getShihatsuEki珈ȂƁAɕ̗Ԃ݂ĂƂ݂ȂĂ܂AڑsȂ
							//)IȎnwloop[1]Aloop[0]ɂ͂ĂƂ
							//܂loop[0]̕ŁARessyaConnectChecksAb莟ԂɂȂȂA̕IndexsRessyaCurrentɏ܂B
							//loop[1]̕ŁARessyaConnectChecksꍇARsRessyaCurrentJikokuƓɂȂ邪A
							//sRessyaCurrent̕Indexv΁AԂƔʂł̂ŁAڑłB
							for (int idxo = 0; idxo < (int)iEkiOrderBrunchOriginSide.size() && bContinueSearch; idxo++)
							{
								bContinueSearch = RessyaConnectCheck(
									iEkiOrderBrunchOriginSide[idxo],
									pRessyaSearch,
									//pRessyaSearchEstimate,
									idxRessyaSearch,
									&sRessyaBefore,
									iTrackIndexTer,
									&sRessyaCurrent,
									iMainTrack/*,
											  contRessyaNumbered[iRessyahoukouSearch][idxRessyaSearch]*/);
							}
							for (int idxl = 0; idxl < (int)iEkiOrderLoop.size() && bContinueSearch; idxl++)
							{
								bContinueSearch = RessyaConnectCheck(
									iEkiOrderLoop[idxl],
									pRessyaSearch,
									//pRessyaSearchEstimate,
									idxRessyaSearch,
									&sRessyaBefore,
									iTrackIndexTer,
									&sRessyaCurrent,
									iMainTrack/*,
									contRessyaNumbered[iRessyahoukouSearch][idxRessyaSearch]*/);
							}
							for (int idxt = 0; idxt < (int)iEkiOrderBrunchTerminalSide.size() && bContinueSearch; idxt++)
							{
								bContinueSearch = RessyaConnectCheck(
									iEkiOrderBrunchTerminalSide[idxt],
									pRessyaSearch,
									//pRessyaSearchEstimate,
									idxRessyaSearch,
									&sRessyaBefore,
									iTrackIndexTer,
									&sRessyaCurrent,
									iMainTrack/*,
									contRessyaNumbered[iRessyahoukouSearch][idxRessyaSearch]*/);
							}
						}
					}
				}
				//------------------T܂------------------

				CentDedRessya* pRessyaBefore = pRessyaCont[sRessyaBefore.getRessyahoukou()]->getMuPtr()->get(sRessyaBefore.getRessyaIndex());

				if (!bContinueSearch || sRessyaCurrent.getRessyaIndex() == INT_MIN)
				{
					pRessyaBefore->setRessyaidxNext(INT_MIN);
					break;
				}

#pragma omp critical
				{
					if (contRessyaNumbered[sRessyaCurrent.getRessyahoukou()][sRessyaCurrent.getRessyaIndex()])
					{
						//truȅꍇpRessyaNextɉ^pɓĂꍇ́ABefore̎ԂINT_MINɂB
						//pRessyaBefore->setRessyaidxNext(INT_MIN);
						//break;
						bContinueSearch = false;
					}
					else
					{
						//falsȅꍇAcontRessyaNumberedtrueɂB
						contRessyaNumbered[sRessyaCurrent.getRessyahoukou()][sRessyaCurrent.getRessyaIndex()] = true;
						//̑̓(ԏAԂւ̏oԁE^ԏݓ)critical̊Oōs
					}
				}

				if (!bContinueSearch)
				{
					pRessyaBefore->setRessyaidxNext(INT_MIN);
					break;
				}

				CentDedRessya* pRessyaNext = pRessyaCont[sRessyaCurrent.getRessyahoukou()]->getMuPtr()->get(sRessyaCurrent.getRessyaIndex());

				//OԂ̎ԏ
				pRessyaBefore->setRessyaidxNext(sRessyaCurrent.getRessyaIndex());
				pRessyaBefore->setRessyahoukouNext(sRessyaCurrent.getRessyahoukou());

				//Ԃɉ^pԍݒƁAoԏOԂRs[B
				pRessyaNext->setOperationNumber(strOperationNumber);
				pRessyaNext->setRessyaidxOut(pRessyaBefore->getRessyaidxOut());
				pRessyaNext->setRessyahoukouOut(pRessyaBefore->getRessyahoukouOut());
				//pRessyaNext->setRessyaidxNext(INT_MIN);

//#pragma omp critical
//				contRessyaNumbered[sRessyaCurrent.getRessyahoukou()][sRessyaCurrent.getRessyaIndex()] = true;

				//̂߂ɁAsRessyaBeforeB
				sRessyaBefore.setRessyahoukou(sRessyaCurrent.getRessyahoukou());// pRessyaNext->getRessyahoukou();
				sRessyaBefore.setRessyaIndex(sRessyaCurrent.getRessyaIndex());
				iEkiIndexTer = pRessyaNext->EkiIndexOfEkiOrder(pRessyaNext->getSyuuchakuEki());

				CentDedEkiJikoku aEkiJikokuSyuuchakuNext =
					pRessyaNext->getCentDedEkiJikoku(pRessyaNext->getSyuuchakuEki());
				if (aEkiJikokuSyuuchakuNext.getEkiatsukai() == CentDedEkiJikoku::Ekiatsukai_Keiyunasi)
				{
					pRessyaNext->setRessyaidxNext(INT_MIN);
					break;
				}
				CentDedRessyaTrack aRessyaTrackSyuuchakuNext =
					pRessyaNext->getCentDedRessyaTrack(pRessyaNext->getSyuuchakuEki());
				if (aRessyaTrackSyuuchakuNext.getOperation() == CentDedRessyaTrack::Operation_InOut ||
					aRessyaTrackSyuuchakuNext.getOperation() == CentDedRessyaTrack::Operation_Outer)
				{
					pRessyaNext->setRessyaidxNext(INT_MIN);
					break;
				}
				else if (aRessyaTrackSyuuchakuNext.getOperation() == CentDedRessyaTrack::Operation_None)
				{
					sRessyaBefore.setJikoku(pRessyaNext
						->getCentDedEkiJikoku(pRessyaNext->getSyuuchakuEki()).getChakujikoku(true));
					iTrackIndexTer = aRessyaTrackSyuuchakuNext.getRessyaTrackIndex();
					if (iTrackIndexTer == 0)
					{
						iTrackIndexTer = pEkiCont->get(iEkiIndexTer).getMainTrack(sRessyaBefore.getRessyahoukou());
					}
				}
				else if (aRessyaTrackSyuuchakuNext.getOperation() == CentDedRessyaTrack::Operation_Shunt)
				{
					if (aRessyaTrackSyuuchakuNext.getOperationChakuJikoku(true).isNull())
					{
						CdDedJikoku aCdDedJikoku = aEkiJikokuSyuuchakuNext.getChakujikoku(true);
						sRessyaBefore.setJikoku(aCdDedJikoku.addSeconds(60));
					}
					else
					{
						sRessyaBefore.setJikoku(aRessyaTrackSyuuchakuNext.getOperationChakuJikoku(true));
					}
					iTrackIndexTer = aRessyaTrackSyuuchakuNext.getShuntTrackIndex();
				}
			}

		}
	}
	for (int iRessyahoukou = Ressyahoukou_Kudari;
		iRessyahoukou <= Ressyahoukou_Nobori; iRessyahoukou++)
	{
		int iSize = pRessyaCont[iRessyahoukou]->size();
		for (int idxRessya = 0; idxRessya < iSize; idxRessya++)
		{
			if (!contRessyaNumbered[iRessyahoukou][idxRessya])
			{
				CentDedRessya* pCentDedRessya = pRessyaCont[iRessyahoukou]->getMuPtr()->get(idxRessya);
				pCentDedRessya->setOperationNumber(_T(""));
				pCentDedRessya->setRessyaidxOut(INT_MIN);
				pCentDedRessya->setRessyaidxNext(INT_MIN);
			}
		}
	}
}

void CDedOperationConnecter::operationUpdate(
	const CdDedJikoku aCdDedJikokuMin, 
	const CdDedJikoku aCdDedJikokuMax, 
	const ERessyahoukou eRessyahoukouEdit, 
	const int iIndexDst, 
	const int iSizeDst, 
	const int iAddSize)
{
	const CentDedEkiCont* pEkiCont = m_pDedRosen->getCentDedEkiCont();
	CentDedRessyaCont* pRessyaCont[2];
	for (int iRessyahoukou = Ressyahoukou_Kudari;
		iRessyahoukou <= Ressyahoukou_Nobori; iRessyahoukou++)
	{
		pRessyaCont[iRessyahoukou] = m_pDedDia->getCentDedRessyaCont((ERessyahoukou)iRessyahoukou);
	}

	//ςݗIndex쐬
	vector<vector<bool>> contRessyaNumbered;
	contRessyaNumbered.resize(2);
	for (int iRessyahoukou = Ressyahoukou_Kudari;
		iRessyahoukou <= Ressyahoukou_Nobori; iRessyahoukou++)
	{
		contRessyaNumbered[iRessyahoukou].assign(pRessyaCont[iRessyahoukou]->size(), false);
	}


	for (int iRessyahoukou = Ressyahoukou_Kudari;
		iRessyahoukou <= Ressyahoukou_Nobori; iRessyahoukou++)
	{
		int iSize = pRessyaCont[iRessyahoukou]->size();
#pragma omp parallel for schedule(dynamic)
		for (int idxRessya = 0; idxRessya < iSize; idxRessya++)
		{
			CentDedRessya* pCentDedRessya = pRessyaCont[iRessyahoukou]->getMuPtr()->get(idxRessya);
			if (pCentDedRessya->isNull())
			{
				continue;
			}
			CentDedEkiJikoku aCentDedEkiJikokuShihatsu =
				pCentDedRessya->getCentDedEkiJikoku(pCentDedRessya->getSihatsuEki());
			if (aCentDedEkiJikokuShihatsu.getEkiatsukai() == CentDedEkiJikoku::Ekiatsukai_Keiyunasi)
			{
				continue;
			}
			CentDedRessyaTrack aCentDedRessyaTrackShihatsu =
				pCentDedRessya->getCentDedRessyaTrack(pCentDedRessya->getSihatsuEki());
			if (aCentDedRessyaTrackShihatsu.getOperation() != CentDedRessyaTrack::Operation_InOut &&
				aCentDedRessyaTrackShihatsu.getOperation() != CentDedRessyaTrack::Operation_Outer)
			{
				continue;
			}
			else if (aCentDedRessyaTrackShihatsu.getOperationNumber().empty())
			{
				//Xgŉ^pԍɂ̂ŁAcontRessyaNumberedfalsê܂܂ɂĂA
				//ł͋ɂƂ͂ȂėǂƂB
				//pRessyaCont[iRessyahoukou]->getMuPtr()->get(idxRessya)->setOperationNumber("");
				//contRessyaNumbered[iRessyahoukou][idxRessya] = true;
				continue;
			}

			tstring strOperationNumber = aCentDedRessyaTrackShihatsu.getOperationNumber();
			pCentDedRessya->setOperationNumber(strOperationNumber);
			pCentDedRessya->setRessyaidxOut(idxRessya);
			pCentDedRessya->setRessyahoukouOut((ERessyahoukou)iRessyahoukou);
#pragma omp critical
			contRessyaNumbered[iRessyahoukou][idxRessya] = true;

			//Step3 ԌƂāAIw̎ƔԐ擾BƂȂ̏ꍇ́AƔԐ
			//̏ꍇ́AƓԐ擾B
		//iTerminalTrackIndex OԂ̏IԐ {(0)͎gpȂ悤ɂB
			int iTrackIndexTer;
		//iEkiIndexTerminal OԏIw̉wIndex
			int iEkiIndexTer = pCentDedRessya->EkiIndexOfEkiOrder(pCentDedRessya->getSyuuchakuEki());
			CdDedRessyaProperty sRessyaBefore;
			sRessyaBefore.setRessyaIndex(idxRessya);
			sRessyaBefore.setRessyahoukou(pCentDedRessya->getRessyahoukou());

			CentDedEkiJikoku aEkiJikokuOutSyuuchaku =
				pCentDedRessya->getCentDedEkiJikoku(pCentDedRessya->getSyuuchakuEki());
			if (aEkiJikokuOutSyuuchaku.getEkiatsukai() == CentDedEkiJikoku::Ekiatsukai_Keiyunasi)
			{
				pCentDedRessya->setRessyaidxNext(INT_MIN);
				continue;
			}
			CentDedRessyaTrack aRessyaTrackOutSyuuchaku =
				pCentDedRessya->getCentDedRessyaTrack(pCentDedRessya->getSyuuchakuEki());
			if (aRessyaTrackOutSyuuchaku.getOperation() == CentDedRessyaTrack::Operation_InOut ||
				aRessyaTrackOutSyuuchaku.getOperation() == CentDedRessyaTrack::Operation_Outer)
			{
				pCentDedRessya->setRessyaidxNext(INT_MIN);
				continue;
			}
			else if (aRessyaTrackOutSyuuchaku.getOperation() == CentDedRessyaTrack::Operation_None)
			{
				sRessyaBefore.setJikoku(pCentDedRessya
					->getCentDedEkiJikoku(pCentDedRessya->getSyuuchakuEki()).getChakujikoku(true));
				iTrackIndexTer = aRessyaTrackOutSyuuchaku.getRessyaTrackIndex();
				if (iTrackIndexTer == 0)
				{
					iTrackIndexTer = pEkiCont->get(iEkiIndexTer).getMainTrack(sRessyaBefore.getRessyahoukou());
				}
			}
			else if (aRessyaTrackOutSyuuchaku.getOperation() == CentDedRessyaTrack::Operation_Shunt)
			{
				if (aRessyaTrackOutSyuuchaku.getOperationChakuJikoku(true).isNull())
				{
					CdDedJikoku aCdDedJikoku = aEkiJikokuOutSyuuchaku.getChakujikoku(true);
					sRessyaBefore.setJikoku(aCdDedJikoku.addSeconds(60));
				}
				else
				{
					sRessyaBefore.setJikoku(aRessyaTrackOutSyuuchaku.getOperationChakuJikoku(true));
				}
				iTrackIndexTer = aRessyaTrackOutSyuuchaku.getShuntTrackIndex();
			}

			//Step4 ԒT
			//ԂƂȂƂāA
				//(1)OԂƓԐn܂
				//(2)OԂ̎(N_܂Ȃ)n܂
				//(3)OԂƎԂ̊ԂɁA̗Ԃ̔ԐgpȂ3𖞂
			//TΏۂ̗Ԃ
			//(1)iEkiIndexTerminaln̏ꍇ@Ƃ̏ꍇԐɂāAƂȂEȍꍇԐɂāAԐ擾AȂ玞擾
				//(1)b莟ԂAaJikokuTerォaJikokuAfterCurOȂAVȎb莟ԂɂB
				//AΏۂɔԍtĂȂaJikokuAfterCur㏑Ab莟Ԃ͋ɂB
				//(2)b莟Ԃ݂ꍇAaJikokuTerォaJikokuAfterCurOȂAVȎb莟ԂɂB
			//(2)iEkiIndexTerminalrw̏ꍇA܂́AnwEIw̔ԐɂāAԐ擾AȂ玞擾
				//(1)<<aJikokuTer<aJikokuAfterCurȂAցA
				//(2)<aJikokuTer<aJikokuAfterCur<ȂATł؂
				//(3)<aJikokuTer<<aJikokuAfterCurȂATł؂
				//(4)aJikokuTer<<<aJikokuAfterCurȂAaJikokuAfterCur𒅎ɂAb莟ԂɂĎ
				//(5)aJikokuTer<<aJikokuAfterCur<ȂAaJikokuAfterCur𒅎ɂAb莟ԂɂĎ
					//()̃p^[́Ab莟ԂƁATΏۂ̗Ԃ̍ݐĂ̂ŁA{Ă͂ȂȂp^[
				//(6)aJikokuTer<aJikokuAfterCur<<ȂA
			//(3)iEkiIndexTerminalȈꍇ@Ƃ̏ꍇԐɂāAƂȂ̏ꍇԐɂāAԐ擾AȂ玞擾
			//aJikokuTerォaJikokuAfterCurOȂAaJikokuAfterCur𒅎ɂAb莟ԂɂĎ
			//(3)iEkiIndexTerminal^sEoȐꍇ
			//E󗍂݂̒TŒǉ
			while (1)
			{
				//aJikokuAfterCur aCdDedJikokuTerminalƂ̒l̊ԂAT͈͂ƂȂ܂B
				//T͈͂ɗԂ݂ꍇA̗Ԃ̎ŁA̒lɏ㏑AT͈͂߂Ă܂B
				//ĺA_CON_1bOłB
				//CdDedJikoku aJikokuAfterCur = aKitenJikoku;
				//aJikokuAfterCur.addSeconds(-1);
				//iRessyaidxAfterCur b莟Ԃ̗IndexłAeRessyahoukouAfterCurƑgݍ킹Ďg܂B
				//lyюb莟Ԃ݂Ȃꍇ́AINT_MINłB
				//int iRessyaidxAfterCur = INT_MIN;
				//eRessyahoukouAfterCur b莟Ԃ̗ԕłBiRessyaidxAfterCurƑgݍ킹Ďg܂B
				//l͉(ftHg)Ab莟Ԃ݂Ȃꍇ́AsłB
				//ERessyahoukou eRessyahoukouAfterCur;
				CdDedRessyaProperty sRessyaCurrent;
				CdDedJikoku aJikokuTemp = m_KitenJikoku;
				aJikokuTemp.addSeconds(-1);
				sRessyaCurrent.setJikoku(aJikokuTemp);
				sRessyaCurrent.setRessyaIndex(INT_MIN);


				//-----ԃ`FbN̊Tv-----
				//	OԂRessyaidxNextINT_MINł͂Ȃꍇ́AҏWȌԂł͎ԂƂƁB
				//	̑OԂƎԂ̌q肪AҏWɂĕςĂȂƂmȏꍇ́A
				//	ԒT΂ƂŁA쑬x̃Abv}
				//	ҏWɂĕςĂȂƂmȂ̂́A
				//	(1) OԁԂMinO̎ԂɎ܂
				//	(2) OԁԂMaxO̎ԂɎ܂
				//	(3) ԂꍇAOԂMaxŉ^sIB
				//	AMax̏ꍇA"^pԍ"ςĂ\̂ŁA^ԏ݂Ȃǂ͒ʏʂs
				//	̂sRessyaCurrentɁAm肵Ԃ̏݁AԒT[v΂A[v̏ݍƂɈڂ
				//----------------------------------
				bool bPassSearch = false;
				//Ԃ݂ĂꍇAOԏIƎԎn̎ԑтAMin-MaxƏdȂĂ邩ǂmF
				if (sRessyaBefore.getJikoku().compare(aCdDedJikokuMax, m_KitenJikoku) > 0)
				{
					//Max끨NextRȂ̂ŁAԂƂ̐ڑ͖Ȃ
					const CentDedRessya* pRessyaBeforeRead = pRessyaCont[sRessyaBefore.getRessyahoukou()]
						->getMuPtr()->get(sRessyaBefore.getRessyaIndex());
					if (pRessyaBeforeRead->getRessyaidxNext() != INT_MIN)
					{
						//MaxŁAԂꍇ́AҏWɂĐVɎԂł邱ƂȂ̂ŁAbreak
						//͊ԈႢAMaxŁAԂꍇ́AVɉ^pԍt^邱ƂŌq肪łꍇ̂ŁAԒTsB

						//ԂAҏWԕiIndexDstȏiIndexDst+iSizeDstȂAԂȂĂ̂ōĒT
						//ԂAҏWԕiIndexDst + iSizeDstȏ̏ꍇ́AiAddSize - iSizeDstIndexɑƂŕ␳
						if (pRessyaBeforeRead->getRessyahoukouNext() != eRessyahoukouEdit ||
							pRessyaBeforeRead->getRessyaidxNext() < iIndexDst ||
							pRessyaBeforeRead->getRessyaidxNext() >= (iIndexDst + iSizeDst))
						{
							int iRessyaidxNextOld = pRessyaBeforeRead->getRessyaidxNext();

							if (pRessyaBeforeRead->getRessyahoukouNext() == eRessyahoukouEdit &&
								iRessyaidxNextOld >= (iIndexDst + iSizeDst))
							{
								iRessyaidxNextOld += (iAddSize - iSizeDst);
							}
							sRessyaCurrent.setRessyahoukou(pRessyaBeforeRead->getRessyahoukouNext());
							sRessyaCurrent.setRessyaIndex(iRessyaidxNextOld);
							bPassSearch = true;
						}

					}
				}
				else if(sRessyaBefore.getJikoku().compare(aCdDedJikokuMin, m_KitenJikoku) < 0)
				{
					const CentDedRessya* pRessyaBeforeRead = pRessyaCont[sRessyaBefore.getRessyahoukou()]
						->getMuPtr()->get(sRessyaBefore.getRessyaIndex());
					//MinOŎԂꍇAҏWŐVɎԂł\̂ŁAԒTs
					if (pRessyaBeforeRead->getRessyaidxNext() != INT_MIN)
					{
						//ԂꍇAԂ̎n𒲂ׁAꂪMinOȂAԊmIndex␳̂݃`FbN

						//ԂAҏWԕiIndexDstȏiIndexDst+iSizeDstȂAԂȂĂ̂ōĒT
						//ԂAҏWԕiIndexDst + iSizeDstȏ̏ꍇ́AiAddSize - iSizeDstIndexɑƂŕ␳
						if (pRessyaBeforeRead->getRessyahoukouNext() != eRessyahoukouEdit ||
							pRessyaBeforeRead->getRessyaidxNext() < iIndexDst ||
							pRessyaBeforeRead->getRessyaidxNext() >= (iIndexDst + iSizeDst))
						{
							int iRessyaidxNextOld = pRessyaBeforeRead->getRessyaidxNext();
							//ԂҏWӏȂAIndex␳B
							if (pRessyaBeforeRead->getRessyahoukouNext() == eRessyahoukouEdit &&
								iRessyaidxNextOld >= (iIndexDst + iSizeDst))
							{
								iRessyaidxNextOld += (iAddSize - iSizeDst);
							}
							CentDedRessya* pRessyaNextOld = pRessyaCont[pRessyaBeforeRead->getRessyahoukouNext()]
								->getMuPtr()->get(iRessyaidxNextOld);
							//NextOldNullԂ̉\()Ȃ
							CentDedEkiJikoku aEkiJikokuNextOldSihatsu =
								pRessyaNextOld->getCentDedEkiJikoku(pRessyaNextOld->getSihatsuEki());
							CentDedRessyaTrack aRessyaTrackNextOldSihatsu =
								pRessyaNextOld->getCentDedRessyaTrack(pRessyaNextOld->getSihatsuEki());
							//NextOld̎nwoR̉\()Ȃ
							if (aRessyaTrackNextOldSihatsu.getOperation() == CentDedRessyaTrack::Operation_None)
							{
								if (aEkiJikokuNextOldSihatsu.getHatsujikoku(true).compare(aCdDedJikokuMin, m_KitenJikoku) < 0)
								{
									//pRessyaNextOld̎nwAaCdDedJikokuMinOȂApRessyaNextOldԂƂ
									sRessyaCurrent.setRessyahoukou(pRessyaBeforeRead->getRessyahoukouNext());
									sRessyaCurrent.setRessyaIndex(iRessyaidxNextOld);
									bPassSearch = true;
								}
							}
							else if (aRessyaTrackNextOldSihatsu.getOperation() == CentDedRessyaTrack::Operation_Shunt)
							{
								CdDedJikoku aJikokuTemp;
								if (aRessyaTrackNextOldSihatsu.getOperationHatsuJikoku().isNull())
								{
									aJikokuTemp = aEkiJikokuNextOldSihatsu.getHatsujikoku(true);
									aJikokuTemp.addSeconds(-60);
								}
								else
								{
									aJikokuTemp = aRessyaTrackNextOldSihatsu.getOperationHatsuJikoku();
								}

								if (aJikokuTemp.compare(aCdDedJikokuMin, m_KitenJikoku) < 0)
								{
									//pRessyaNextOld̓AaCdDedJikokuMinOȂApRessyaNextOldԂƂ
									sRessyaCurrent.setRessyahoukou(pRessyaBeforeRead->getRessyahoukouNext());
									sRessyaCurrent.setRessyaIndex(iRessyaidxNextOld);
									bPassSearch = true;
								}
							}
						}
					}
				}

		//------------------T------------------
				bool bContinueSearch = true;
				for (int iRessyahoukouSearch = Ressyahoukou_Kudari;
					iRessyahoukouSearch <= Ressyahoukou_Nobori && bContinueSearch && !bPassSearch ; iRessyahoukouSearch++)
				{
					int iEkiOrderTerminal = pRessyaCont[iRessyahoukouSearch]->EkiOrderOfEkiIndex(iEkiIndexTer);
					int iMainTrack = pEkiCont->get(iEkiIndexTer).getMainTrack((ERessyahoukou)iRessyahoukouSearch);

					//EΉ iEkiIndexTerɁAEݒŌqĂwOrder߂B
					deque<int> iEkiOrderBrunchOriginSide;
					deque<int> iEkiOrderLoop;
					deque<int> iEkiOrderBrunchTerminalSide;
					int iResult = pEkiCont->getEkiOrderBrunchLoop(
						iEkiOrderTerminal,
						(ERessyahoukou)iRessyahoukouSearch,
						iEkiOrderBrunchOriginSide,
						iEkiOrderLoop,
						iEkiOrderBrunchTerminalSide);

					int iSizeSearch = pRessyaCont[iRessyahoukouSearch]->size();
					for (int idxRessyaSearch = 0;
						idxRessyaSearch < iSizeSearch && bContinueSearch;
						idxRessyaSearch++)
					{
						if (sRessyaBefore.getRessyahoukou() == (ERessyahoukou)iRessyahoukouSearch 
							&& sRessyaBefore.getRessyaIndex() == idxRessyaSearch)
						{
							//ΏۗԂAOԂƓȂ玟
							continue;
						}
						CentDedRessya* pRessyaSearch = pRessyaCont[iRessyahoukouSearch]->getMuPtr()->get(idxRessyaSearch);
						if (pRessyaSearch->isNull())
						{
							//ΏۗԂANullԂȂ玟
							continue;
						}

						//EΉ
						if (iResult == -1)
						{
							bContinueSearch = RessyaConnectCheck(
								iEkiOrderTerminal,
								pRessyaSearch,
								idxRessyaSearch,
								&sRessyaBefore,
								iTrackIndexTer,
								&sRessyaCurrent,
								iMainTrack/*,
								contRessyaNumbered[iRessyahoukouSearch][idxRessyaSearch]*/);
							if (!bContinueSearch)
							{
								break;
							}
						}
						else
						{
							//origin->loop->terminal̏ɍsB́AnwƓȂ̐ڑwɂ͂ĂꍇA
							//getShihatsuEki珈ȂƁAɕ̗Ԃ݂ĂƂ݂ȂĂ܂AڑsȂ
							//)IȎnwloop[1]Aloop[0]ɂ͂ĂƂ
							//܂loop[0]̕ŁARessyaConnectChecksAb莟ԂɂȂȂA̕IndexsRessyaCurrentɏ܂B
							//loop[1]̕ŁARessyaConnectChecksꍇARsRessyaCurrentJikokuƓɂȂ邪A
							//sRessyaCurrent̕Indexv΁AԂƔʂł̂ŁAڑłB
							for (int idxo = 0; idxo < (int)iEkiOrderBrunchOriginSide.size() && bContinueSearch; idxo++)
							{
								bContinueSearch = RessyaConnectCheck(
									iEkiOrderBrunchOriginSide[idxo],
									pRessyaSearch,
									//pRessyaSearchEstimate,
									idxRessyaSearch,
									&sRessyaBefore,
									iTrackIndexTer,
									&sRessyaCurrent,
									iMainTrack/*,
											  contRessyaNumbered[iRessyahoukouSearch][idxRessyaSearch]*/);
							}
							for (int idxl = 0; idxl < (int)iEkiOrderLoop.size() && bContinueSearch; idxl++)
							{
								bContinueSearch = RessyaConnectCheck(
									iEkiOrderLoop[idxl],
									pRessyaSearch,
									//pRessyaSearchEstimate,
									idxRessyaSearch,
									&sRessyaBefore,
									iTrackIndexTer,
									&sRessyaCurrent,
									iMainTrack/*,
											  contRessyaNumbered[iRessyahoukouSearch][idxRessyaSearch]*/);
							}
							for (int idxt = 0; idxt < (int)iEkiOrderBrunchTerminalSide.size() && bContinueSearch; idxt++)
							{
								bContinueSearch = RessyaConnectCheck(
									iEkiOrderBrunchTerminalSide[idxt],
									pRessyaSearch,
									//pRessyaSearchEstimate,
									idxRessyaSearch,
									&sRessyaBefore,
									iTrackIndexTer,
									&sRessyaCurrent,
									iMainTrack/*,
											  contRessyaNumbered[iRessyahoukouSearch][idxRessyaSearch]*/);
							}
						}
					}
				}
				//------------------T܂------------------

				CentDedRessya* pRessyaBefore = pRessyaCont[sRessyaBefore.getRessyahoukou()]->getMuPtr()->get(sRessyaBefore.getRessyaIndex());
				if (!bContinueSearch || sRessyaCurrent.getRessyaIndex() == INT_MIN)
				{
					pRessyaBefore->setRessyaidxNext(INT_MIN);
					break;
				}

#pragma omp critical
				{
					if (contRessyaNumbered[sRessyaCurrent.getRessyahoukou()][sRessyaCurrent.getRessyaIndex()])
					{
						//truȅꍇpRessyaNextɉ^pɓĂꍇ́ABefore̎ԂINT_MINɂB
						//pRessyaBefore->setRessyaidxNext(INT_MIN);
						//break;
						bContinueSearch = false;
					}
					else
					{
						//falsȅꍇAcontRessyaNumberedtrueɂB
						contRessyaNumbered[sRessyaCurrent.getRessyahoukou()][sRessyaCurrent.getRessyaIndex()] = true;
						//̑̓(ԏAԂւ̏oԁE^ԏݓ)critical̊Oōs
					}
				}
				if (!bContinueSearch)
				{
					pRessyaBefore->setRessyaidxNext(INT_MIN);
					break;
				}

				CentDedRessya* pRessyaNext = pRessyaCont[sRessyaCurrent.getRessyahoukou()]->getMuPtr()->get(sRessyaCurrent.getRessyaIndex());

				//OԂ̎ԏ
				pRessyaBefore->setRessyaidxNext(sRessyaCurrent.getRessyaIndex());
				pRessyaBefore->setRessyahoukouNext(sRessyaCurrent.getRessyahoukou());

				//Ԃɉ^pԍݒƁAoԏOԂRs[B
				pRessyaNext->setOperationNumber(strOperationNumber);
				pRessyaNext->setRessyaidxOut(pRessyaBefore->getRessyaidxOut());
				pRessyaNext->setRessyahoukouOut(pRessyaBefore->getRessyahoukouOut());
				//pRessyaNext->setRessyaidxNext(INT_MIN);

//#pragma omp critical
//				contRessyaNumbered[sRessyaCurrent.getRessyahoukou()][sRessyaCurrent.getRessyaIndex()] = true;

				//̂߂ɁAsRessyaBeforeB
				sRessyaBefore.setRessyahoukou(sRessyaCurrent.getRessyahoukou());// pRessyaNext->getRessyahoukou();
				sRessyaBefore.setRessyaIndex(sRessyaCurrent.getRessyaIndex());
				iEkiIndexTer = pRessyaNext->EkiIndexOfEkiOrder(pRessyaNext->getSyuuchakuEki());

				CentDedEkiJikoku aEkiJikokuSyuuchakuNext =
					pRessyaNext->getCentDedEkiJikoku(pRessyaNext->getSyuuchakuEki());
				if (aEkiJikokuSyuuchakuNext.getEkiatsukai() == CentDedEkiJikoku::Ekiatsukai_Keiyunasi)
				{
					pRessyaNext->setRessyaidxNext(INT_MIN);
					break;
				}
				CentDedRessyaTrack aRessyaTrackSyuuchakuNext =
					pRessyaNext->getCentDedRessyaTrack(pRessyaNext->getSyuuchakuEki());
				if (aRessyaTrackSyuuchakuNext.getOperation() == CentDedRessyaTrack::Operation_InOut ||
					aRessyaTrackSyuuchakuNext.getOperation() == CentDedRessyaTrack::Operation_Outer)
				{
					pRessyaNext->setRessyaidxNext(INT_MIN);
					break;
				}
				else if (aRessyaTrackSyuuchakuNext.getOperation() == CentDedRessyaTrack::Operation_None)
				{
					sRessyaBefore.setJikoku(pRessyaNext
						->getCentDedEkiJikoku(pRessyaNext->getSyuuchakuEki()).getChakujikoku(true));
					iTrackIndexTer = aRessyaTrackSyuuchakuNext.getRessyaTrackIndex();
					if (iTrackIndexTer == 0)
					{
						iTrackIndexTer = pEkiCont->get(iEkiIndexTer).getMainTrack(sRessyaBefore.getRessyahoukou());
					}
				}
				else if (aRessyaTrackSyuuchakuNext.getOperation() == CentDedRessyaTrack::Operation_Shunt)
				{
					if (aRessyaTrackSyuuchakuNext.getOperationChakuJikoku(true).isNull())
					{
						CdDedJikoku aCdDedJikoku = aEkiJikokuSyuuchakuNext.getChakujikoku(true);
						sRessyaBefore.setJikoku(aCdDedJikoku.addSeconds(60));
					}
					else
					{
						sRessyaBefore.setJikoku(aRessyaTrackSyuuchakuNext.getOperationChakuJikoku(true));
					}
					iTrackIndexTer = aRessyaTrackSyuuchakuNext.getShuntTrackIndex();
				}
			}

		}
	}
	for (int iRessyahoukou = Ressyahoukou_Kudari;
		iRessyahoukou <= Ressyahoukou_Nobori; iRessyahoukou++)
	{
		int iSize = pRessyaCont[iRessyahoukou]->size();
		for (int idxRessya = 0; idxRessya < iSize; idxRessya++)
		{
			if (!contRessyaNumbered[iRessyahoukou][idxRessya])
			{
				CentDedRessya* pCentDedRessya = pRessyaCont[iRessyahoukou]->getMuPtr()->get(idxRessya);
				pCentDedRessya->setOperationNumber(_T(""));
				pCentDedRessya->setRessyaidxOut(INT_MIN);
				pCentDedRessya->setRessyaidxNext(INT_MIN);
			}
		}
	}
}
;

} //namespace entDgr
