/*
OuDiaSecond Copyright (C) 2017-2018 diagram_mania

̃vÓAtake-okm쐬OuDia\tgEFAłB
̃vOpɂẮAtake-okmLڂ̉Lɏ܂B
*/
/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CentDedDia.cpp
// ****************************************************************
*/
#include "stdafx.h"
#include "CentDedDia.h"
#include "CentDedDiaCont.h"

using namespace std ;

#ifdef _MFC_VER 
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#endif


namespace entDed{

// ****************************************************************
//	CentDedDia
// ****************************************************************

// ********************************
//	RXgN^
// ********************************
	CentDedDia::CentDedDia(const tstring& strName)
		: m_strName(strName)
		, m_iJikokuhyouMainBackColorIndex(0)
		, m_iJikokuhyouSubBackColorIndex(1)
		, m_iJikokuhyouBackPatternIndex(0)
		, m_bWaitOperationUpdate(false)
	{
		m_CentDedRessyaCont[0] = new CXRessyaCont(
			this,
			Ressyahoukou_Kudari);
		m_CentDedRessyaCont[1] = new CXRessyaCont(
			this,
			Ressyahoukou_Nobori);
	}

CentDedDia::CentDedDia( 
		int iEkiCount )
	:m_iJikokuhyouMainBackColorIndex(0)
	, m_iJikokuhyouSubBackColorIndex(1)
	, m_iJikokuhyouBackPatternIndex(0)
	, m_bWaitOperationUpdate(false)
{
	m_CentDedRessyaCont[0] = new CXRessyaCont( 
		this , 
		iEkiCount , Ressyahoukou_Kudari ) ;
	m_CentDedRessyaCont[1] = new CXRessyaCont( 
		this , 
		iEkiCount , Ressyahoukou_Nobori ) ;
}

CentDedDia::CentDedDia( 
		const tstring& strName ,
		int iEkiCount ) :
	m_strName( strName )
	, m_iJikokuhyouMainBackColorIndex(0)
	, m_iJikokuhyouSubBackColorIndex(1)
	, m_iJikokuhyouBackPatternIndex(0)
	, m_bWaitOperationUpdate(false)
{
	m_CentDedRessyaCont[0] = new CXRessyaCont( 
		this , 
		iEkiCount , Ressyahoukou_Kudari ) ;
	m_CentDedRessyaCont[1] = new CXRessyaCont( 
		this , 
		iEkiCount , Ressyahoukou_Nobori ) ;
}


CentDedDia::CentDedDia(
	const tstring & strName, 
	const int & iJikokuhyouMainBackColorIndex, 
	const int & iJikokuhyouSubBackColorIndex, 
	const int & iJikokuhyouBackPatternIndex, 
	int iEkiCount) :
	m_strName(strName),
	m_iJikokuhyouMainBackColorIndex(iJikokuhyouMainBackColorIndex),
	m_iJikokuhyouSubBackColorIndex(iJikokuhyouSubBackColorIndex),
	m_iJikokuhyouBackPatternIndex(iJikokuhyouBackPatternIndex),
	m_bWaitOperationUpdate(false)
{
	m_CentDedRessyaCont[0] = new CXRessyaCont(
		this,
		iEkiCount, Ressyahoukou_Kudari);
	m_CentDedRessyaCont[1] = new CXRessyaCont(
		this,
		iEkiCount, Ressyahoukou_Nobori);
}

CentDedDia::CentDedDia( const CentDedDia& value ) :
	m_strName( value.m_strName ) ,
	m_iJikokuhyouMainBackColorIndex(value.m_iJikokuhyouMainBackColorIndex),
	m_iJikokuhyouSubBackColorIndex(value.m_iJikokuhyouSubBackColorIndex),
	m_iJikokuhyouBackPatternIndex(value.m_iJikokuhyouBackPatternIndex),
	m_bWaitOperationUpdate(false)
{
	m_CentDedRessyaCont[0] = new CXRessyaCont( this , *value.m_CentDedRessyaCont[0] ) ;
	m_CentDedRessyaCont[1] = new CXRessyaCont( this , *value.m_CentDedRessyaCont[1] ) ;
}

CentDedDia& CentDedDia::operator=( const CentDedDia& value )
{
	super::operator=( value ) ; 
	// --------------------------------
	CentDedDiaCont* pDiaCont = dynamic_cast<CentDedDiaCont*>( getParent() ) ;
	if ( pDiaCont != NULL )
	{
		/*
		㏑(operator=): ̃IuWFNgeIuWFNg CentDedDiaCont ̎qłꍇŁÃ_C󕶎łꍇA͓Õ_C CentDedDiaCont ɂꍇ͗OX[B
	@	  (ACentDedDiaCont::set()ɓnƃG[ɂȂ悤ȃIuWFNgłꍇ́A͗OX[Ƃ܂)
		*/
		int iResult = pDiaCont->setable( value , pDiaCont->getIndex( this ) ) ;
		if( iResult < 0 )
		{
			throw LException() ;
		}
	}

	// --------------------------------
	m_strName = value.m_strName ;
	*m_CentDedRessyaCont[0] = *value.m_CentDedRessyaCont[0] ;	
	*m_CentDedRessyaCont[1] = *value.m_CentDedRessyaCont[1] ;
	m_iJikokuhyouMainBackColorIndex = value.m_iJikokuhyouMainBackColorIndex;
	m_iJikokuhyouSubBackColorIndex = value.m_iJikokuhyouSubBackColorIndex;
	
	return *this ;
}
		
CentDedDia::~CentDedDia()
{
	delete m_CentDedRessyaCont[0] ;
	delete m_CentDedRessyaCont[1] ;

}

	// ********************************
	//@name CChildBase-
	// ********************************
void CentDedDia::setParent( CParentBase* pParent )
{
	super::setParent( pParent ) ; 
	adjust() ;
}
	// ********************************
	//@name CentDedDia-
	// ********************************
void CentDedDia::setName( const tstring& value )
{
	//	㏑(operator=): ̃IuWFNgeIuWFNg CentDedDiaCont ̎qłꍇŁA
	//	_C󕶎łꍇ͗OX[B
	if ( value.length() == 0 )
	{
		throw LException() ;
	}
	// --------------------------------
	CentDedDiaCont* pDiaCont = dynamic_cast<CentDedDiaCont*>( getParent() ) ;
	if ( pDiaCont != NULL )
	{
		/*
		㏑(operator=): ̃IuWFNgeIuWFNg CentDedDiaCont ̎qłꍇŁA
			͓Õ_C CentDedDiaCont ɂꍇ͗OX[B
		*/
		int iResult = pDiaCont->findCentDedDiaByName( value ) ;
		if( iResult >= 0 && iResult != pDiaCont->getIndex( this ) )
		{
			throw LException() ;
		}
	}
	// --------------------------------
	m_strName = value ; 
}





	// ********************************
	//@name CentDedDia-
	// ********************************
void CentDedDia::adjustByEkijikokukeisiki(
		const CentDedEkiCont* pCentDedEkiCont ,
		int iEkiIndex )
{
	int iRv = 0 ;

	//		INT_MAX ́Aw肵ƂɂȂ܂B
	if ( iRv >= 0 )
	{
		if ( iEkiIndex == INT_MAX )
		{
			iEkiIndex = pCentDedEkiCont->size() - 1 ;
		}
		if ( !( 0 <= iEkiIndex && iEkiIndex < pCentDedEkiCont->size() ) )
		{
			iRv = -1 ;	//	iEkiIndex ܂B
		}
	}
	if ( iRv >= 0 )
	{
		for ( int iRessyahoukou = Ressyahoukou_Kudari ;
			iRessyahoukou <= Ressyahoukou_Nobori ;
			iRessyahoukou ++ )
		{
			ERessyahoukou eRessyahoukou = (ERessyahoukou)iRessyahoukou ;

			int iEkiOrder = pCentDedEkiCont->EkiOrderOfEkiIndex( eRessyahoukou , iEkiIndex ) ;
			CentDedEkiCont::CdDedEki aDedEki = pCentDedEkiCont->getMuPtr( eRessyahoukou )->get( iEkiOrder ) ;

			CentDedRessyaCont* pCentDedRessyaCont = getCentDedRessyaCont( eRessyahoukou ) ;

			pCentDedRessyaCont->adjustByEkijikokukeisiki( iEkiOrder , 
				aDedEki.getChakujikokuHyouji() , 
				aDedEki.getHatsujikokuHyouji() ) ;

		}
	}
}

void CentDedDia::adjust()
{
	int iRessyahoukou = 0 ; 
	for ( iRessyahoukou = Ressyahoukou_Kudari ; 
			iRessyahoukou <= Ressyahoukou_Nobori ; 
			iRessyahoukou ++ ){
		m_CentDedRessyaCont[iRessyahoukou]->adjust() ;
	}
}


	// ********************************
	//@name CentDedDia-wEԎʐ̕ύX
	// ********************************

int CentDedDia::isExistRessyaOfRessyasyubetsu( 
		int iRessyasyubetsuIndex ,
		ERessyahoukou* peRessyahoukou ,
		int* piRessyaIndex ) const
{
	int iRv = 0 ;
	ERessyahoukou eRessyahoukouFound = Ressyahoukou_Kudari ;
	int iRessyaIndexFound = -1 ;
	// --------------------------------
	if ( iRv >= 0 ){
			int iRessyahoukou = 0 ;
			for ( iRessyahoukou = Ressyahoukou_Kudari ; 
					iRv == 0 && iRessyahoukou <= Ressyahoukou_Nobori ; 
					iRessyahoukou ++ ){
				ERessyahoukou	eRessyahoukou = (ERessyahoukou)iRessyahoukou ;
				
				iRv = m_CentDedRessyaCont[iRessyahoukou]->
					isExistRessyaOfRessyasyubetsu( 
						iRessyasyubetsuIndex , &iRessyaIndexFound ) ;
				if ( iRv == 1 ){
					eRessyahoukouFound = eRessyahoukou ;
				}
			}
	}
	// --------------------------------
	if ( peRessyahoukou != NULL ){
		*peRessyahoukou = eRessyahoukouFound ;
	}
	if ( piRessyaIndex != NULL ){
		*piRessyaIndex = iRessyaIndexFound ;
	}

	return ( iRv ) ;
}

int CentDedDia::isExistRessyaOfEkiTrack2(
	int iEkiIndex,
	int iEkiTrack2Index,
	ERessyahoukou* peRessyahoukou,
	int* piRessyaIndex) const
{
	int iRv = 0;
	ERessyahoukou eRessyahoukouFound = Ressyahoukou_Kudari;
	int iRessyaIndexFound = -1;
	// --------------------------------
	if (iRv >= 0) {
		int iRessyahoukou = 0;
		for (iRessyahoukou = Ressyahoukou_Kudari;
			iRv == 0 && iRessyahoukou <= Ressyahoukou_Nobori;
			iRessyahoukou++) {
			ERessyahoukou	eRessyahoukou = (ERessyahoukou)iRessyahoukou;

			iRv = m_CentDedRessyaCont[iRessyahoukou]->
				isExistRessyaOfEkiTrack2(
					m_CentDedRessyaCont[iRessyahoukou]->EkiOrderOfEkiIndex(iEkiIndex),
					iEkiTrack2Index, &iRessyaIndexFound);
			if (iRv == 1) {
				eRessyahoukouFound = eRessyahoukou;
			}
		}
	}
	// --------------------------------
	if (peRessyahoukou != NULL) {
		*peRessyahoukou = eRessyahoukouFound;
	}
	if (piRessyaIndex != NULL) {
		*piRessyaIndex = iRessyaIndexFound;
	}

	return (iRv);
}

int CentDedDia::isExistRessyaOfOuterTerminal(
	int iEkiIndex,
	int iOuterTerminalIndex,
	ERessyahoukou* peRessyahoukou,
	int* piRessyaIndex) const
{
	int iRv = 0;
	ERessyahoukou eRessyahoukouFound = Ressyahoukou_Kudari;
	int iRessyaIndexFound = -1;
	// --------------------------------
	if (iRv >= 0) {
		int iRessyahoukou = 0;
		for (iRessyahoukou = Ressyahoukou_Kudari;
			iRv == 0 && iRessyahoukou <= Ressyahoukou_Nobori;
			iRessyahoukou++) {
			ERessyahoukou	eRessyahoukou = (ERessyahoukou)iRessyahoukou;

			iRv = m_CentDedRessyaCont[iRessyahoukou]->
				isExistRessyaOfOuterTerminal(
					m_CentDedRessyaCont[iRessyahoukou]->EkiOrderOfEkiIndex(iEkiIndex),
					iOuterTerminalIndex, &iRessyaIndexFound);
			if (iRv == 1) {
				eRessyahoukouFound = eRessyahoukou;
			}
		}
	}
	// --------------------------------
	if (peRessyahoukou != NULL) {
		*peRessyahoukou = eRessyahoukouFound;
	}
	if (piRessyaIndex != NULL) {
		*piRessyaIndex = iRessyaIndexFound;
	}

	return (iRv);
}
	// ********************************
	//@name CentDedRosen-qIuWFNg̑̒ʒm
	// ********************************
void CentDedDia::onEkiInsert( int iEkiIndex )
{
	int iRessyahoukou = 0 ; 
	for ( iRessyahoukou = Ressyahoukou_Kudari ; 
			iRessyahoukou <= Ressyahoukou_Nobori ; 
			iRessyahoukou ++ ){
		if ( iRessyahoukou == Ressyahoukou_Kudari ){ 
			m_CentDedRessyaCont[iRessyahoukou]->onEkiInsert( 
				m_CentDedRessyaCont[iRessyahoukou]->EkiOrderOfEkiIndex( 
					iEkiIndex ) 
			) ;
		}	else if ( iRessyahoukou == Ressyahoukou_Nobori ){ 
			m_CentDedRessyaCont[iRessyahoukou]->onEkiInsert( 
				m_CentDedRessyaCont[iRessyahoukou]->EkiOrderOfEkiIndex( 
					iEkiIndex ) + 1 
			) ;
			//	 +1 ̈ӖEEE
			//	Sw̘HɁAnwłwIndex0ǉꍇA
			//	̃ReỉwOrder 4()  ɒǉȂĂ͂Ȃ܂B 
		}
	}
}

void CentDedDia::onEkiErase( int iEkiIndex  )
{
	int iRessyahoukou = 0 ; 
	for ( iRessyahoukou = Ressyahoukou_Kudari ; 
			iRessyahoukou <= Ressyahoukou_Nobori ; 
			iRessyahoukou ++ ){
		m_CentDedRessyaCont[iRessyahoukou]->onEkiErase( 
			m_CentDedRessyaCont[iRessyahoukou]->EkiOrderOfEkiIndex( iEkiIndex ) ) ;
	}
}

void CentDedDia::onEkiTrack2Insert(int iEkiIndex, int iEkiTrack2Index)
{
	int iRessyahoukou = 0;
	for (iRessyahoukou = Ressyahoukou_Kudari;
		iRessyahoukou <= Ressyahoukou_Nobori; iRessyahoukou++) {
		m_CentDedRessyaCont[iRessyahoukou]->onEkiTrack2Insert(
			m_CentDedRessyaCont[iRessyahoukou]->EkiOrderOfEkiIndex(iEkiIndex), iEkiTrack2Index);
	}
}

void CentDedDia::onEkiTrack2Erase(int iEkiIndex, int iEkiTrack2Index)
{
	int iRessyahoukou = 0;
	for (iRessyahoukou = Ressyahoukou_Kudari;
		iRessyahoukou <= Ressyahoukou_Nobori; iRessyahoukou++) {
		m_CentDedRessyaCont[iRessyahoukou]->onEkiTrack2Erase(
			m_CentDedRessyaCont[iRessyahoukou]->EkiOrderOfEkiIndex(iEkiIndex), iEkiTrack2Index);
	}
}

void CentDedDia::onRessyasyubetsuInsert( int iRessyasyubetsuIndex )
{
	int iRessyahoukou = 0 ;
	for ( iRessyahoukou = Ressyahoukou_Kudari ; 
		iRessyahoukou <= Ressyahoukou_Nobori ; iRessyahoukou ++ ){
		m_CentDedRessyaCont[iRessyahoukou]->onRessyasyubetsuInsert( iRessyasyubetsuIndex ) ;
	}
}

void CentDedDia::onRessyasyubetsuErase( int iRessyasyubetsuIndex )
{
	int iRessyahoukou = 0 ;
	for ( iRessyahoukou = Ressyahoukou_Kudari ; 
		iRessyahoukou <= Ressyahoukou_Nobori ; iRessyahoukou ++ ){
		m_CentDedRessyaCont[iRessyahoukou]->onRessyasyubetsuErase( iRessyasyubetsuIndex ) ;
	}
}

void CentDedDia::adjustBrunchLoopByBrunchEdit(
	int iEkiIndex, bool bOriginSide, 
	deque<int>& iEkiIndexBrunchOriginSide,
	deque<int>& iEkiIndexLoop, deque<int>& iEkiIndexBrunchTerminalSide)
{
	//int iRessyahoukou = 0;
	//for (iRessyahoukou = Ressyahoukou_Kudari;
	//	iRessyahoukou <= Ressyahoukou_Nobori; iRessyahoukou++) {
	//for (int idx = 0; idx < (int)iEkiIndexBrunchOriginSide.size(); idx++)
	//{
	//	iEkiOrderBrunchOriginSide.push_back(
	//		m_CentDedRessyaCont[iRessyahoukou]->EkiOrderOfEkiIndex(
	//			iEkiIndexBrunchOriginSide[idx]));
	//}
	//for (int idx = 0; idx < (int)iEkiIndexLoop.size(); idx++)
	//{
	//	iEkiOrderLoop.push_back(
	//		m_CentDedRessyaCont[iRessyahoukou]->EkiOrderOfEkiIndex(
	//			iEkiIndexLoop[idx]));
	//}
	//for (int idx = 0; idx < (int)iEkiIndexBrunchTerminalSide.size(); idx++)
	//{
	//	iEkiOrderBrunchTerminalSide.push_back(
	//		m_CentDedRessyaCont[iRessyahoukou]->EkiOrderOfEkiIndex(
	//			iEkiIndexBrunchTerminalSide[idx]));
	//}
	m_CentDedRessyaCont[Ressyahoukou_Kudari]->adjustBrunchLoopByBrunchEdit(
		iEkiIndex, bOriginSide,
		iEkiIndexBrunchOriginSide, iEkiIndexLoop, iEkiIndexBrunchTerminalSide);


	deque<int> iEkiOrderBrunchOriginSide;
	deque<int> iEkiOrderLoop;
	deque<int> iEkiOrderBrunchTerminalSide;
	//if (iResult == -1)
	//{
	//	return iResult;
	//}
	for (int idx = 0; idx < (int)iEkiIndexBrunchOriginSide.size(); idx++)
	{
		iEkiOrderBrunchTerminalSide.push_front(
			m_CentDedRessyaCont[Ressyahoukou_Nobori]->EkiOrderOfEkiIndex(
				iEkiIndexBrunchOriginSide[idx]));
	}
	for (int idx = 0; idx < (int)iEkiIndexLoop.size(); idx++)
	{
		iEkiOrderLoop.push_front(
			m_CentDedRessyaCont[Ressyahoukou_Nobori]->EkiOrderOfEkiIndex(
				iEkiIndexLoop[idx]));
	}
	for (int idx = 0; idx < (int)iEkiIndexBrunchTerminalSide.size(); idx++)
	{
		iEkiOrderBrunchOriginSide.push_front(
			m_CentDedRessyaCont[Ressyahoukou_Nobori]->EkiOrderOfEkiIndex(
				iEkiIndexBrunchTerminalSide[idx]));
	}
	//if (iResult == INT_MAX)
	//{
	//	return INT_MIN;
	//}
	//else if (iResult == INT_MIN)
	//{
	//	return INT_MAX;
	//}
	//else if (iResult >= 0)
	//{
	//	iResult = (int)iEkiIndexLoop.size() - iResult - 1;
	//}

	m_CentDedRessyaCont[Ressyahoukou_Nobori]->adjustBrunchLoopByBrunchEdit(
		m_CentDedRessyaCont[Ressyahoukou_Nobori]->EkiOrderOfEkiIndex(iEkiIndex),
		!bOriginSide, iEkiOrderBrunchOriginSide,
		iEkiOrderLoop, iEkiOrderBrunchTerminalSide);
	//}
}

void CentDedDia::adjustBrunchLoopByLoopEdit(
	int iEkiIndex, int iPosition,
	deque<int>& iEkiIndexBrunchOriginSide, deque<int>& iEkiIndexLoop, 
	deque<int>& iEkiIndexBrunchTerminalSide)
{
	//int iRessyahoukou = 0;
	//for (iRessyahoukou = Ressyahoukou_Kudari;
	//	iRessyahoukou <= Ressyahoukou_Nobori; iRessyahoukou++) {
		//deque<int> iEkiOrderBrunchOriginSide;
		//deque<int> iEkiOrderLoop;
		//deque<int> iEkiOrderBrunchTerminalSide;
		//for (int idx = 0; idx < (int)iEkiIndexBrunchOriginSide.size(); idx++)
		//{
		//	iEkiOrderBrunchOriginSide.push_back(
		//		m_CentDedRessyaCont[iRessyahoukou]->EkiOrderOfEkiIndex(
		//			iEkiIndexBrunchOriginSide[idx]));
		//}
		//for (int idx = 0; idx < (int)iEkiIndexLoop.size(); idx++)
		//{
		//	iEkiOrderLoop.push_back(
		//		m_CentDedRessyaCont[iRessyahoukou]->EkiOrderOfEkiIndex(
		//			iEkiIndexLoop[idx]));
		//}
		//for (int idx = 0; idx < (int)iEkiIndexBrunchTerminalSide.size(); idx++)
		//{
		//	iEkiOrderBrunchTerminalSide.push_back(
		//		m_CentDedRessyaCont[iRessyahoukou]->EkiOrderOfEkiIndex(
		//			iEkiIndexBrunchTerminalSide[idx]));
		//}
		m_CentDedRessyaCont[Ressyahoukou_Kudari]->adjustBrunchLoopByLoopEdit(
			iEkiIndex,iPosition,
			iEkiIndexBrunchOriginSide, iEkiIndexLoop, iEkiIndexBrunchTerminalSide);
	//}

	deque<int> iEkiOrderBrunchOriginSide;
	deque<int> iEkiOrderLoop;
	deque<int> iEkiOrderBrunchTerminalSide;
	for (int idx = 0; idx < (int)iEkiIndexBrunchOriginSide.size(); idx++)
	{
		iEkiOrderBrunchTerminalSide.push_front(
			m_CentDedRessyaCont[Ressyahoukou_Nobori]->EkiOrderOfEkiIndex(
				iEkiIndexBrunchOriginSide[idx]));
	}
	for (int idx = 0; idx < (int)iEkiIndexLoop.size(); idx++)
	{
		iEkiOrderLoop.push_front(
			m_CentDedRessyaCont[Ressyahoukou_Nobori]->EkiOrderOfEkiIndex(
				iEkiIndexLoop[idx]));
	}
	for (int idx = 0; idx < (int)iEkiIndexBrunchTerminalSide.size(); idx++)
	{
		iEkiOrderBrunchOriginSide.push_front(
			m_CentDedRessyaCont[Ressyahoukou_Nobori]->EkiOrderOfEkiIndex(
				iEkiIndexBrunchTerminalSide[idx]));
	}
	m_CentDedRessyaCont[Ressyahoukou_Nobori]->adjustBrunchLoopByLoopEdit(
		m_CentDedRessyaCont[Ressyahoukou_Nobori]->EkiOrderOfEkiIndex(iEkiIndex),
		iEkiIndexLoop.size() - iPosition - 1,
		iEkiOrderBrunchOriginSide, iEkiOrderLoop, iEkiOrderBrunchTerminalSide);
}

void CentDedDia::adjustBrunchLoopEkiTrack2(
	const deque<int>& iEkiIndexBrunchLoop, 
	const std::vector<int>& iEkiTrack2Map)
{
	int iRessyahoukou = 0;
	for (iRessyahoukou = Ressyahoukou_Kudari;
		iRessyahoukou <= Ressyahoukou_Nobori; iRessyahoukou++) {
	deque<int> iEkiOrderBrunchLoop;
	for (int idx = 0; idx < (int)iEkiIndexBrunchLoop.size(); idx++)
	{
		iEkiOrderBrunchLoop.push_back(
			m_CentDedRessyaCont[iRessyahoukou]->EkiOrderOfEkiIndex(
				iEkiIndexBrunchLoop[idx]));
	}
	m_CentDedRessyaCont[iRessyahoukou]->adjustBrunchLoopEkiTrack2(
		iEkiOrderBrunchLoop,
		iEkiTrack2Map);
	}
}

void CentDedDia::adjustBrunchLoopOuterTerminal(
	const int iEkiIndex,
	const std::vector<int>& iOuterTerminalEkimeiMap)
{
	int iRessyahoukou = 0;
	for (iRessyahoukou = Ressyahoukou_Kudari;
		iRessyahoukou <= Ressyahoukou_Nobori; iRessyahoukou++) 
	{
		m_CentDedRessyaCont[iRessyahoukou]->adjustBrunchLoopOuterTerminal(
			m_CentDedRessyaCont[iRessyahoukou]->EkiOrderOfEkiIndex(iEkiIndex),
			iOuterTerminalEkimeiMap);
	}
}


} //namespace entDed
