/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CentDedDgrEkiJikoku.h
//	$Id: CentDedDgrEkijikoku.h 241 2016-01-05 06:14:33Z okm $
// ****************************************************************
*/
/** @file */
#ifndef CentDedDgrEkiJikoku_h
#define CentDedDgrEkiJikoku_h
#include "entDed\CentDedEkiJikoku.h"

namespace entDgr{
	using namespace entDed;
// ****************************************************************
//	CentDedDgrEkiJikoku
// ****************************************************************
/**
@brief 
  _COɂAԂ̊ewł̉w\܂B
  
  ̃NX́A CentDedDgrRessya ɏW񂳂܂B

  CentDedDgrRessya : CentDedDgrEkiJikoku ̑dx́A1 : w łB
*/
class CentDedDgrEkiJikoku
{
private:
	// ********************************
	///@name	
	// ********************************
	///@{
	/**
		wB
	 */
	CentDedEkiJikoku::EEkiatsukai	m_eEkiatsukai ;
	
	/**
		ɑΉ_COXWB
		̐E24:00:00 ȏ\Ƃ܂B

		AA INT_MIN NULL(wȂ)\܂B
	
		m_eEkiatsukai 
		^sȂ ( Ekiatsukai_None ),
		oRȂ ( Ekiatsukai_Keiyunasi ) ̏ꍇ́A
		̒l͈Ӗ܂B
	 */
	int m_iDgrXPosChaku ;
	
	/**
		ɑΉ_COXWB

		AA INT_MIN NULL(wȂ)\܂B
	
		m_eEkiatsukai 
		^sȂ ( Ekiatsukai_None ),
		oRȂ ( Ekiatsukai_Keiyunasi ) ̏ꍇ́A
		̒l͈Ӗ܂B
	 */
	int m_iDgrXPosHatsu ;
	
	
	/**
		_COԐXW

		̉w_COԐ̒ԂɂȂꍇ́A
		_COԐƁẢw(YWE)Ƃ̌_
		_COXWێ܂B
		łȂꍇ́AINT_MIN łB
		INT_MIN NULL(wȂ)\܂B

		̐E24:00:00 ȏ\Ƃ܂B
		
		
		̉w_COԐ̒[_ɂꍇA
		̒l NULL ɂȂ܂B

		m_eEkiatsukai 
		^sȂ ( Ekiatsukai_None ),
		oRȂ ( Ekiatsukai_Keiyunasi ) ̏ꍇ́A
		̒l͈Ӗ܂B
		
		(j
		
		Ow̉wԍŏvȉ̂Ƃ̘HƂ܂B

		@code
		-------------------
		wOrder0  
		wOrder1  01
		wOrder2  01
		-------------------
		@endcode

		Ɉȉ̂悤ȗԂݒ肳AԐwOrder0-wOrder2
		ݒ肳ꂽꍇA

		@code
		-------------------
		wOrder0  10:00
		wOrder1  10:01
		wOrder2  10:03
		-------------------
		@endcode

		wOrder1 m_iDgrXPosRessyasen ́A 10:01:30
		(10:00`10:03Ԓ wOrder1 ̌_)
		ɂȂ܂B
		
	 */
	int m_iDgrXPosRessyasen ;


	/**
		̉ẅʒuɗԏ(ԔԍEԖE)
		`悷KvȂ true B

		 false łA CentDedDgrRessya::readCentDedRessya() 
		ɂĐݒ肳܂B
	*/
	bool m_bShouldRessyajouhouDraw ;
	///@}
public:
	// ********************************
	//	RXgN^
	// ********************************
	CentDedDgrEkiJikoku() :
		m_eEkiatsukai( CentDedEkiJikoku::Ekiatsukai_None ),
		m_iDgrXPosChaku( INT_MIN ) ,
		m_iDgrXPosHatsu( INT_MIN ) ,
		m_iDgrXPosRessyasen( INT_MIN ) ,
		m_bShouldRessyajouhouDraw( false )
	{
	}
	
	CentDedDgrEkiJikoku( 
		CentDedEkiJikoku::EEkiatsukai eEkiatsukai , 
		int iDgrXPosChaku ,
		int iDgrXPosHatsu ,
		int iDgrXPosRessyasen = INT_MIN ) :
		m_eEkiatsukai( eEkiatsukai ),
		m_iDgrXPosChaku( iDgrXPosChaku ) ,
		m_iDgrXPosHatsu( iDgrXPosHatsu ) ,
		m_iDgrXPosRessyasen( iDgrXPosRessyasen ),
		m_bShouldRessyajouhouDraw( false )
	{
	}

public:
	// ********************************
	///@name CentDedDgrEkiJikoku-
	// ********************************
	///@{
	CentDedEkiJikoku::EEkiatsukai getEkiatsukai()const 
	{	return 	m_eEkiatsukai ;};
	
	/**
		 XW łB
	@param bHatsuIfNull [in]
		-	false ;	//	NULLȂ NULL(INT_MIX) Ԃ܂B
		-	true  ;	//	NULLȂ (INT_MIX) Ԃ܂B
	*/
	int getDgrXPosChaku( bool bHatsuIfNull = false )const
	{
		int iRv = m_iDgrXPosChaku ;
		if ( iRv == INT_MIN && bHatsuIfNull )
		{
			iRv = m_iDgrXPosHatsu ;
		}
		return iRv ;
	};
	void setDgrXPosChaku( int value )
	{	m_iDgrXPosChaku = value ;};

	/**
		 XW łB
	@param bChakuIfNull [in]
		-	false ;	//	NULLȂ NULL(INT_MIX) Ԃ܂B
		-	true  ;	//	NULLȂ (INT_MIX) Ԃ܂B
	*/
	int getDgrXPosHatsu( bool bChakuIfNull = false )const
	{
		int iRv = m_iDgrXPosHatsu ;
		if ( iRv == INT_MIN && bChakuIfNull )
		{
			iRv = m_iDgrXPosChaku ;
		}
		return iRv ;
	};
	void setDgrXPosHatsu( int value )
	{	m_iDgrXPosHatsu = value ;};

	int getDgrXPosRessyasen()const
	{	return m_iDgrXPosRessyasen ;};
	void setDgrXPosRessyasen( int value )
	{	m_iDgrXPosRessyasen = value ; };

	bool getShouldRessyajouhouDraw()const
	{	return m_bShouldRessyajouhouDraw ;};
	void setShouldRessyajouhouDraw( bool value )
	{	m_bShouldRessyajouhouDraw = value ;};

	///@}
	// ********************************
	///@name CentDedDgrEkiJikoku-
	// ********************************
	///@{
	/**
		ׂẮw_COwxIuWFNg
		w_COGeBeBXWxZEZ܂(NULL INT_MIN ͏B
	 @param iSeconds [in]
		ZEZlibEw_COGeBeBXWxj	
		w肵ĉB
	 */
	virtual void modifyDgrXPos( int iSeconds ) 
	{
		if ( m_iDgrXPosChaku != INT_MIN )
		{
			m_iDgrXPosChaku += iSeconds ;
		}
		if ( m_iDgrXPosHatsu != INT_MIN )
		{
			m_iDgrXPosHatsu += iSeconds ;
		}
		if ( m_iDgrXPosRessyasen != INT_MIN )
		{
			m_iDgrXPosRessyasen += iSeconds ;
		}
	}
	///@}
};


} //namespace entDgr

#endif /*CentDedDgrEkiJikoku_h*/


