/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CdPenProp.h
// ****************************************************************
*/
/** @file */
#ifndef  CdPenProp_h
#define  CdPenProp_h
#include "CdColorProp.h"

namespace DcDrawLib{
namespace DcdCd{
namespace DcDrawProp{

// ****************************************************************
//	CdPenProp
// ****************************************************************
/**
 * @brief
 * yTvz
 *	   y̑ێPf[^NXłB
 *
 *	   CConverter_WinGdi NXgpƁALOGPEN\̂Ƃ̊Ԃőݕϊ
 *	ł܂B
 */
class CdPenProp
{
// ********************************
///@name Ci[^Cv
// ********************************
///@{
 public:
	enum EStyle
	{
		/**	
		 *	̃y	
		 */
		SOLID ,	
		/** 
		 *	j̃yB
		 *	̑w肳ƁAy̕͘_PʂłPɌ肳A
		 *	m_iWidth ͖ɂȂ܂
		 */
		DASH ,
		/**
		 *	 _̃yB
		 *	̑w肳ƁAy̕͘_PʂłPɌ肳A
		 *	m_iWidth ͖ɂȂ܂
		 */
		DOT ,
		/** 
		 *	_̃yB
		 *	̑w肳ƁAy̕͘_PʂłPɌ肳A
		 *	m_iWidth ͖ɂȂ܂
		 */
		DASHDOT ,
		/** 
		 *	_̃yB
		 *	̑w肳ƁAy̕͘_PʂłPɌ肳A
		 *	m_iWidth ͖ɂȂ܂
		 */
		DASHDOTDOT ,
		/**
		 *	 k̃yB
		 *	`悵܂
		 */
		NULLPEN ,
		/**	
		 *	Oڂ鋫Elp`w肷 GDI ֐ (EllipseARectangleA
		 *	RoundRectAPieAChord o֐Ȃ) ɂ쐬}`
		 *	gɒ`悷邽߂̃yB`͎ł	
		 */
		SOLID_INSIDEFRAME ,	
	};
///@}
// ********************************
///@name	
// ********************************
///@{
 private:
	/** 
	 *	̑^ȂAy̑̓foCXPʂŖɂPɂȂ܂ 
	 *
	 *	ftHgł͋Uł
	 */
	bool		m_bIsDevicewidth1 ;
	
	/** 
	 *	_Pʂő\ł B
	 *
	 *	m_bIsDevicewidth1 ^̏ꍇA̒l͋IɂOƂȂ܂B
	 *	
	 *	m_bIsDevicewidth1 UŁAm_eStyle  SOLID  SOLID_INSIDEFRAME 
	 *	ǂłȂꍇ́A̒l͋IɂPƂȂ܂B
	 *	
	 *	m_bIsDevicewidth1 UŁAm_eStyle  SOLID  SOLID_INSIDEFRAME 
	 *	ꍇɂ́A̒l͂Pȏ̔Cӂ̒lɂȂ܂B
	 *
	 *	ftHgł1łB
	 */
	int			m_iLogicalunitWidth ;
	
	/**
	 *	y̐FłB
	 *
	 *	ftHg͍ł
	 */
	CdColorProp	m_colorrefColor ;

	/**	
	 *	`B
	 *
	 *	ftHg NULLPEN łB
	 */
	EStyle	m_eStyle	;
///@}	
// ********************************
//	RXgN^
// ********************************
 public:
	/** 
	 *	_PʂŎw肷yw肵܂B
	 * @param iLogicalunitWidth [in]
	 *	_Pʂő\ł 
	 *	m_bIsDevicewidth1 ^̏ꍇA̒l͋IɂOƂȂ܂B
	 *	m_bIsDevicewidth1 UŁAm_eStyle  SOLID  SOLID_INSIDEFRAME 
	 *	ǂłȂꍇ́A̒l͋IɂPƂȂ܂B
	 *	m_bIsDevicewidth1 UŁAm_eStyle  SOLID  SOLID_INSIDEFRAME 
	 *	ꍇɂ́A̒l͂Pȏ̔Cӂ̒lɂȂ܂B
	 * @param aColorref [in]
	 *	y̐Fł
	 * @param eStyle [in]
	 *	y̌`w肵ĂB
	 */
	CdPenProp( int iLogicalunitWidth , 
				CdColorProp aColorref = CdColorProp( 0 , 0 , 0 ) , 
				EStyle eStyle = SOLID ) :
		m_bIsDevicewidth1( false ) ,
		m_iLogicalunitWidth( iLogicalunitWidth ) , 
		m_colorrefColor( aColorref ) ,
		m_eStyle( eStyle ) 
		{};
	
	/** 
	 *	ftHgRXgN^BNULLPEN ɏ܂B
	 *		- 
	 *		- ͘_PʂłP
	 *		- F͍
	 *
	 *	`܂B
	 */
	CdPenProp() : 
		m_bIsDevicewidth1( false ) ,
		m_iLogicalunitWidth( 1 ) , 
		m_colorrefColor( CdColorProp( 0 , 0 , 0 ) ) ,
		m_eStyle( NULLPEN ) 
		{};
	
	
// ********************************
//	CdPenProp
// ********************************
 public:
	// ********************************
	///@name	
	// ********************************
	///@{
	bool isDevicewidth1()const{	return m_bIsDevicewidth1 ; } ;
	CdPenProp& setIsDevicewidth1( bool ev ){
		m_bIsDevicewidth1 = ev ; return *this ;} ;
	
	/** 
	 *	Ԃ܂B
	 * @return
	 *	- ɃfoCXPʂPł΁AO
	 *	- NULLPEN ȂAO
	 *	- łȂꍇ́AP
	 *	- łȂꍇ́A_Pʂł̑
	 */
	int getLogicalunitWidth()const{
		if ( m_bIsDevicewidth1 ){	return ( 0 ) ; } ;

		if ( m_eStyle == NULLPEN ){
			return ( 0 ) ; 
		}
		if ( !( m_eStyle == SOLID || m_eStyle == SOLID_INSIDEFRAME ) ){
			return ( 1 ) ; 
		}

		if ( m_iLogicalunitWidth < 1 ){
			return ( 1 ) ;
		}
		return ( m_iLogicalunitWidth ) ;
	};
	/** 
	 *	_PʂŐݒ肵܂B
	 *	A m_eStyle  SOLID , ܂ SOLID_INSIDEFRAME ȊO
	 *	ꍇA܂ m_bIsDevicewidth1 ^̏ꍇ́A
	 *	̃o֐Ŏw肵l͌ʂ܂B
	 */
	CdPenProp& setLogicalunitWidth( int ev ){
		m_iLogicalunitWidth = ev ;
		return *this ;
	};
	
	CdColorProp getColor()const{	return m_colorrefColor ; } ;
	CdPenProp& setColor( CdColorProp ev ){
		m_colorrefColor = ev ;	return *this ; } ;
	
	EStyle getStyle()const{	return m_eStyle ; } ;
	CdPenProp& setStyle( EStyle ev ){
		m_eStyle = ev ;	return *this ; } ;
	
	/**
	 *	2̃IuWFNg̊eǂ𔻒肵܂B
	 * @param value [in]
	 *	ȓΏۂƂȂIuWFNgw肵ĂB
	 * @return 
	 *	value  *this Ƃ̊ԂŁAׂĂ̑ΐ^łB
	 */
	bool isEqualTo( const CdPenProp& value )const{
		return ( 
			m_bIsDevicewidth1 == value.m_bIsDevicewidth1 &&
			m_iLogicalunitWidth == value.m_iLogicalunitWidth &&
			m_colorrefColor == value.m_colorrefColor &&
			m_eStyle == value.m_eStyle )	;
	};
	/**
	 *	isEqualTo() ƓłB
	 */
	bool operator==( const CdPenProp& value )const{
		return ( isEqualTo( value ) ) ;
	};
	bool operator!=( const CdPenProp& value )const{
		return ( !isEqualTo( value ) ) ;
	};

	/**
	 *	this  b 
	 *	iOɂȂjȂ^łB
	 * @param b [in]
	 *	ȓΏۂƂȂIuWFNgw肵ĂB
	 * @return 
	 *	this  b 
	 *	iOɂȂjȂ^łB
	 */
	bool  less( const CdPenProp& value)const{
		if ( m_bIsDevicewidth1 != value.m_bIsDevicewidth1 ){
			return ( m_bIsDevicewidth1 < value.m_bIsDevicewidth1 ) ;
		}	else if ( m_iLogicalunitWidth != value.m_iLogicalunitWidth ){
			return ( m_iLogicalunitWidth < value.m_iLogicalunitWidth ) ;
		}	else if ( m_colorrefColor != value.m_colorrefColor ){
			return ( m_colorrefColor < value.m_colorrefColor ) ;
		}	else if ( m_eStyle != value.m_eStyle ){
			return ( m_eStyle < value.m_eStyle ) ;
		}
		return ( false ) ;
	};
	/**
	 *	less() ƓłB
	 */
	bool operator<( const CdPenProp& b )const{
		return less( b );
	};
	///@}
	
};

} //namespace DcDrawProp
} //namespace DcdCd
} //namespace DcDrawLib

#endif /*CdPenProp_h*/
