/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	Ou.h
// ****************************************************************
*/
/** @file */
#ifndef  Ou_h
#define  Ou_h
#include "NsOu\OuBase.h"
#include "NsOu\OuHolder.h"

namespace OuLib{

#ifndef NO_NSOU
namespace NsOu{
#endif//NO_NSOU

// ****************************************************************
//	Ou< TargetType >
// ****************************************************************
/**
@brief
  	  TargetType ^̃IuWFNgQƂ
	X}[g|C^łB

@ref page_oumodel 

 
 */
template< class TargetType1 > 
class Ou : public OuBase
{
// ********************************
//	NX`
// ********************************
 public:
	typedef OuBase	super ;
	typedef TargetType1 TargetType ;


// ********************************
///@name ֘A
// ********************************
///@{
 private:
	/**
	 	^[QbgIuWFNgւ̃|C^łB
	 	RXgN^EZqŌ肵܂B
	 */
	TargetType*		m_pTarget ;

///@}
// ********************************
//	RXgN^EfXgN^
// ********************************
 public:
	/**
	 	  ftHgRXgN^łB
	 	  ^[QbgIuWFNgNULLƂȂ܂B
	 */
	Ou() : 
		m_pTarget( NULL ) 
	{
	};
	/**
	 	  V^[QbgIuWFNgQƂƂ̃RXgN^łB
	 	  new Ő OuHolderIuWFNgo^܂B
	 @param pHolder [in]
	 	V^[QbgIuWFNgێĂA OuHolder IuWFNg
	 	w肵ĂB
	 */
	template< class TargetTypeSrc >
	Ou( OuHolder<TargetTypeSrc>* pHolder ) 
		: super( pHolder ) 
	{
		m_pTarget = static_cast<TargetType*>( pHolder->getTarget() ) ;
	};
	
	
	/**
	 	ϊRXgN^
	 	 Ou IuWFNgi܂́AOu̔hNX̃IuWFNgj
	 	QƂĂ^[QbgIuWFNgQƂ܂B
	 @param ev [in]
	 	 Ou  IuWFNgw肵ĂB
	 */
	template< class TargetTypeSrc >
	Ou( Ou<TargetTypeSrc>& ev )
		: super( ev ) 
	{
		m_pTarget = static_cast<TargetType*>( ev.getTarget() ) ;
	};
	
	/**
		ZqłB
		 Ou IuWFNgi܂́AOu̔hNX̃IuWFNgj
		QƂĂ^[QbgIuWFNgQƂ܂B
		̂ƂA܂ł Ou IuWFNgQƂĂ^[Qbg
		IuWFNgɑ΂ẮAQƃJE^炵AKvȂ폜s܂B
	@param ev [in]
		 Ou  IuWFNgw肵ĂB
	*/
	template< class TargetTypeSrc >
	Ou& operator=( Ou<TargetTypeSrc>& ev ) 
	{
		super::operator=( ev ) ;
		m_pTarget = static_cast<TargetType*>( ev.getTarget() ) ;
		
		return ( *this ) ;
	};


	/**
		Rs[RXgN^
		 Ou IuWFNgi܂́AOu̔hNX̃IuWFNgj
		QƂĂ^[QbgIuWFNgQƂ܂B
	@param ev [in]
		 Ou  IuWFNgw肵ĂB
	*/
	Ou( const Ou& ev )
		: super( ev ) 
	{
		m_pTarget = ev.m_pTarget   ;
	};
	
	/**
		ZqłB
		 Ou IuWFNgi܂́AOu̔hNX̃IuWFNgj
		QƂĂ^[QbgIuWFNgQƂ܂B
		̂ƂA܂ł Ou IuWFNgQƂĂ^[Qbg
		IuWFNgɑ΂ẮAQƃJE^炵AKvȂ폜s܂B
	@param ev [in]
		 Ou  IuWFNgw肵ĂB
	 */
	Ou& operator=( const Ou& ev ) 
	{
		super::operator=( ev ) ;
		m_pTarget = ev.m_pTarget ;
		
		return ( *this ) ;
	};

	//	fXgN^
	virtual ~Ou()
	{
	};

// ********************************
//	"Ou< TargetType >"
// ********************************
 public:
	// ********************************
	///@name "Ou< TargetType >"-֘A
	// ********************************
	///@{
	TargetType* getTarget(){	return ( m_pTarget ) ; 	} ;
	const TargetType* getTarget()const{	return ( m_pTarget ) ; 	} ;
	///@}
	// ********************************
	///@name "Ou< TargetType >"-Zq
	// ********************************
	///@{

	/**
		  ^[QbgIuWFNgւ̃LXgZqłB
		  ɂAOuIuWFNg𕁒ʂ̃|C^̑
		֐̈ƂēnƂł܂B
	*/
	operator  TargetType*(){	return ( getTarget() ) ; } ;
	operator  const TargetType*()const{	return ( getTarget() ) ; } ;
	
	/**
		  "->"Zq
		^[QbgIuWFNg̃|C^Ԃ܂B
		  ɂAOuIuWFNg "->" āA^[QbgIuWFNg
		oɃANZXł܂B
	*/
	TargetType* operator->(){	return ( getTarget() ) ; } ;
	const TargetType* operator->()const{	return ( getTarget() ) ; } ;
	
	/**
		  "*"Zq
		  ɂA Ou IuWFNg "*" āA^[QbgIuWFNg
		̎̂\Ƃł܂B
	*/
	TargetType& operator*(){	return ( *getTarget() ) ; } ;
	const TargetType& operator*()const{	return ( *getTarget() ) ; } ;
	
	/**
		  rZq
		  ^[QbgIuWFNg̃|C^ƁAʏ̃|C^̔r
		s܂B
		  rΏۂɂ NULL w肷邱Ƃł܂B
	@param ev [in]
		rΏۂ̃|C^w肵ĂB
	@return
		- (operator==)ΏۂƂȂIuWFNg̃|C^łΐ^ł
		- (operator!=)ΏۂƂȂIuWFNg̃|C^قȂΐ^ł
	*/
	bool operator==( TargetType* ev )const
	{
		return ( m_pTarget == ev ) ;
	};	
	/**
		@see operator==( TargetType* ev ) QƂĂB
	*/
	bool operator!=( TargetType* ev )const
	{
		return ( m_pTarget != ev ) ;
	};	

	/**
		  rZq
		  this ƁAwOuIuWFNgƂ̊ԂŁA^[QbgIuWFNg
		|C^̔rs܂B
	@param ev [in]
		rΏۂ Ou IuWFNgw肵ĂB
	@return
		- (operator==)ΏۂƂȂIuWFNg̃|C^łΐ^ł
		- (operator!=)ΏۂƂȂIuWFNg̃|C^قȂΐ^ł
	*/
	template< class TargetTypeSrc >
	bool operator==( Ou<TargetTypeSrc>& ev )const
	{
		return ( m_pTarget == ev.getTarget() ) ;
	};	
	/**
		@see operator!=() QƂĂB
	*/
	template< class TargetTypeSrc >
	bool operator!=( Ou<TargetTypeSrc>& ev )const
	{
		return ( m_pTarget != ev.getTarget() ) ;
	};	

	///@}
	// ********************************
	///@name "Ou< TargetType >"-
	// ********************************
	///@{
	/**
	@return
		^[QbgIuWFNgNULLȂA^Ԃ܂B
	*/
	virtual bool isNull() const
	{
		return ( m_pTarget == NULL ) ;
	};

	/**
		 Ou IuWFNg
		^[QbgIuWFNgɑ΂QƂ𒆎~A
		Ԃɖ߂܂B
	*/
	virtual void clear() 
	{
		super::clear() ;
		m_pTarget = NULL ;
	};
	///@}

};

#ifndef NO_NSOU
} //namespace NsOu
#endif//NO_NSOU

} //namespace OuLib


#endif /*Ou_h*/
