/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
// ****************************************************************
//	$Id: CConvCsvDocument.cpp 285 2016-06-05 08:10:51Z okm $
// ****************************************************************
/** @file */
#include "CConvCsvDocument.h"
#include <tchar.h>

namespace OuLib{
namespace Str{
namespace CsvDocument{

using std::string ;


// ****************************************************************
//	CCsvDecoder
// ****************************************************************
/**
@brief
	CSVt@C̓e߂ CdCsvDocument IuWFNg
	\ۂ̏ԋ@BłB

ygz

1.  CX^X𐶐ĂB

2.  CSVt@C̓e addChar() \bhŉ߂ĂB

3.  CSVt@C̓eׂ addChar() ɓńA addEof() 
ĂяoĂB
@̏Ԃ CdCsvDocument ̍\I܂BgetCdCsvDocument() 
 \hLg擾邱Ƃł܂B

4.  VCSVt@C߂ꍇ́A
@VCX^X𐶐ȂĂ͂Ȃ܂B
*/
class CCsvDecoder
{
public:
	// ********************************
	///@name Ci[^Cv
	// ********************************
	///@{
	enum EState
	{
		/**
			p̊O
		*/
		EState_OuterQuote ,
		/**
			p̓
		*/
		EState_InnerQuote ,
		/**
			p̓́A1ڂ̈p̒
		*/
		EState_QuoteInnerQuote ,
	};
	///@}
private:
	// ********************************
	///@name  
	// ********************************
	///@{
	/**
		݂̏
	*/
	EState m_EState ;
	/**
		ݍ\̃hLg
	*/
	CdCsvDocument	m_CdCsvDocument ;
	/**
		ݍ\̍s
	*/
	CdCsvRow	m_CdCsvRow ;
	/**
		ݍ\̃Z̕
	*/
	tstring	m_strCellData ;
	///@}
private:
	// --------------------------------
	///@name addChar() ̉֐
	// --------------------------------
	///@{
	void addChar_EState_OuterQuote(TCHAR ch ) ;
	void addChar_EState_InnerQuote(TCHAR ch ) ;
	void addChar_EState_QuoteInnerQuote(TCHAR ch ) ;
	///@}
public:
	// ********************************
	//	RXgN^
	// ********************************
	CCsvDecoder()
		: m_EState( EState_OuterQuote ) 
	{
	};
	// ********************************
	///@name  
	// ********************************
	///@{
	CdCsvDocument	getCdCsvDocument()
	{	return m_CdCsvDocument ;};
	///@}
	// ********************************
	///@name 
	// ********************************
	///@{
	/**
		CSVt@C̓e߂܂B
	@param ch [in]
		t@C̓ẽLN^w肵ĂB
	*/
	void addChar(TCHAR ch ) ;
	/**
		CSVt@C̉߂I܂B
	@return
		-	0 ;	//	
		-	-1 ;	//	pĂ܂
	//	
	*/
	int addEof() ;
	///@}
};
void CCsvDecoder::addChar_EState_OuterQuote(TCHAR ch )
{
			if ( ch == '\n' )
			{
				if ( m_strCellData.size() > 0 
						|| m_CdCsvRow.getCellCont()->size() )
				{
					m_CdCsvRow.getCellCont()->insert( CdCsvCell( m_strCellData ) , INT_MAX ) ;
					m_strCellData.erase() ;
				}
				{
					m_CdCsvDocument.getRowCont()->insert( m_CdCsvRow ) ;
					m_CdCsvRow.getCellCont()->erase( 0 , INT_MAX ) ;

				}

			}
			else if ( ch == ',' )
			{
				{
					m_CdCsvRow.getCellCont()->insert( CdCsvCell( m_strCellData ) , INT_MAX ) ;
					m_strCellData.erase() ;
				}
			}
			else if ( ch == '\"' )
			{
				m_EState = EState_InnerQuote ;
			}
			else
			{
				m_strCellData += ch ;
			}
}
void CCsvDecoder::addChar_EState_InnerQuote(TCHAR ch )
{
			if ( ch == '\n' )
			{
				m_strCellData += ch ;
			}
			else if ( ch == ',' )
			{
				m_strCellData += ch ;
			}
			else if ( ch == '\"' )
			{
				m_EState = EState_QuoteInnerQuote ;
			}
			else
			{
				m_strCellData += ch ;
			}
}
void CCsvDecoder::addChar_EState_QuoteInnerQuote(TCHAR ch )
{
			if ( ch == '\n' )
			{
				m_EState = EState_OuterQuote ;
				addChar_EState_OuterQuote( ch ) ; 
			}
			else if ( ch == ',' )
			{
				m_EState = EState_OuterQuote ;
				addChar_EState_OuterQuote( ch ) ; 
			}
			else if ( ch == '\"' )
			{
				m_strCellData += ch ;
				m_EState = EState_InnerQuote ;
			}
			else
			{
				m_EState = EState_OuterQuote ;
				addChar_EState_OuterQuote( ch ) ; 
			}
}

void CCsvDecoder::addChar(TCHAR ch )
{
	switch( m_EState )
	{
	case EState_OuterQuote :
		//	p̊O
		{
			addChar_EState_OuterQuote( ch ) ;
		}
		break ;
	case EState_InnerQuote :
		//	p̓
		{
			addChar_EState_InnerQuote( ch ) ;
		}
		break ;
	case EState_QuoteInnerQuote :
		//	p̓́A1ڂ̈p̒
		{
			addChar_EState_QuoteInnerQuote( ch ) ;
		}
		break ;
	}
}
int CCsvDecoder::addEof() 
{
	int iRv = 0 ;
	switch( m_EState )
	{
	case EState_OuterQuote :
	case EState_QuoteInnerQuote :
		//	p̓́A1ڂ̈p̒
		{
			if ( m_strCellData.size() > 0 
						|| m_CdCsvRow.getCellCont()->size() )
			{
				m_CdCsvRow.getCellCont()->insert( CdCsvCell( m_strCellData ) , INT_MAX ) ;
				m_strCellData.erase() ;
			}
			if ( m_CdCsvRow.getCellCont()->size() > 0 
					|| m_CdCsvRow.getCellCont()->size() > 0 )
			{
				m_CdCsvDocument.getRowCont()->insert( m_CdCsvRow ) ;
				m_CdCsvRow.getCellCont()->erase( 0 , INT_MAX ) ;

			}
		}
		break ;
	case EState_InnerQuote :
		//	p̓
		{
			iRv = -1 ;	//	pĂ܂
		}
		break ;
	}

	return iRv ;
}

// ****************************************************************
	// --------------------------------
	//@name ֐
	// --------------------------------
tstring CConvCsvDocument::encodeCell( const CdCsvCell& aCdCsvCell ) 
{
	tstring strCell = aCdCsvCell.getData() ;
	tstring strRv ;

	bool bMustQuote = false ;
	for ( int idx = 0 ; idx < (int)strCell.size() ; idx ++ )
	{
		if ( strCell[idx] == '\n' )
		{
			bMustQuote = true ;
			strRv += strCell[idx] ;
		}
		else if ( strCell[idx] == '\"' )
		{
			bMustQuote = true ;
			strRv += _T("\"\"") ;
		}
		else
		{
			strRv += strCell[idx] ;
		}
	}
	if ( bMustQuote )
	{
		strRv = tstring(_T("\"") ) + strRv + _T("\"") ;
	}

	return strRv ;
}
	// ********************************
	//	RXgN^
	// ********************************
CConvCsvDocument::CConvCsvDocument(void)
{
}

CConvCsvDocument::~CConvCsvDocument(void)
{
}
	// ********************************
	//@name	CConvCsvDocument
	// ********************************
tstring CConvCsvDocument::encode( const CdCsvDocument* pCdCsvDocument ) 
{
	tstring strRv ;

	const Mu< const CdCsvRow& >* pRowCont = pCdCsvDocument->getRowCont() ;
	for ( int idxRow = 0 ; 
			idxRow < pRowCont->size() ;
			idxRow ++ )
	{
		CdCsvRow	aCdCsvRow = pRowCont->get( idxRow ) ;


		tstring strRow ;
		const Mu< CdCsvCell >* pCellCont = aCdCsvRow.getCellCont() ;
		for ( int idxCell = 0 ; idxCell < pCellCont->size() ; idxCell ++ )
		{
			if ( idxCell > 0 )
			{
				strRow += ',' ;
			}

			tstring strCell ;
			CdCsvCell	aCdCsvCell = pCellCont->get( idxCell ) ;
			strCell = encodeCell( aCdCsvCell ) ;

			strRow += strCell ;
		}

		strRv += strRow ;
		strRv += '\n' ;
	}
	return strRv ;
}
int CConvCsvDocument::decode( CdCsvDocument* pCdCsvDocument 
		, const tstring& strCsvText ) 
{
	int iRv = 0 ;
	if ( iRv >= 0 )
	{
		CCsvDecoder	aCCsvDecoder ;
		for ( int idxChar = 0 ; idxChar < (int)strCsvText.size() ; idxChar ++ )
		{
			aCCsvDecoder.addChar( strCsvText[idxChar] ) ;
		}
		int iResult = aCCsvDecoder.addEof() ;
		//-	-1 ;	//	pĂ܂
		if ( iResult < 0 )
		{
			iRv = iResult ;
		}
		else
		{
			*pCdCsvDocument = aCCsvDecoder.getCdCsvDocument() ;
		}
	}
	return iRv ;
}


} //namespace CsvDocument{
} //namespace Str{
} //namespace OuLib{

