/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
// ****************************************************************
// $Id: COuErrorInfo.h 63 2012-09-01 08:54:26Z okm $
// ****************************************************************
/** @file */
#ifndef  OuLib_str_OuPropertiesText_ErrorInfo_COuErrorInfo_h
#define  OuLib_str_OuPropertiesText_ErrorInfo_COuErrorInfo_h

#include "str\OuPropertiesText\CDirectory.h"
#include <string>
#include "str\tstring.h"
#include <tchar.h>
namespace OuLib{
namespace Str{
namespace OuPropertiesText{
namespace ErrorInfo{

/**
@brief
  OuErrorInfo ́AG[̏ڍ׏ێPf[^`łB

  ̃NX́AƂ

  - Reason - G[̓e
  - Prop  - G[̕⑫ OuPropertiesText 
  
܂BAAProp ̓IvVȂ̂ŁAsvłΎgȂĂ܂܂

  Reason ɂ͌ƂāAsE^u͊܂܂Ȃ̂Ƃ܂iOuErrorInfoText̕ϊłȂȂ邽߁j

  this ́ANull(G[ێĂȂ)Ƃ邱Ƃł܂B
  ̏ꍇA Reason 󕶎EProp.size()  0 ƂȂ܂B
 
<H4>
yOuPropertiesTextErrorInfoz
</H4>

  OuPropertiesTextErrorInfo ́AOuErrorInfo ̓e
  OuPropertiesText x[XtH[}bgƂĕ\f[^`łB

  @see COuErrorInfoContainer


()
@code
ErrorInfo.
Reason=File Not Found.
Prop.
FileName=source.txt
Server.
Host=FtpServer
Username=FtpUser
.
.
.
@endcode

<H4>
yOuErrorInfoTextz
</H4>

  OuErrorInfo ̓e\eLXgłBUIւ̕\z肵Ă܂B

  @see COuErrorInfoContainer

()
@code
File Not Found.	FileName=source.txt
@endcode

*/
class COuErrorInfo
{
private:
	// ********************************
	///@name 
	// ********************************
	///@{
	/**
		"Reason" PropertyText B
		G[̌\܂B́̕A
		ppƂ܂B
		^uEs܂ނƂ͂ł܂
		(AÃNXł̓^uEs̃`FbN͍s܂)
	*/
	tstring m_strReason ;
	/**
		G[̕⑫ OuPropertiesText 
	*/
	CNodeContainer	m_Prop ;
	///@}
public:
	// ********************************
	///@name 萔
	// ********************************
	///@{
	static const TCHAR* const DirectoryName_ErrorInfo ;
	static const TCHAR* const PropertyTextName_Reason ;
	static const TCHAR* const DirectoryName_Prop ;
	///@}
	
public:
	COuErrorInfo()
	{
	};
	COuErrorInfo( const tstring& strReason ) :
		m_strReason( strReason )
	{
	};
	COuErrorInfo( 
		const tstring& strReason , 
		const CNodeContainer& Prop ) :
		m_strReason( strReason ) ,
		m_Prop( Prop ) 
	{
	}
public:
	// ********************************
	///@name 
	// ********************************
	///@{
	tstring getReason()const{	return m_strReason ;};
	void setReason( const tstring& value )
	{	m_strReason = value ;};
	CNodeContainer*	getProp(){	return &m_Prop ;};
	const CNodeContainer*	getProp()const{	return &m_Prop ;};
	///@}
	// ********************************
	///@name 
	// ********************************
	///@{
	/**
	@return
		̃Rei̓e OuPropertiesTextErrorInfo ɕϊA
		i[ "ErrorInfo" Directory Ԃ܂B
		
	*/
	Ou<CDirectory> toOuPropertiesTextErrorInfo()const;

	/**
		OuPropertiesTextErrorInfo ێĂ
		"ErrorInfo" Directory ̓eAthis ɔf܂B
	@param pCNode [in]
		"pCDirectory" Directory ێĂ
		CDirectory ̓ew肵ĂB
	@return
		 0 ȏAG[Ȃ畉̐łB
		-	-1 ;	//	pCDirectory  "Directory" ł͂܂B
		-	-2 ;	//	Directory "Reason" PropertyText ܂B
	*/
	int fromOuPropertiesTextErrorInfo( 
		Ou<const CDirectory> pCDirectory );

	/**	
	@return
		wOuErrorInfoTextx𐶐ĕԂ܂B
	*/
	tstring toOuErrorInfoText()const ;

	/**	
		wOuErrorInfoTextx߂ÃNX̑ɔf܂B
		̃NX܂ŕێĂf[^͔j܂B
	@param strOuErrorInfoText [in]
		wOuErrorInfoTextxw肵܂B
	@return 
		 0 ȏAG[Ȃ畉̐łB
	
	@note
		strOuErrorInfoText 󕶎̏ꍇ́AG[ɂ͂Ȃ炸
		SĂ̑NAԂɂȂ܂B
	*/
	int fromOuErrorInfoText( const tstring& strOuErrorInfoText );
	/**	
		this  Null Ԃɂ܂B
	*/
	void clear() ;

	/**	
	@return
		this  Null ԂȂ  true łB
	*/
	bool isNull()const ;
	///@}
};


} //namespace ErrorInfo{
} //namespace OuPropertiesText{
} //namespace Str{
} //namespace OuLib{

#endif //OuLib_str_OuPropertiesText_ErrorInfo_COuErrorInfo_h
