/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CHidemdiApp.cpp
// ****************************************************************
*/

#include <afxadv.h>
#include "CHidemdiApp.h"

namespace OuMfc{
namespace Hidemdi{


// ****************************************************************
//	CHidemdiApp
// ****************************************************************
//--------------------------------
//	֐
//--------------------------------
BOOL CHidemdiApp::RegisterRootDoctmpl
						( CHidemdiRootDoctmpl* prootdoctemplateEv ) 
		//[Attention]
		//	InitInstance() Doctemplate𐶐ƂɁA
		//	[gDoctemplateIuWFNg̃|C^Ã\bh
		//	o^ĂB
{
	m_pdoctemplateRoot = prootdoctemplateEv ;
	return ( TRUE ) ;
}


CHidemdiRootDoctmpl*	CHidemdiApp::pRootDoctmpl() 
		//	[gDoc/View̃ev[gւ
		//	|C^Ԃ܂
{
	return ( m_pdoctemplateRoot ) ;
}

CHidemdiRootDoc* CHidemdiApp::pRootDoc() 
		//	[gDocւ̃|C^Ԃ܂
{
	CDocument*	pRv = NULL ;
	if ( m_pdoctemplateRoot != NULL ){
		POSITION	LPosition = m_pdoctemplateRoot->GetFirstDocPosition() ;
		while( LPosition != NULL ){
			pRv = m_pdoctemplateRoot->GetNextDoc( LPosition ) ;
		}
	}
	//ASSERT( pRv != NULL ) ;
	return ( (CHidemdiRootDoc*)pRv ) ;
}

int CHidemdiApp::RemoveFromRecentFileList( LPCTSTR lpszEFilename ) 
		//	t@CAMRUXg폜܂
		//lpszEFilename
		//	폜t@CԂ܂
		//[r]
		//	폜Gg̐Ԃ܂
{
	int	iRv = 0 ;
	if ( m_pRecentFileList != NULL ){
		int	iLIdx ;
		for ( iLIdx = 0 ; iLIdx < m_pRecentFileList->GetSize() ; iLIdx ++ ){
			if ( (*m_pRecentFileList)[iLIdx] == lpszEFilename ){
				m_pRecentFileList->Remove( iLIdx ) ;
				iLIdx -- ;
				iRv ++ ;
			}
		}
	}
	return ( iRv ) ;
}

//----------------------------------------------------------------
//	MFC
//----------------------------------------------------------------

BEGIN_MESSAGE_MAP(CHidemdiApp, CHidemdiApp::super)
	//{{AFX_MSG_MAP(CHidemdiApp)
	ON_COMMAND(ID_FILE_NEW, OnFileNew)
	ON_COMMAND(ID_FILE_SAVE, OnFileSave)
	ON_COMMAND(ID_FILE_SAVE_AS, OnFileSaveAs)
	ON_UPDATE_COMMAND_UI(ID_FILE_SAVE, OnUpdateFileSave)
	ON_UPDATE_COMMAND_UI(ID_FILE_SAVE_AS, OnUpdateFileSaveAs)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()



CHidemdiApp::CHidemdiApp()
{
	m_pdoctemplateRoot = NULL ;
		//[Attention]
		//	InitInstance() CDocTemplateo^ƂɁA
		//	[gDoc/View̃ev[gւ
		//	|C^ێĂB
}

BOOL CHidemdiApp::InitInstance()
{
	return ( TRUE ) ;
}


void CHidemdiApp::OnFileNew() 
{
	m_pdoctemplateRoot->OpenDocumentFile( NULL ) ;
}

void CHidemdiApp::OnFileSave() 
{
	CHidemdiRootDoc*	pLRootDoc = pRootDoc() ;
	if ( pLRootDoc != NULL ){
		pLRootDoc->OnCmdMsg( ID_FILE_SAVE , 0 , NULL , NULL ) ;
	}
	
}

void CHidemdiApp::OnFileSaveAs() 
{
	CHidemdiRootDoc*	pLRootDoc = pRootDoc() ;
	if ( pLRootDoc != NULL ){
		pLRootDoc->OnCmdMsg( ID_FILE_SAVE_AS , 0 , NULL , NULL ) ;
	}
			//[Attention]
			//	R}hnh𑼂̃R}h^[Qbg
			//	Ϗꍇ́AϏIuWFNgɑ΂āA
			//	CCmdTarget::OnCmdMsg() ĂяoĂB
			//
			//virtual BOOL CCmdTarget::OnCmdMsg( UINT nID
			//	, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo );
			//[r]
			//bZ[WꂽƂ 0 ȊOԂ܂BȊO 0 
			//	Ԃ܂B
			//nID
			//   R}h ID w肵ĂB
			//nCode
			//	0w肵ĂB
			//pExtra
			//	NULLw肵ĂB
			//pHandlerInfo 
			//	NULLw肵ĂB
}

void CHidemdiApp::OnUpdateFileSave(CCmdUI* pCmdUI) 
{
	CHidemdiRootDoc*	pLRootDoc = pRootDoc() ;
	if ( pLRootDoc != NULL ){
		pCmdUI->DoUpdate( pLRootDoc , FALSE ) ;
			//[Attention]
			//	㏑ۑEOĕۑ̃R}h́A[ghLg
			//	Ϗ܂

			//[Attention]
			//	R}hOnUpdate...()𑼂̃R}h^[Qbg
			//	Ϗꍇ́ACCmdUi::DoUpdate() ĂяoĂB
			//
			//BOOL CCmdUI::DoUpdate(CCmdTarget* pTarget
			//					, BOOL bDisableIfNoHndler)
			//	  R}hOnUpdate...()\bhA
			//	wCCmdTargetIuWFNgɑ΂ČĂяo܂B
			//pTarget
			//	  OnUpdate...()\bhĂяo
			//	CCmdTargetIuWFNgw肵ĂB
			//bDisableIfNoHndler
			//	^ȂAďõR}hOnUpdate...()\bhȂꍇɁA
			//	̃R}h֎~ԂƂȂ܂B
	}
}

void CHidemdiApp::OnUpdateFileSaveAs(CCmdUI* pCmdUI) 
{
	CHidemdiRootDoc*	pLRootDoc = pRootDoc() ;
	if ( pLRootDoc != NULL ){
		pCmdUI->DoUpdate( pLRootDoc , FALSE ) ;
	}
}


BOOL CHidemdiApp::OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo)
{
	CHidemdiRootDoc* pCHidemdiRootDoc = pRootDoc() ;

	if ( pCHidemdiRootDoc != NULL )
	{
		if ( pCHidemdiRootDoc->OnCmdMsg( nID , nCode , pExtra , pHandlerInfo ) )
		{
			return TRUE ;
		}
	}

	return CWinApp::OnCmdMsg(nID, nCode, pExtra, pHandlerInfo);
}

} //namespace Hidemdi
} //namespace OuMfc

