/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CHidemdiApp.h
// ****************************************************************
*/
/** @file */
#ifndef  CHidemidApp_h
#define  CHidemidApp_h

#include <afxwin.h>

#include "CHidemdiRootDoctmpl.h"
#include "CHidemdiRootDoc.h" 

namespace OuMfc{
namespace Hidemdi{

// ****************************************************************
//	CHidemdiApp
// ****************************************************************
/** @brief
yTvz
 Hidemdi AvP[VɂAAvP[VNX̊{NXłB

 [gDoc/View̃ev[goƂĕێ܂B
 Hidemdi AvP[Vł́ÃNXpAhNX
InitInstance()  [gDoc/ViewETuDoc/View̃ev[g𐶐ȂĂ
Ȃ܂B[gDoc/View̃ev[ǵARegisterRootDoctmplŁAthis
o^ȂĂ͂Ȃ܂B
  ̃NX́A[gDoc/View̃ev[gEhLg擾
T[rX񋟂Ă܂B

  R}hbZ[ẂARootDocɈϏ܂B
*/
class CHidemdiApp : public CWinApp
{
// ********************************
//	]^
// ********************************
 public:
	typedef CWinApp	super ;

//--------------------------------
//	f[^o
//--------------------------------
 private:
	/**
		lNULLłB
		InitInstance() ŁARegisterRootDoctmpl()
		gāA[gDoc/View̃ev[gւ
		|C^o^܂B
	*/
	CHidemdiRootDoctmpl*	m_pdoctemplateRoot ;

//--------------------------------
//	֐
//--------------------------------
 protected:
	/**
		InitInstance() Doctemplate𐶐ƂɁA
		[gDoctemplateIuWFNg̃|C^Ã\bh
		o^ĂB
	*/
	virtual BOOL RegisterRootDoctmpl
								( CHidemdiRootDoctmpl* prootdoctemplateEv ) ;

// ********************************
//	CHidemdiTestApp
// ********************************
 public:
	/**
	@return
		[gDoc/View̃ev[gւ
		|C^Ԃ܂
	*/
	virtual CHidemdiRootDoctmpl*	pRootDoctmpl() ;

	/**
	@return
		[gDocւ̃|C^Ԃ܂
	*/
	virtual CHidemdiRootDoc*			pRootDoc() ;

	/**
		t@CAMRUXg폜܂
	@param lpszEFilename [in]
		폜t@CԂ܂
	@return
		폜Gg̐Ԃ܂
	*/
	virtual int RemoveFromRecentFileList( LPCTSTR lpszEFilename ) ;

//----------------------------------------------------------------
//	MFC
//----------------------------------------------------------------
public:
	CHidemdiApp();

// I[o[Ch
	// ClassWizard ͉z֐̃I[o[Ch𐶐܂B
	//{{AFX_VIRTUAL(CHidemdiApp)
	public:
	virtual BOOL InitInstance();
	//}}AFX_VIRTUAL
	
// Cve[V
	//{{AFX_MSG(CHidemdiApp)
	afx_msg void OnFileNew();
	afx_msg void OnFileSave();
	afx_msg void OnFileSaveAs();
	afx_msg void OnUpdateFileSave(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFileSaveAs(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
	virtual BOOL OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo);
};

} //namespace Hidemdi
} //namespace OuMfc

#endif /*CHidemdiApp_h*/


